<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn 
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * This file updates the database
 * @package Import
 */

if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * try it, it works sometimes
 */
ini_set("max_execution_time", "6000");


$array_meta = Array('exif','iptc','xmp');

if( isset($_POST['cmd']) && $_POST['cmd']=='import')
{
	echo '<h1 class="linStyle">'.i18n("Running Import...").'</h1>';
	
	if(!isset($_REQUEST['album_select']) OR $_REQUEST['album_select'][0]=='all')
	{
		$all_albums = true;
	}
	else
	{
		$all_albums = false;
	}


	/**
	 * import
	 */
	if($_REQUEST['index_import']=='index')
	{
		echo '<h2 class="linStyle">'.i18n("Directory Import").'</h2>';
		if($all_albums)
		{
			echo i18n("Parsing All Directories...").'<br />';
			LinImport::updateDir( $parent_id = 0, $recursive = true, $dryrun = false );
		}
		else
		{
			foreach($_REQUEST['album_select'] AS $key=>$value)
			{
				$data = $GLOBALS['linpha']->db->GetRow("SELECT name FROM ".LIN_PREFIX."photos WHERE id = '".LinSql::linAddslashes($value)."'");				
				echo i18n("Parsing Directory:").' '.$data['name'].'<br />';
				LinImport::updateDir( $parent_id = $value, $recursive = true, $dryrun = false );
			}
		}
	
		if( isset($GLOBALS['linpha']->template->output['sys_log']) )
		{
			echo $GLOBALS['linpha']->template->output['sys_log'];
			unset($GLOBALS['linpha']->template->output['sys_log']);
		}
		
		echo '<br />';
	}
	
	/**
	 * thumbnails
	 */
		/**
		 * @todo  should we create the folder thumbnails here?
		 * they will be automatically created on each visit
		 * we would have to take care to the script backwards,
		 * that means first of the depest subfolder until we're on top
		 */
	if($_REQUEST['index_thumbnails']!='no' OR isset($_REQUEST['index_thumbnails_delete']))
	{
		echo '<h2 class="linStyle">'.i18n("Thumbnails").'</h2>';

		$thumbnail = new LinImage();
		
		if($_REQUEST['index_thumbnails']=='recreate')
		{
			$_GET['force'] = true;
		}

		/**
		 * all albums selected
		 */
		if($all_albums)
		{
			/**
			 * delete thumbnails
			 */
			if( isset($_REQUEST['index_thumbnails_delete']) )
			{
				echo i18n("Delete All Existing Thumbnails...").'<br />';
				$thumbcachepath = LinSql::getPath('cache').'/thumb';
				LinFilesys::rm_rf( $thumbcachepath );	// all subfolders will automatically be 	recreated on each image access
				if(file_exists($thumbcachepath))
				{
					echo i18n("Warning while deleting file/folder, check permissions!").'<br />';
				}
				else
				{
					mkdir( $thumbcachepath );
				}
			}

			/**
			 * set query string for create/recreate thumbnails
			 */			
			if($_REQUEST['index_thumbnails']!='no')
			{
				echo '<h3>'.i18n("Parsing All Directories...").'</h3><br />';
				$createthumbquery = $GLOBALS['linpha']->db->Execute("SELECT id FROM ".LIN_PREFIX."photos WHERE img_type <> 0 AND img_type <> 9999999");
			}
		}
		else	// $all_albums == false -> not all directory selected
		{
			/**
			 * go through each selected directory
			 */
			foreach($_REQUEST['album_select'] AS $key=>$value)
			{
				$data = $GLOBALS['linpha']->db->GetRow("SELECT name FROM ".LIN_PREFIX."photos WHERE id = '".LinSql::linAddslashes($value)."'");				
				echo i18n("Parsing Directory:").' '.$data['name'].'<br />';

				$sql = "SELECT id FROM ".LIN_PREFIX."photos WHERE " .
						"parent_id = '".LinSql::linAddslashes($value)."' AND " .
						"img_type <> 0 AND img_type <> 9999999";

				/**
				 * delete thumbnails
				 */
				if( isset($_REQUEST['index_thumbnails_delete']) )
				{
					echo i18n("Delete Thumbnails");
					$query = $GLOBALS['linpha']->db->Execute($sql);
					while($data = $query->FetchRow(ADODB_FETCH_NUM))
					{
						if( LinImage::deleteCachedThumbnail($data[0]) )
						{
							echo " ".$data[0].",";
						}
					}
					echo '<br />';
				}

				/**
				 * set query string for create/recreate thumbnails
				 */
				if($_REQUEST['index_thumbnails']!='no')
				{
					$createthumbquery = $GLOBALS['linpha']->db->Execute($sql);
				}
			}
		}
		
		/**
		 * now create thumbnails, $query has been set previously
		 */
		if($_REQUEST['index_thumbnails']!='no')
		{
			echo i18n("Create Thumbnail");
			while($data = $createthumbquery->FetchRow(ADODB_FETCH_NUM))
			{
				if( ! $thumbnail->createThumbnail($data[0]) )
				{
					echo i18n("Error While Creating Thumbnail!")."<br />Error: ".$thumbnail->error_msg."<br />";
				}
				if( ! $thumbnail->isCached )	// thumbnail wasn't cached -> now created!
				{
					echo " ".$data[0].",";
				}
				flush();
			}
			echo '<br />';
		}
		
		echo '<br />';
	}


	/**
	 * exif, iptc, xmp
	 * 
	 * if "Delete First" and "All albums" was selected, the whole table will be deleted
	 */
	$MetaData = new MetaDataIndex();

	foreach($array_meta AS $meta_value)
	{
		if( isset( $_REQUEST['index_'.$meta_value] ) && 
			( $_REQUEST['index_'.$meta_value] == 'index' OR isset($_REQUEST['index_'.$meta_value.'_delete']) ) )
		{
			echo '<h2 class="linStyle">'.i18n("File Indexing").' ('.strtoupper($meta_value).')</h2>';

			/**
			 * get imgids to indexing, if reindex is selected: delete these entries first
			 */
			if($all_albums)
			{
				echo i18n("All Directories selected").'<br />';
	
				$query = $GLOBALS['linpha']->db->Execute("SELECT id, md5sum FROM ".LIN_PREFIX."photos WHERE img_type <> 0 AND img_type <> 9999999");
				while($data = $query->FetchRow())
				{
		        	$array_meta_ids[$data['id']] = $data['md5sum'];
				}
			}
			else
			{
				echo i18n("Directory selected:").' ';
				foreach($_REQUEST['album_select'] AS $key=>$value)
				{
					$data = $GLOBALS['linpha']->db->GetRow("SELECT name FROM ".LIN_PREFIX."photos WHERE id = '".LinSql::linAddslashes($value)."'");				
					echo $data['name'].', ';
	
					$query = $GLOBALS['linpha']->db->Execute("SELECT id, md5sum FROM ".LIN_PREFIX."photos WHERE " .
							"parent_id = '".LinSql::linAddslashes($value)."' AND " .
							"img_type <> 0 AND img_type <> 9999999");
					while($data = $query->FetchRow(ADODB_FETCH_NUM))
					{
			        	$array_meta_ids[$data['id']] = $data['md5sum'];
					}
				}
				echo '<br />';
			}

			/**
			 * delete first (if selected)
			 */
			if( isset($_REQUEST['index_'.$meta_value.'_delete']) )
			{
			   	if( $all_albums )
			   	{
			   		echo i18n("Delete all index data").'<br />';
			   		$GLOBALS['linpha']->db->Execute("DELETE FROM ".LIN_PREFIX."meta_".$meta_value);
			   	}
			   	elseif( isset($array_meta_ids) )
			   	{
			   		echo i18n("Delete index data of selected directories").'<br />';
			   		foreach($array_meta_ids AS $id=>$md5sum)
			   		{
			   			$GLOBALS['linpha']->db->Execute("DELETE FROM ".LIN_PREFIX."meta_".$meta_value." WHERE md5sum = '".$md5sum."'");
			   		}
			   	}
			}

			/**
			 * index image, parse all saved ids
			 */
			if( isset($array_meta_ids) && $_REQUEST['index_'.$meta_value] == 'index' )
			{
				echo i18n("Index Image");

				foreach($array_meta_ids AS $id=>$md5sum)
				{
			        $query = $GLOBALS['linpha']->db->Execute("SELECT md5sum ".
				            "FROM ".LIN_PREFIX."meta_exif WHERE md5sum = '".$md5sum."'");
				
			        if( $query->EOF) // not a single value returned
			        {
			            $full_filename = LinSql::getFullImagePath($id);
	
						switch($meta_value)
						{
						case 'exif':
				            $MetaData->saveData( 'exif', $full_filename,$md5sum );
						break;
						case 'iptc':
				            $MetaData->saveData( 'iptc', $full_filename,$md5sum );                    
						break;
						case 'xmp':
						break;
						}

						echo " ".$id.",";
						flush();	
			        }
				}

			}
			
			echo '<br /><br />';
		}
		unset($array_meta_ids);
	}
}


echo '<h1 class="linStyle">'.i18n("Import").'</h1>';
echo i18n("Select Folders For Import/Update:");
?>
<br />
<form action="./?cat=maintenance_import" method="POST">
<select name="album_select[]" size="10" multiple="multiple" style="width: 500px;">
<?php linBuildAlbumSelect($with_all_albs_entry=true); ?>
</select>
<br /><br />

<?php echo i18n("Import").':'; ?>
<br />

<input type="checkbox" id="index_import_detect_filechanges" name="force_update" value="true" /><label for="index_import_detect_filechanges"> <?php echo i18n("Detect File Changes"); ?></label><br />
<input type="radio" id="index_import_no" name="index_import" value="no" /><label for="index_import_no"> <?php echo i18n("No Import"); ?></label><br />
<input type="radio" id="index_import_index" name="index_import" value="index" checked="checked" /><label for="index_import_index"> <?php echo i18n("Import"); ?></label><br />
<br />

<?php echo i18n("Thumbnails").':'; ?>
<br />
<input type="checkbox" id="index_thumbnails_deletefirst" name="index_thumbnails_delete" value="delete" /><label for="index_thumbnails_deletefirst"> <?php echo i18n("Delete First"); ?></label><br />
<input type="radio" id="index_thumbnails_no" name="index_thumbnails" value="no" /><label for="index_thumbnails_no"> <?php echo i18n("No Create"); ?></label><br />
<input type="radio" id="index_thumbnails_index" name="index_thumbnails" value="create" checked="checked" /><label for="index_thumbnails_index"> <?php echo i18n("Create"); ?></label><br />
<input type="radio" id="index_thumbnails_reindex" name="index_thumbnails" value="recreate" /><label for="index_thumbnails_reindex"> <?php echo i18n("Re-create"); ?></label><br />
<br />

<?php
foreach($array_meta AS $value)
{
	if($GLOBALS['linpha']->sql->config->value['sys_image_'.$value])
	{
		echo strtoupper($value).":<br />";
		echo '<input type="checkbox" id="index_'.$value.'_deletefirst" name="index_'.$value.'_delete" value="delete" /><label for="index_'.$value.'_deletefirst"> '.i18n("Delete First").'</label><br />';
		echo '<input type="radio" id="index_'.$value.'_no" name="index_'.$value.'" value="no" /><label for="index_'.$value.'_no"> '.i18n("No indexing").'</label><br />';
		echo '<input type="radio" id="index_'.$value.'_index" name="index_'.$value.'" value="index" checked="checked" /><label for="index_'.$value.'_index"> '.i18n("Indexing").'</label><br />';
		echo '<br />';
	}
}

?>
<input type="hidden" name="cmd" value="import">
<input type="submit" name="submit" value="<?php echo i18n("Start"); ?>" />
</form>
<br /><br />
<?php


/**
 * dry-run
 */
echo '<h2 class="linStyle">'.i18n("Stuff Not Up-To-Date").'</h2>';

/**
 * import
 */
	if($linpha->sql->config->value['sys_import_autoimport'])
	{
		LinImport::updateDir( $parent_id = 0, $recursive = true, $dryrun = true );
	}

	/**
	 * flush buffer
	 */
	echo '<b>'.i18n("Following files/folders needs updating:").'</b><br />';
	if( isset($GLOBALS['linpha']->template->output['sys_log']) )
	{
		echo $GLOBALS['linpha']->template->output['sys_log'];
		unset($GLOBALS['linpha']->template->output['sys_log']);
	}
	else
	{
		echo i18n("Nothing, we're up-to-date!").'<br />';
	}
	
	echo '<br />';

/**
 * thumbnails
 */
	$thumbnail = new LinImage();

	$num = 0;
	$query = $GLOBALS['linpha']->db->Execute("SELECT id FROM ".LIN_PREFIX."photos WHERE img_type <> 0 AND img_type <> 9999999");
	while($data = $query->FetchRow(ADODB_FETCH_NUM))
	{

		$thumbnail->mode = 'thumb';
		$thumbnail->photo_id = $data[0];

		$thumbnail->setFileInformation();
		
		if( ! $thumbnail->isCached )
		{
			$num++;
		}
	}
	echo '<b>'.i18n("Nr Thumbnails To Create:").' '.$num.'<br />';

/**
 * exif, iptc, xmp
 * 
 * nr images to index: (nr_total - nr_indexed)
 */
	$nr_total = $GLOBALS['linpha']->db->GetRow("SELECT sum(stats_numbers) FROM ".LIN_PREFIX."photos WHERE parent_id = '0' GROUP BY parent_id");
	foreach($array_meta AS $value)
	{
		if($GLOBALS['linpha']->sql->config->value['sys_image_'.$value])
		{
			$nr_indexed = $GLOBALS['linpha']->db->GetRow("SELECT count(md5sum) FROM ".LIN_PREFIX."meta_".$value);

			echo strtoupper($value).': '.i18n("Nr Images Needs Indexing:").' ' . ($nr_total[0] - $nr_indexed[0]) .' <br />';
		}
	}
?>