<?php
if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * init
 */
	if(!isset($cat3))
	{
		$cat3 = 'own';
	}
	$array_field_types = Array(
		1 => 'text',
		2 => 'select',
		3 => 'date'
	);

/**
 * show subsubmenu
 */
	$array_menu = Array(
		'own' => Array('name' => 'Own fields', 'link' => 'metadata_define_own'),
		'adddata' => Array('name' => 'Add select data (set Category names)', 'link' => 'metadata_define_adddata'),
		'exif' => Array('name' => 'Exif fields', 'link' => 'metadata_define_exif'),
		'iptc' => Array('name' => 'Iptc fields', 'link' => 'metadata_define_iptc')	
	);
	
	LinAdmin::printAdminMenu($array_menu,$cat3);

/**
 * parse POST data
 */
if(isset($_POST['cmd'])) {
	include_once(LINPHA_DIR.'/admin/metadata_define_post.php');
}

switch($cat3)
{
case 'own':
	show_own_fields();
	break;
case 'adddata':
	show_add_data();
	break;
case 'exif':
	echo i18n("The exif data are normally automatically created by the digital camera. These values may not be edited whitin LinPHA.");
	echo '<br /><br />';
	echo i18n("You probably may not choose all exif tags, because the database table would get to big.");
	echo '<br /><br /><br />';
	show_exif_iptc();
	break;
case 'iptc':
case 'xmp':
	echo i18n("The iptc/xmp data are normally not created by default. They need to be filled in within LinPHA or with an external program like photoshop. The iptc/xmp tags are very common in the photographer industry.");
	echo '<br /><br />';
	show_exif_iptc();
	break;
}

function show_own_fields()
{
	?>
	<h3>Built-in fields</h3>
	<form name="builtin" action="./?cat=metadata_define_own" method="POST">
	<table border="0" width="400">
		<tr>
			<td><b>Field name</b></td>
			<td><b>Type</b></td>
			<td><b>Enable</b></td>
			<td><b>Disable</b></td>
		</tr>
	
	<?php
	/**
	 * get builtin fields
	 */
	$query = $GLOBALS['linpha']->db->Execute("SELECT id, name, field_type, flags " .
			"FROM ".LIN_PREFIX."meta_fields " .
			"WHERE flags = '5' OR flags = '6' ");
			
	while($data = $query->FetchRow())
	{
		echo '<tr><td>';
		echo $data['name'];
		echo '</td><td>';
		echo $GLOBALS['array_field_types'][$data['field_type']];
		echo '</td><td>';
		
		echo '<input type="radio" name="builtin['.$data['id'].']" value="1"'. ( $data['flags']==5 ? ' checked="checked"' : '') .' />';
		echo '</td><td>';
		echo '<input type="radio" name="builtin['.$data['id'].']" value="0"'. ( $data['flags']==6 ? ' checked="checked"' : '') .' />';
  		echo '</td></tr>';
	}

	?>
	</table>
	
	<input type="hidden" name="cmd" value="update_builtin" />
	<input type="submit" name="submit" value="submit" />
	</form>
	<br />
	
	
	<h3>Add new own fields</h3>
	<form name="addnew" action="./?cat=metadata_define_own" method="POST">
	<table border="0">
		<tr>
			<td width="100">Name</td>
			<td><input type="text" name="new_name" value="" maxlength="255" style="width: 200px;" /></td>
		</tr>
		<tr>
			<td>Type</td>
			<td>
				<select name="new_type" style="width: 200px;" >
				<?php
				foreach($GLOBALS['array_field_types'] AS $key=>$value)
				{
					echo '<option value="'.$key.'">'.$value.'</option>';
				}
				?>
				</select>
			</td>
		</tr>
	</table>
	<input type="hidden" name="cmd" value="add_new" />
	<input type="submit" name="submit" value="add new"/>
	</form>
	<br />
	
	<?php
	/**
	 * get own fields
	 */
	$query = $GLOBALS['linpha']->db->Execute("SELECT id, name, field_type, flags " .
			"FROM ".LIN_PREFIX."meta_fields " .
					"WHERE flags = '7' " .
					"OR flags = '8'");

	if( ! $query->EOF )
	{
		?>
		<h3>Own fields</h3>
		<form name="builtin" action="./?cat=metadata_define_own" method="POST">
		<table border="0">
			<tr>
				<td width="170"><b>Field name</b></td>
				<td width="150"><b>Type</b></td>
				<td width="70"><b>Enable</b></td>
				<td width="100"><b>Disable</b></td>
				<td><b>Commands</b></td>
				<td>&nbsp;</td>
			</tr>
		
		<?php
		while($data = $query->FetchRow())
		{
			?>
			<tr>
  				<form action="./?cat=metadata_define_own" method="POST">
				<td>
					<input type="text" name="new_name" value="<?php echo $data['name']; ?>" style="width: 150px;" maxlength="255" />
				</td>
				<td><?php echo $GLOBALS['array_field_types'][$data['field_type']]; ?></td>
				<td>
					<?php
					echo '<input type="radio" name="builtin['.$data['id'].']" value="1"'. ( $data['flags']==7 ? ' checked="checked"' : '') .' />';
					?>
				</td>
				<td>
					<?php
					echo '<input type="radio" name="builtin['.$data['id'].']" value="0"'. ( $data['flags']==8 ? ' checked="checked"' : '') .' />';
					?>
				</td>
				<td>
	  				<input type="hidden" name="cmd" value="change_field" />
	  				<input type="hidden" name="id" value="<?php echo $data['id']; ?>" />
	  				<input type="submit" name="rename" value="submit" />
				</td>
				</form>
				<td>
	  				<form action="./?cat=metadata_define_own" method="POST">
	  				<input type="hidden" name="cmd" value="delete" />
	  				<input type="hidden" name="id" value="<?php echo $data['id']; ?>" />
	  				<input type="submit" name="delete" value="delete" />
	  				</form>
				</td>
			</tr>
			<?php
		}
	
		?>
		</table>
		</form>
		<?php
	}
}

function show_add_data()
{
	$query = $GLOBALS['linpha']->db->Execute("SELECT id, name FROM ".LIN_PREFIX."meta_fields WHERE field_type = '2'");
	while($data = $query->FetchRow())
	{
		?>
		<h3><?php echo i18n( ucfirst( $data['name'] ) ); ?></h3>
		<table border="0">
			<tr>
				<td width="170"><b><?php echo i18n("Name"); ?></b></td>
				<td width="150"><b><?php echo i18n("Private"); echo ' <span title="'.i18n("not visible in the search page by the normal user").'">(Info)</span>'; ?></b></td>
				<td><b>Commands</b></td>
				<td>&nbsp;</td>
			</tr>
		<?php
		$query2 = $GLOBALS['linpha']->db->Execute("SELECT id, name, isprivate FROM ".LIN_PREFIX."meta_category WHERE field_id = '".$data['id']."'");
		while($data2 = $query2->FetchRow())
		{
			?>
			<tr>
				<form action="./?cat=metadata_define_adddata" method="POST">
				<td>
					<input type="text" name="new_name" value="<?php echo $data2['name']; ?>" />
				</td>
				<td>
					<input type="checkbox" name="isprivate" value="true"<?php echo ($data2['isprivate'] ? ' checked="checked"' : ''); ?> />
				</td>
				<td>
					<input type="hidden" name="cmd" value="mod_category" />
					<input type="hidden" name="id" value="<?php echo $data2['id']; ?>" />
					<input type="submit" name="submit" value="Submit" />
				</td>
				</form>
				<td>
					<form action="./?cat=metadata_define_adddata" method="POST">
					<input type="hidden" name="cmd" value="delete_category" />
					<input type="hidden" name="id" value="<?php echo $data2['id']; ?>" />
					<input type="submit" name="delete" value="delete" />
					</form>
				</td>
			</tr>
			<?php		
		}
		?>
			<tr>
				<form action="./?cat=metadata_define_adddata" method="POST">
				<td>
					<input type="text" name="new_name" value="" />
				</td>
				<td>
					<input type="checkbox" name="isprivate" value="1" />
				</td>
				<td>
					<input type="hidden" name="field_id" value="<?php echo $data['id']; ?>" />
					<input type="hidden" name="cmd" value="add_new_category" />
					<input type="submit" name="submit" value="Add new" />
				</td>
				<td>&nbsp;</td>
				</form>
			</tr>  
		</table>
		<?php
	}
}

function show_exif_iptc()
{
	$MetaData = new LinMetaDataAdmin();
	$MetaData->setFields( $GLOBALS['cat3'] );
	
	/**
	 * get enabled/disabled setting
	 */
	$enabled = $GLOBALS['linpha']->sql->config->value['sys_image_'.$GLOBALS['cat3']];
?>

	<div align="center">
	<form action="./?cat=metadata_define_<?php echo $GLOBALS['cat3']; ?>" method="POST">
	<input type="radio" name="exifiptc_enable" value="1"<?php echo ($enabled ? ' checked="checked"' : ''); ?> />Enable
	<input type="radio" name="exifiptc_enable" value="0"<?php echo ($enabled ? '' : ' checked="checked"'); ?> />Disable
	<input type="hidden" name="cmd" value="update_exifiptc" />
	<input type="submit" name="name" value="update" />
	</form>
	<br /><br />

	<form action="./?cat=metadata_define_<?php echo $GLOBALS['cat3']; ?>" method="POST" onsubmit="selectAll()">
	<table border="0">
		<tr>
			<td valign="top" rowspan="3" align="center">
				Selected fields<br />
				<select id="selected_fields" name="selected_fields[]" size="25" style="width: 200px;" multiple="multiple">
				<?php
				foreach($MetaData->defined_fields[$GLOBALS['cat3']] AS $key=>$value)
				{
					echo '<option value="'.$key.'">'.$value.'</option>'."\n";
				}
				?>
				</select>
				<br />
			</td>
			<td>
				<input type="button" name="shiftleft" value="&lt;" onclick="addElement()" />
				<br />
				<input type="button" name="shiftright" value="&gt;" onclick="removeElement()" />
			</td>
			<td valign="top">
				Available fields<br />
				<select id="all_fields" name="builtin_fields" size="25" style="width: 200px;">
				<?php
				foreach($MetaData->available_fields[$GLOBALS['cat3']] AS $key=>$value)
				{
					echo '<option value="'.$key.'">'.$value.'</option>';
				}
				?>
				</select>
			</td>
		</tr>
	</table>
	<input type="hidden" name="cmd" value="create_exifiptc" />
	<input type="submit" name="name" value="Submit" />
	</form>

	</div>

	<script type="text/javascript">
	/**
	 * http://www.babailiica.com/js/sorter/
	 */
	
	function selectAll()
	{
		obj = document.getElementById('selected_fields');
		for (var i=0; i<obj.length; i++) {
			obj[i].selected = true;
		}
	}
	
	function addElement ()
	{
		obj_from = document.getElementById('all_fields');
		obj_to = document.getElementById('selected_fields');
		
		moveElement(obj_from, obj_to);
	}

	function removeElement ()
	{
		obj_from = document.getElementById('selected_fields');
		obj_to = document.getElementById('all_fields');
		
		moveElement(obj_from, obj_to);
	}

	function moveElement(obj_from, obj_to)
	{
		if(obj_from.selectedIndex != -1)
		{
			old_index = obj_from.selectedIndex;
			
			NewEntry = new Option( obj_from.options[ obj_from.selectedIndex ].text, obj_from.options[ obj_from.selectedIndex ].value, false, true );
			obj_to.options[ obj_to.options.length] = NewEntry;

			obj_from.options[ obj_from.selectedIndex ] = null;
	
			/**
			 * set selectedIndex back to field above
			 */
			obj_to.selectedIndex = obj_to.length - 1;
			
			if( obj_from.selectedIndex == obj_from.length )
			{
				obj_from.selectedIndex = obj_from.selectedIndex - 1;
			}
			else
			{
				obj_from.selectedIndex = old_index;
			}
		}
		else
		{
			alert('nothing selected');
		}
	}
	
	</script>
	<?php
}

?>