<?php
if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * @package admin
 * @subpackage metadata
 * 
 * for a description of the table structure, flag nr etc. see in the developper wiki at
 * http://linpha.sourceforge.net/wiki/index.php/Tables_linpha_meta_fields
 */

if(!isset($cat3))
{
	$cat3 = 'image';
}

$array_menu = Array(
	'image' => Array('name' => 'Image', 'link' => 'metadata_select_image'),
	'slideshow' => Array('name' => 'Slideshow', 'link' => 'metadata_select_slideshow'),
	'thumb' => Array('name' => 'Thumbnail', 'link' => 'metadata_select_thumb'),
	'thumbdetail' => Array('name' => 'Thumbnail Detail View', 'link' => 'metadata_select_thumbdetail'),
	'video' => Array('name' => 'Video', 'link' => 'metadata_select_video'),
	'album' => Array('name' => 'Album', 'link' => 'metadata_select_album')	
);

LinAdmin::printAdminMenu($array_menu,$cat3);

switch($cat3)
{
case 'image':
	printFieldsTable(10);
	break;
case 'slideshow':
	printFieldsTable(15);
	break;
case 'thumb':
	printFieldsTable(13);
	break;
case 'thumbdetail':
	printFieldsTable(14);
	break;
case 'video':
	printFieldsTable(11);
	break;
case 'album':
	printFieldsTable(12);
	break;
}



function printFieldsTable($flag_nr)
{
	if(isset($_POST['cmd']) && $_POST['cmd']=='select_image_fields')
	{
		/**
		 * delete all existing entries in database
		 */
		$GLOBALS['linpha']->db->Execute("DELETE FROM ".LIN_PREFIX."meta_fields WHERE flags = '".$flag_nr."'");
		
		/**
		 * write new entrys
		 */
		if(isset($_POST['select_image_fields']))
		{
			foreach($_POST['select_image_fields'] AS $value)
			{
				$GLOBALS['linpha']->db->Execute("INSERT into ".LIN_PREFIX."meta_fields (name, flags)" .
					" VALUES ('".LinSql::linAddslashes($value)."','".$flag_nr."')");
			}
		}
	}

	/**
	 * set exif/iptc fields
	 */
	$MetaData = new LinMetaDataAdmin();
?>
	<form name="form_image_fields" method="POST" onsubmit="selectAll()">
	<div align="center">
	<table border="0">
		<tr>
			<td valign="top" rowspan="4" align="center">
				Selected fields<br />
				<select id="select_image_fields" name="select_image_fields[]" size="25" style="width: 200px;" multiple="multiple">
				<?php
				$query = $GLOBALS['linpha']->db->Execute("SELECT id, name FROM ".LIN_PREFIX."meta_fields WHERE flags = '".$flag_nr."' ORDER by id");
				while($data = $query->FetchRow())
				{
					echo '<option value="'.$data['name'].'">'.$MetaData->getNameOfField($data['name'],true).'</option>';
				}
				?>
				</select>
				<br />
				<input type="button" name="shift_up" value="^" onclick="moveupElement()" />
				<input type="button" name="shift_down" value="v" onclick="movedownElement()" />
				<br /><br />
				<input type="button" name="remove" value="delete selected" onclick="deleteElement()" />
				<br /><br />
				<input type="text" name="title_name" value="" /><br />
				<input type="button" name="add_title" value="add title" onclick="addElement()" />
			</td>
			<td>
				<input type="button" name="builtin_shiftleft" value="&lt;" onclick="copyElement('image_fields')" />
			</td>
			<td>
				Image fields (builtin)<br />
				<select id="image_fields" name="image_fields" size="7" style="width: 200px;">
				<?php
				$query = $GLOBALS['linpha']->db->Execute("SELECT id, name FROM ".LIN_PREFIX."meta_fields " .
					"WHERE flags = '1' OR flags = '5'");
				while($data = $query->FetchRow())
				{
					echo '<option value="builtin_'.$data['name'].'">'.i18n( ucfirst( $data['name'] ) ).'</option>';
				}
				?>
				</select>
			</td>
		</tr>
		<tr>
			<td>
				<input type="button" name="own_shiftleft" value="&lt;" onclick="copyElement('own_fields')" />
			</td>
			<td>
				Image fields (own) (<a href="./?cat=metadata_define_own">define</a>)<br />
				<select id="own_fields" name="own_fields" size="7" style="width: 200px;">
				<?php
				$query = $GLOBALS['linpha']->db->Execute("SELECT id, name FROM ".LIN_PREFIX."meta_fields " .
					"WHERE flags = '7'");
				while($data = $query->FetchRow())
				{
					echo '<option value="id_'.$data['id'].'">'.$data['name'].'</option>';
				}
				?>
				</select>
			</td>
		</tr>
		<?php
		if($flag_nr != 11 && $flag_nr != 12)
		{
		?>
		<tr>
			<td>
				<input type="button" name="exif_shiftleft" value="&lt;" onclick="copyElement('exif_fields')" />
			</td>
			<td>
				Exif fields (<a href="./?cat=metadata_define_exif">define</a>)<br />
				<?php
				if($GLOBALS['linpha']->sql->config->value['sys_image_exif']) {
					$str_disabled = '';
				} else {
					$str_disabled = ' disabled="disabled"';
				}
				?>
				<select id="exif_fields" name="exif_fields" size="7" style="width: 200px;"<?php echo $str_disabled; ?>>
				<?php
				$MetaData->setFields('exif');
				foreach($MetaData->defined_fields['exif'] AS $key=>$value)
				{
					echo '<option value="exif_'.$key.'">'.$value.'</option>';
				}
				?>
				</select>
			</td>
		</tr>
		<tr>
			<td>
				<input type="button" name="iptc_shiftleft" value="&lt;" onclick="copyElement('iptc_fields')" />
			</td>
			<td>
				IPTC fields (<a href="./?cat=metadata_define_iptc">define</a>)<br />
				<?php
				if($GLOBALS['linpha']->sql->config->value['sys_image_iptc']) {
					$str_disabled = '';
				} else {
					$str_disabled = ' disabled="disabled"';
				}
				?>
				<select id="iptc_fields" name="iptc_fields" size="7" style="width: 200px;"<?php echo $str_disabled; ?>>
				<?php
				$MetaData->setFields('iptc');
				foreach($MetaData->defined_fields['iptc'] AS $key=>$value)
				{
					echo '<option value="iptc_'.$key.'">'.$value.'</option>';
				}
				?>
				</select>
			</td>
		</tr>
		<?php
		}
		else
		{
			echo '<tr><td height="100"></td><td></td></tr><tr><td height="100"></td><td></td></tr>';
		}
		?>
	</table>
	<br />
	<input type="hidden" name="cmd" value="select_image_fields" />
	<input type="submit" name="submit" value="submit" />

	</div>
	</form>

	<script type="text/javascript">
	/**
	 * http://www.babailiica.com/js/sorter/
	 */
	
	function selectAll()
	{
		obj = document.getElementById('select_image_fields');
		for (var i=0; i<obj.length; i++) {
			obj[i].selected = true;
		}
	}
	
	
	function copyElement (coming_from)
	{
		obj_from = document.getElementById(coming_from);
		obj = document.getElementById('select_image_fields');
		
		NewEntry = new Option( obj_from.options[ obj_from.selectedIndex ].text, obj_from.options[ obj_from.selectedIndex ].value, false, true );
		obj.options[ obj.options.length ] = NewEntry;
		
		/**
		 * append ' (exif)' and ' (iptc)'
		 */
		if(coming_from=='exif_fields')
		{
			obj.options[ obj.options.length-1 ].text = obj.options[ obj.options.length-1 ].text + ' (exif)';
		}
		if(coming_from=='iptc_fields')
		{
			obj.options[ obj.options.length-1 ].text = obj.options[ obj.options.length-1 ].text + ' (iptc)';
		}
	
		
		/**
		 * remove new selection on left side
		 */
		obj.options[ obj.options.length-1 ].selected = false;
	}
	
	function addElement ()
	{
	  obj = document.getElementById('select_image_fields');
	  
	  NewEntry = new Option( document.form_image_fields.title_name.value, document.form_image_fields.title_name.value, false, true );
	  NewEntry.className = "linSelectOptionTitle";
	  obj.options[obj.options.length] = NewEntry;
	  document.form_image_fields.title_name.value = "";
	}
	
	function deleteElement ()
	{
		obj = document.getElementById('select_image_fields');
		
		current_index = obj.selectedIndex;
		obj.options[ current_index ] = null;
	
		/**
		 * set selectedIndex back to field above
		 */
		if( current_index == obj.length )
		{
			obj.selectedIndex = current_index - 1;
		}
		else
		{
			obj.selectedIndex = current_index;
		}
	}
	
	function moveupElement ()
	{
		obj = document.getElementById('select_image_fields');
		
		current_index = obj.selectedIndex;
		if( current_index != 0 )
		{
			/**
			 * swap entries
			 */
			tmp_value = obj.options[ current_index ].value;
			tmp_text = obj.options[ current_index ].text;
			tmp_class = obj.options[ current_index ].className;
			
			obj.options[ current_index ].value = obj.options[ current_index - 1].value;
			obj.options[ current_index ].text = obj.options[ current_index - 1].text;
			obj.options[ current_index ].className = obj.options[ current_index - 1].className;
	
			obj.options[ current_index - 1].value = tmp_value;
			obj.options[ current_index - 1].text = tmp_text;
			obj.options[ current_index - 1].className = tmp_class;
			
			/**
			 * set selectedIndex back to swapped field
			 */
			obj.selectedIndex = current_index - 1;
		}
	}
	
	function movedownElement ()
	{
		obj = document.getElementById('select_image_fields');
		
		current_index = obj.selectedIndex;
	
		if( current_index != ( obj.length - 1 ) )
		{
			/**
			 * swap entries
			 */
			tmp_value = obj.options[ current_index ].value;
			tmp_text = obj.options[ current_index ].text;
			tmp_class = obj.options[ current_index ].className;
			
			obj.options[ current_index ].value = obj.options[ current_index + 1].value;
			obj.options[ current_index ].text = obj.options[ current_index + 1].text;
			obj.options[ current_index ].className = obj.options[ current_index + 1].className;
	
			obj.options[ current_index + 1].value = tmp_value;
			obj.options[ current_index + 1].text = tmp_text;
			obj.options[ current_index + 1].className = tmp_class;
			
			/**
			 * set selectedIndex back to swapped field
			 */
			obj.selectedIndex = current_index + 1;
		}
	}
	</script>
<?php
}
?>