<?php
if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * save data
 */
if(isset($_POST['cmd']))
{
	try
	{
		
	switch($_POST['cmd'])
	{
	case 'mod_user':

		/**
		 * check if username is empty
		 */
		if( empty($_POST['mod_user_name']) )
		{
			throw new Exception(i18n("The username may not be empty."));
		}

		/**
		 * check if username already exists
		 * (only if it will be changed)
		 */
		if( $_POST['old_user_name'] != $_POST['mod_user_name'] )
		{
			$query = $GLOBALS['linpha']->db->Execute("SELECT username FROM ".LIN_PREFIX."users " .
				"WHERE username = '".LinSql::linAddslashes($_POST['mod_user_name'])."'");
			if( ! $query->EOF )
			{
				throw new Exception(i18n("A user with the same username already exists."));
			}
		}

		/**
		 * check length of new password
		 * (if strlen() == 0, the password isn't updated at all)
		 */
		if( strlen($_POST['mod_user_pass'])>0 && strlen($_POST['mod_user_pass'])<3 )
		{
			throw new Exception(i18n("Password To Short"));
		}

       /**
        * update password
        * only if it is not empty
        */
		if(empty($_POST['mod_user_pass']))
		{
			$sql_str_new_password = "";
		} else {
            $md5_pass = md5($_POST['mod_user_pass']);
			$sql_str_new_password = "password='".$md5_pass."', ";
		}

		$GLOBALS['linpha']->db->Execute("UPDATE ".LIN_PREFIX."users SET ".
								"username='".LinSql::linAddslashes($_POST['mod_user_name'])."', ".
								"display_name='".LinSql::linAddslashes($_POST['mod_user_fullname'])."', ".
								$sql_str_new_password.
								"user_email='".LinSql::linAddslashes($_POST['mod_user_mail'])."' ".
								"WHERE id='".LinSql::linAddslashes($_POST['id'])."'");

		/**
        * if current account is changed update session variables and login cookie
        */
		if($_POST['old_user_name'] == $_SESSION['user_name'])
		{
            $_SESSION['user_name'] = $_POST['mod_user_name'];
            $_SESSION['user_displayname'] = (empty($_POST['mod_user_fullname'])) ? $_POST['mod_user_name'] : $_POST['mod_user_fullname'];  //Store user fullname. If fullname is blank - store username.
            
            /**
             * does not work, because headers are already sent
             *  
            if(isset($_COOKIE['linpha_userid']) &&
                isset($_COOKIE['linpha_password']) &&
                isset($md5_pass))
            {
                $GLOBALS['linpha']->sql->setLinphaCookie($_POST['id'], $md5_pass);
            }*/
		}

		break;
	case 'del_user':
		$GLOBALS['linpha']->db->Execute("DELETE FROM ".LIN_PREFIX."users WHERE id='".LinSql::linAddslashes($_POST['id'])."'");
		break;
	case 'new_user':

		/**
		 * check if username is empty
		 */
		if( empty($_POST['new_user_name']) )
		{
			throw new Exception(i18n("The username may not be empty."));
		}

		/**
		 * check if username already exists
		 */
		$query = $GLOBALS['linpha']->db->Execute("SELECT username FROM ".LIN_PREFIX."users " .
			"WHERE username = '".LinSql::linAddslashes($_POST['new_user_name'])."'");
		if( ! $query->EOF )
		{
			throw new Exception(i18n("A user with the same username already exists."));
		}

		/**
		 * check length of new password
		 */
		if( strlen($_POST['new_user_pass'])<3 )
		{
			throw new Exception(i18n("Password To Short"));
		}

		$GLOBALS['linpha']->db->Execute("INSERT INTO ".LIN_PREFIX."users " .
			"(username, password, user_email, display_name) ".
			"VALUES " .
			"('".LinSql::linAddslashes($_POST['new_user_name'])."', '".md5($_POST['new_user_pass'])."', ".
			"'".LinSql::linAddslashes($_POST['new_user_mail'])."', '".LinSql::linAddslashes($_POST['new_user_fullname'])."')");
		break;
	}
	}
	catch(Exception $error)
	{
		linSysLog("Error: ".$error -> getMessage());
	}
}
?>        
<table border="1">
	<tr>
		<td><b><?php echo i18n("Username"); ?></b></td>
		<td><b><?php echo i18n("Display Name"); ?></b></td>
		<td><b><?php echo i18n("Password"); ?></b></td>
		<td><b><?php echo i18n("Email"); ?></b></td>
		<td><b><?php echo i18n("Actions"); ?></b></td>
	</tr>
<?php
    /**
    * show users
    */
    $query = $GLOBALS['linpha']->db->Execute("SELECT id, username, display_name, user_email FROM ".LIN_PREFIX."users ORDER BY username");
	while($data = $query->FetchRow())
	{
        ?>
	    <tr>
	        <form name="mod_user" method="POST" action="<?php echo LINPHA_DIR.'/admin/?cat=permissions_users'; ?>">
	        <td>
	            <input type="text" name="mod_user_name" size="20" maxlength="255" value="<?php echo htmlspecialchars($data['username'], ENT_QUOTES); ?>">
	        </td>
		    <td>
		        <input type="text" name="mod_user_fullname" size="20" maxlength="255" value="<?php echo htmlspecialchars($data['display_name'], ENT_QUOTES); ?>">
		    </td>
            <td>
                <input type="password" name="mod_user_pass" size="20" maxlength="255">
            </td>
		    <td>
		        <input type="text" name="mod_user_mail" size="20" maxlength="255" value="<?php echo $data['user_email']; ?>">
		    </td>
            <td>
                <input type="hidden" name="id" value="<?php echo $data['id']; ?>">
                <input type="hidden" name="old_user_name" value="<?php echo htmlspecialchars($data['username'], ENT_QUOTES); ?>">
				<input type="hidden" name="cmd" value="mod_user">
                <input type="submit" value="<?php echo i18n("Modify User"); ?>" style="float: left;">
	            </form>

	           	<form name="edit_groups" method="POST" action="<?php echo LINPHA_DIR.'/admin/?cat=permissions_usergroup&amp;edit=user&amp;linId='.$data['id']; ?>">
                <input type="submit" name="edit_groups" value="<?php echo i18n("Edit Groups"); ?>" style="float: left;">
                </form>

                <form name="del_user" method="POST" action="<?php echo LINPHA_DIR.'/admin/?cat=permissions_users'; ?>">
                <input type="hidden" name="id" value="<?php echo $data['id']; ?>">
                <input type="hidden" name="cmd" value="del_user">
                <input type="submit" value="<?php echo i18n("Delete"); ?>" style="float: left;">
                </form>
            </td>
        </tr>
        <?php
	}

	/**
	 * add new user
	 */
	?>
	<form name="new_user" method="POST" action="<?php echo LINPHA_DIR.'/admin/?cat=permissions_users'; ?>">
		<tr>
			<td><input type="text" name="new_user_name" size="20" maxlength="255"></td>
			<td><input type="text" name="new_user_fullname" size="20" maxlength="255"></td>
			<td><input type="password" name="new_user_pass" size="20" maxlength="255"></td>
			<td><input type="text" name="new_user_mail" size="20" maxlength="255"></td>
			<td>
				<input type="hidden" name="cmd" value="new_user">
				<input type="submit" value="<?php echo i18n("Create User"); ?>" onclick="return checkPassLength();">
			</td>
		</tr>
	</form>
</table>

<script language="JavaScript" type="text/javascript">
function checkPassLength()
{
	if(document.new_user.new_user_pass.value.length <3  )
	{
		alert ('<?php echo i18n("Password To Short"); ?>');
		document.new_user.new_user_pass.focus();
		return false;
	}
}
</script>