<?php
if(!defined('LINPHA_DIR')) { exit(1); }

if(!isset($cat3))
{
	$cat3 = 'general';
}

$array_menu = Array(
	'general' => Array('name' => 'General', 'link' => 'settings_layout_general'),
	'home' => Array('name' => 'Home Site', 'link' => 'settings_layout_home'),
	'thumb' => Array('name' => 'Thumb View', 'link' => 'settings_layout_thumb'),
	'image' => Array('name' => 'Image View', 'link' => 'settings_layout_image'),
	'others' => Array('name' => 'Others', 'link' => 'settings_layout_others')
);

LinAdmin::printAdminMenu($array_menu,$cat3);
?>

<form method="POST" action="<?php echo LINPHA_DIR.'/admin/?cat=settings_layout_'.$cat3; ?>">
<?php
  
switch($cat3)
{
case 'general':

	$color_examples = array(
		'' => '',
		'blue' => 'blue',
		'orange' => 'orange'
	);
	
	$color_examples_values = array(
		'blue' => array(
			'bodybg' => 'DDDDDD',
			'elembg' => '87CEFA',
			'font' => '000000',
			'albumsbg' => 'D5FCF4',
			'links' => '005388',
			'linkshover' => '666666',
		),
		'orange' => array(
			'bodybg' => 'FFFFFF',
			'elembg' => 'F09000',
			'font' => '000000',
			'albumsbg' => '94580A',
			'links' => '3d3b33',
			'linkshover' => '555453',
		)
	);

	if(isset($_POST['cmd']) && $_POST['cmd']=='saveconfig')
	{
		if( isset($_POST['select_examples']) && !empty($_POST['select_examples']) && in_array($_POST['select_examples'],$color_examples) )
		{
			$_POST['sys_style_layout_color_bodybg'] = $color_examples_values[ $_POST['select_examples'] ]['bodybg'];
			$_POST['sys_style_layout_color_elembg'] = $color_examples_values[ $_POST['select_examples'] ]['elembg'];
			$_POST['sys_style_layout_color_font'] = $color_examples_values[ $_POST['select_examples'] ]['font'];
			$_POST['sys_style_layout_color_albumsbg'] = $color_examples_values[ $_POST['select_examples'] ]['albumsbg'];
			$_POST['sys_style_layout_color_links'] = $color_examples_values[ $_POST['select_examples'] ]['links'];
			$_POST['sys_style_layout_color_linkshover'] = $color_examples_values[ $_POST['select_examples'] ]['linkshover'];			
		}
		else
		{
			include_once(LINPHA_DIR.'/lib/plugins/watermark/func.watermark.php');
			$_POST['sys_style_layout_color_bodybg'] = LinWatermark::getHtmlFromAll($_POST['sys_style_layout_color_bodybg']);
			$_POST['sys_style_layout_color_elembg'] = LinWatermark::getHtmlFromAll($_POST['sys_style_layout_color_elembg']);
			$_POST['sys_style_layout_color_font'] = LinWatermark::getHtmlFromAll($_POST['sys_style_layout_color_font']);
			$_POST['sys_style_layout_color_albumsbg'] = LinWatermark::getHtmlFromAll($_POST['sys_style_layout_color_albumsbg']);
			$_POST['sys_style_layout_color_links'] = LinWatermark::getHtmlFromAll($_POST['sys_style_layout_color_links']);
			$_POST['sys_style_layout_color_linkshover'] = LinWatermark::getHtmlFromAll($_POST['sys_style_layout_color_linkshover']);			
		}
		
		$LinAdmin->saveConfig(Array(
			'sys_style_layout_title',
			'sys_style_layout_template',
			'sys_style_layout_theme',
			'sys_style_layout_color_bodybg',
			'sys_style_layout_color_elembg',
			'sys_style_layout_color_font',
			'sys_style_layout_color_albumsbg',
			'sys_style_layout_color_links',
			'sys_style_layout_color_linkshover',
		));
	}
	
	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_layout_title'),'sys_style_layout_title',$LinAdmin->option_value_system['sys_style_layout_title']);
	$LinAdmin->printAdminConfig('select',$LinAdmin->getDescriptionByOptionName('sys_style_layout_template'),'sys_style_layout_template',$LinAdmin->option_value_system['sys_style_layout_template'],array('options' => LinAdmin::getTemplates()));
	$LinAdmin->printAdminConfig('select',$LinAdmin->getDescriptionByOptionName('sys_style_layout_theme'),'sys_style_layout_theme',$LinAdmin->option_value_system['sys_style_layout_theme'],array('options' => LinAdmin::getThemes($LinAdmin->option_value_system['sys_style_layout_template'])));


	echo '<h2 class="linStyle">'.i18n("Colors").'</h2>';
	?>
	<script language="JavaScript" type="text/javascript">
	function updateSelectBox(form_select)
	{
		if( form_select.options[ form_select.selectedIndex ].text == '')	// enable
		{
			document.getElementsByName('sys_style_layout_color_bodybg')[0].disabled = false;
			document.getElementsByName('sys_style_layout_color_elembg')[0].disabled = false;
			document.getElementsByName('sys_style_layout_color_font')[0].disabled = false;
			document.getElementsByName('sys_style_layout_color_albumsbg')[0].disabled = false;
			document.getElementsByName('sys_style_layout_color_links')[0].disabled = false;
			document.getElementsByName('sys_style_layout_color_linkshover')[0].disabled = false;
		}
		else	// disable
		{
			document.getElementsByName('sys_style_layout_color_bodybg')[0].disabled = true;
			document.getElementsByName('sys_style_layout_color_elembg')[0].disabled = true;
			document.getElementsByName('sys_style_layout_color_font')[0].disabled = true;
			document.getElementsByName('sys_style_layout_color_albumsbg')[0].disabled = true;
			document.getElementsByName('sys_style_layout_color_links')[0].disabled = true;
			document.getElementsByName('sys_style_layout_color_linkshover')[0].disabled = true;
		}
	}
	</script>
	<?php
	$options = array('input_settings' => ' onchange="updateSelectBox(this)"','options' => $color_examples);
	$LinAdmin->printAdminConfig('select',i18n("Examples"),'select_examples','',$options);
	echo '<br />';
	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_layout_color_bodybg'),'sys_style_layout_color_bodybg',$LinAdmin->option_value_system['sys_style_layout_color_bodybg']);
	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_layout_color_elembg'),'sys_style_layout_color_elembg',$LinAdmin->option_value_system['sys_style_layout_color_elembg']);
	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_layout_color_font'),'sys_style_layout_color_font',$LinAdmin->option_value_system['sys_style_layout_color_font']);
	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_layout_color_albumsbg'),'sys_style_layout_color_albumsbg',$LinAdmin->option_value_system['sys_style_layout_color_albumsbg']);
	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_layout_color_links'),'sys_style_layout_color_links',$LinAdmin->option_value_system['sys_style_layout_color_links']);
	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_layout_color_linkshover'),'sys_style_layout_color_linkshover',$LinAdmin->option_value_system['sys_style_layout_color_linkshover']);

	break;
case 'home':
	$welcometxt = i18n("Add Your Own Welcome Text Here");
	$data = $GLOBALS['linpha']->db->GetRow("SELECT meta_comment FROM ".LIN_PREFIX."meta_comments WHERE md5sum='welcometext'");
	if(isset($data['meta_comment']))
	{
		$welcometxt = $data['meta_comment'];
		$update = true;
	}

	/**
	 * save settings
	 */
		if(isset($_POST['cmd']) && $_POST['cmd']=='saveconfig')
		{
			$LinAdmin->saveConfig(Array(
				'sys_style_home_usedefaultwelcometext',
				'sys_style_home_nrrandomimages',
				'sys_style_home_showalbums',
				'sys_style_home_firstsortorder',
				'sys_style_home_showbrowsebydate'
			));
			if(isset($_POST['welcometext']) && $_POST['welcometext'] != $welcometxt)
			{
				/**
				 * insert or update
				 */
				if(isset($update))
				{
					$GLOBALS['linpha']->db->Execute("UPDATE ".LIN_PREFIX."meta_comments SET " .
						"meta_comment = '".LinSql::linAddslashes($_POST['welcometext'])."'" .
						"WHERE md5sum='welcometext'");
					$welcometxt = $_POST['welcometext'];
				}
				else
				{
					$GLOBALS['linpha']->db->Execute("INSERT into ".LIN_PREFIX."meta_comments (md5sum, meta_comment) " .
							"VALUES ('welcometext', '".LinSql::linAddslashes($_POST['welcometext'])."')");
					$welcometxt = $_POST['welcometext'];
				}
			}
		}


	echo '<b>'.i18n("Welcome Text").'</b><br />';
	$LinAdmin->printAdminConfig('radio',i18n("Use Default Welcome Text"),'sys_style_home_usedefaultwelcometext',$LinAdmin->option_value_system['sys_style_home_usedefaultwelcometext']);

	?>
	<textarea name="welcometext" rows="10" cols="50" class="linForms"><?php echo htmlspecialchars($welcometxt,ENT_QUOTES); ?></textarea>
	<br /><br /><br />
	<?php
	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_home_nrrandomimages'),'sys_style_home_nrrandomimages',$LinAdmin->option_value_system['sys_style_home_nrrandomimages']);
	$LinAdmin->printAdminConfig('radio',$LinAdmin->getDescriptionByOptionName('sys_style_home_showbrowsebydate'),'sys_style_home_showbrowsebydate',$LinAdmin->option_value_system['sys_style_home_showbrowsebydate']);
	$LinAdmin->printAdminConfig('radio',$LinAdmin->getDescriptionByOptionName('sys_style_home_showalbums'),'sys_style_home_showalbums',$LinAdmin->option_value_system['sys_style_home_showalbums']);
	$LinAdmin->printAdminConfig('select',$LinAdmin->getDescriptionByOptionName('sys_style_home_firstsortorder'),'sys_style_home_firstsortorder',$LinAdmin->option_value_system['sys_style_home_firstsortorder'],array('options' => linGetSortOrders()));
	
	break;
case 'thumb':

	if(isset($_POST['cmd']) && $_POST['cmd']=='saveconfig')
	{
		$LinAdmin->saveConfig(Array(
			'sys_style_thumb_showsubfoldersseparate'
		));
	}

	$LinAdmin->printAdminConfig('radio',$LinAdmin->getDescriptionByOptionName('sys_style_thumb_showsubfoldersseparate'),'sys_style_thumb_showsubfoldersseparate',$LinAdmin->option_value_system['sys_style_thumb_showsubfoldersseparate']);
	break;
case 'image':

	if(isset($_POST['cmd']) && $_POST['cmd']=='saveconfig')
	{
		$LinAdmin->saveConfig(Array(
			'sys_style_image_nrprevnextthumbs'
		));
	}

	$LinAdmin->printAdminConfig('text',$LinAdmin->getDescriptionByOptionName('sys_style_image_nrprevnextthumbs'),'sys_style_image_nrprevnextthumbs',$LinAdmin->option_value_system['sys_style_image_nrprevnextthumbs']);
	break;
case 'others':

	if(isset($_POST['cmd']) && $_POST['cmd']=='saveconfig')
	{
		/*$LinAdmin->saveConfig(Array(
			''
		));*/
	}


	break;
}
?>