<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn 
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * Thumb view related methods and functions
 * @package Image
 */

//sleep(5);
 
if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','.'); }

include_once(LINPHA_DIR.'/lib/include/common.php');

/**
 * check for valid id
 */
try
{
	include_once(LINPHA_DIR.'/lib/classes/linpha.class.php');
	$linpha = new linpha();
	$linpha->sql->startSession();

	if( $linpha->template->idCurrent == 0 )
	{
		throw new Exception("no valid id supplied!");
	}
	
	/**
	 * create overrideSettings
	 */
	$overrideSettings = Array();
	if(isset($_GET['width']) && isset($_GET['height']))
	{
		$overrideSettings['max_width'] = intval($_GET['width']);
		$overrideSettings['max_height'] = intval($_GET['height']);
	}
	
	if(isset($_GET['rotate']))
	{
		$overrideSettings['rotate'] = intval($_GET['rotate']);
	}
	
	$image = new LinImage();
	if( ! $image->createImage($linpha->template->idCurrent, $overrideSettings) )	// returns false if no permission
	{
		throw new Exception("Error while creating image!<br />Error: ".$image->error_msg);
	}
	
	$image->printFileToScreen();
}
catch(Exception $error)
{
	echo "Error: ".$error -> getMessage();
	linLog(LOG_TYPE_IMPORT,LOG_ERR,'image',$error->getMessage());
}


?>