<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn 
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * Thumb view related methods and functions
 * @package Image
 */
 
if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','.'); }

include_once(LINPHA_DIR.'/lib/include/common.php');

/**
 * check for valid id
 */
try
{
	include_once(LINPHA_DIR.'/lib/classes/linpha.class.php');
	$linpha = new linpha();
	$linpha->sql->startSession();

	if( $linpha->template->idCurrent == 0 )
	{
		throw new Exception("no valid id supplied!");
	}
	
	$thumbnail = new LinImage();

	
	/**
	 * set necessary infos to display image if exists
	 * create thumbnail if not exists
	 * 
	 * returns false if no permission
	 */
	if( ! $thumbnail->createThumbnail($linpha->template->idCurrent) )
	{
		throw new Exception("Error while creating thumbnail!<br />Error: ".$thumbnail->error_msg);
	}
	
	$thumbnail->printFileToScreen();
}
catch(Exception $error)
{
	echo "Error: ".$error -> getMessage();
	linLog(LOG_TYPE_IMPORT,LOG_ERR,'thumbnail',$error->getMessage());
}


?>