<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * linpha installer
 * @package Installation
 */

include_once(LINPHA_DIR."/install/lib.install.php");


/**
 * language file
 */
	if(isset($_SESSION['language']))	// come from install pages
	{
		/**
		 * strict division from $_SESSION['language'] and include() !!!
		 * make sure we don't have a include($_GET['language']) !!!
		 */
		$array_langs = get_available_language_files();
		$key = array_search( $_SESSION['language'], $array_langs);
		if( $key === false )
		{
			$include_lang = 'English';
		}
		else
		{
			$include_lang = $array_langs[$key];
		}
	}
	elseif(isset($_POST['language']))
	{
		/**
		 * strict division from $_POST['language'] and include() !!!
		 * make sure we don't have a include($_POST['language']) !!!
		 */
		$array_langs = get_available_language_files();
		$key = @array_search( $_POST['language'], $array_langs);
		if( $key === false )
		{
			$include_lang = 'English';
		}
		else
		{
			$include_lang = $array_langs[$key];
		}		
	}
	elseif(isset($lang))	// step 1 (index.php)
	{
		$include_lang = $lang;
	}
	else
	{
		$include_lang = 'English';
		$_SESSION['language'] = "English";
	}

	if(file_exists(LINPHA_DIR."/install/lang/lang.".$include_lang.".php")) {
		include_once(LINPHA_DIR."/install/lang/lang.".$include_lang.".php");
	}


$files = Array(
	"index.php",
	"step1_license.php",
	"step2_requirements.php",
	"step3_dbtype.php",	
	"step4_selectdirectories.php",
	"step5_getlogin.php",
	"step6_selectdatabase.php",
	"step7_selectprefix.php",
	"step8_testing.php",
	"step9_createtables.php",
	"step10_postsettings.php",
	"step11_finish.php"
);

$title_str[0] = "Welcome";
$title_str[1] = "Accept GPL";
$title_str[2] = "Requirements Check";
$title_str[3] = "Database Type";
$title_str[4] = "Directories";
$title_str[5] = "Database Login";
$title_str[6] = "Select Database";
$title_str[7] = "Select Prefix";
$title_str[8] = "System Checks";
$title_str[9] = "Database Tables";
$title_str[10] = "Post Settings";
$title_str[11] = "Finalizing";

if(! isset($is_special))
{
	$current_file = basename($_SERVER['PHP_SELF']);
	$key = array_search($current_file,$files);
}
	
/**
 * on the first page, don't show back button
 */
if($key == 0)
{
	$show_back_button = false;
	$back_file = $files[$key];
}
else
{
	$show_back_button = true;
	$back_file = $files[$key-1];
}

/**
 * when finished, don't show next buttons
 */
if($key == ( count($files) -1 ))
{
	$show_back_button = true;
	$show_next_button = true;
	$next_file = '../';
}
else
{
	$show_next_button = true;
	$next_file = $files[$key+1];
}

	
/**
 * don't start session on the first pages, because of better error handling
 */
if($key >= 3)
{
	session_start();
	if($key==3)
	{
		$_SESSION = Array();
	}
}


if(isset($_GET ['reset']))
{
	$_SESSION = array();
	header("Location: index.php");
	exit();
}
?>