<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','..'); }

/**
 * linpha installer
 * @package Installation
 */

$is_special = true;
$key = 9;

include_once(LINPHA_DIR.'/install/header.php');

$back_file = "step3_dbtype.php";
include_once(LINPHA_DIR.'/install/header_html.php');

/**
 * initialize variables
 */
	$array = array(
		'sql_prefix' => 'linpha_'
	);
	
	foreach($array AS $key=>$value)
	{
		if(isset($_POST[$key]))
		{
			$_SESSION[$key] = $_POST[$key];
		}
		elseif(empty($_SESSION[$key]))
		{
			$_SESSION[$key] = $value;
		}
	}

/**
 * define variables manually
 */
	$_SESSION['sql_hostname'] = "localhost";
	$_SESSION['sql_username'] = "root";
	$_SESSION['sql_password'] = "";
	$_SESSION['sql_dbname'] = "linpha";
	
	
	define('LIN_PREFIX', $_SESSION['sql_prefix']);
	define('LIN_DB_TYPE', $_SESSION['sql_dbtype']);



echo "<h2>".tr("LinPHA Manual Install")."</h2>";
?>
<br />

</form>
<form method="POST" action="manual_install.php">
<?php echo tr("Table Prefix").":"; ?>
<input type="text" name="sql_prefix" value="<?php echo $_SESSION['sql_prefix']; ?>">
<input type="submit" name="submit" value="Change">
</form>

<?php
/**
 * create tables
 */
	/**
	 * get table names and add prefix
	 */
		include_once(LINPHA_DIR.'/install/sql/sql.tables.php');
		foreach($linpha_tables AS $key=>$value)
		{
			$linpha_tables[$key] = LIN_PREFIX.$value;
		}
	
	/**
	 * include sql strings
	 */
		include_once(LINPHA_DIR."/install/sql/sql.".LIN_DB_TYPE.".php");
	
	/**
	 * finally create tables
	 */
	 	$str_query = "";
		while( list($key,$query) = each($sql_tables) )
		{
			$str_query .= $query.";\n";
		}

/**
 * insert data
 */
	$str_query .= "\n\n";
	include_once(LINPHA_DIR.'/install/sql/sql.data.php');
	foreach($sql_queries AS $value)
	{
		$str_query .= $value.";\n";
	}

?>
<br />
<?php echo tr("SQL Queries To Execute")."<br />"; ?>
<textarea style="width: 95%; " rows="8" wrap="off"><?php echo $str_query; ?></textarea>


<?php
/**
 * directory config file
 */
$changeme = ' // change me';
$donotchange = ' // change only with installer !!';

$comment[1] = $donotchange;
include_once(LINPHA_DIR.'/install/sql/config.dir.php');
?>
<br /><br />
<?php echo tr("Folders To Create")."<br />"; ?>
<textarea style="width: 95%; " rows="3" wrap="off">
<?php
echo $_SESSION['album_dir']."\n";
echo $_SESSION['sql_dir']."\n";
echo $_SESSION['cache_dir']."\n";
echo $_SESSION['cache_dir'].'imgcache/'."\n";
for($i = 0; $i < 10; $i++)
{
	echo $_SESSION['cache_dir'].'imgcache/'.$i.'/'."\n";
}
echo $_SESSION['cache_dir'].'thumbache/'."\n";
for($i = 0; $i < 10; $i++)
{
	echo $_SESSION['cache_dir'].'thumbache/'.$i.'/'."\n";
}
echo $_SESSION['tmp_dir']."\n";
echo $_SESSION['tmp_dir'].'adocache/';
?>
</textarea>

<br /><br />
<?php echo tr("Config File <b>sql/config.dir.php</b>")."<br />"; ?>
<textarea style="width: 95%; " rows="3" wrap="off"><?php echo $str; ?></textarea>


<?php
/**
 * sql config file
 */
$comment[1] = $donotchange;
$comment[2] = $changeme; $comment[3] = $changeme; $comment[4] = $changeme; $comment[5] = $changeme;
$comment[6] = $donotchange;

include_once(LINPHA_DIR.'/install/sql/config.sql.php');
?>
<br /><br />
<?php echo tr("Database Connection File"); ?><b><?php echo $_SESSION['sql_dir']; ?>config.sql.php</b><br />
<textarea style="width: 95%; " rows="5" wrap="off"><?php echo $str; ?></textarea>


<br /><br />

<form method="POST" action="<?php echo $next_file; ?>">
<?php
include_once(LINPHA_DIR.'/install/footer.php');

?>