<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * linpha installer
 */

$sql_tables = array(
	"CREATE TABLE ".$linpha_tables['config']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"option_name VARCHAR(255) NOT NULL default '', " .
		"option_value VARCHAR(255) NOT NULL default '', " .
		"user_id INT default '0', " .
		"override SMALLINT default '0', " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['users']." ( ".
		"id INT NOT NULL AUTO_INCREMENT , " .
		"username VARCHAR(255) NOT NULL default '' , " .
		"password VARCHAR(32) NOT NULL default '' , " .
		"user_email VARCHAR(255) NOT NULL default '' , " .
		"display_name VARCHAR(255) NOT NULL default '' , " .
		"stats_downloads INT NOT NULL , " .
		"stats_downloads_size INT NOT NULL, " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['groups']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"group_name VARCHAR(255) NOT NULL default '', " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['user_group']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"group_id INT NOT NULL, " .
		"user_id INT NOT NULL, " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['permissions']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"photos_id INT NOT NULL default '0', " .
		"perm_type VARCHAR(255) NOT NULL default '0', " .
		"permission VARCHAR(255) NOT NULL default '', " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['photos']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"parent_id INT NOT NULL default '0', " .
		"img_type INT NOT NULL default '0', " .
		"name VARCHAR(255) NOT NULL, " .
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"width INT NOT NULL default '0', " .
		"height INT NOT NULL default '0', " .
		"filesize INT NOT NULL default '0', " .
		"time_add INT NOT NULL default '0', " .
		"time_mod INT NOT NULL default '0', " .
		"time_exif INT NOT NULL default '0', " .
		"rotate INT NOT NULL default '0', " .
		"stats_numbers INT NOT NULL default '0', " .
		"stats_views INT NOT NULL default '0', " .
		"stats_downloads INT NOT NULL default '0', " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['photos_cache']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"photo_id INT NOT NULL default '0', " .
		"img_width SMALLINT NOT NULL default '0', " .		
		"img_height SMALLINT NOT NULL default '0', " .		
		"img_quality SMALLINT NOT NULL default '0', " .		
		"img_size INT NOT NULL default '0', " .
		"is_rotated SMALLINT NOT NULL default '0', " .		
		"has_watermark SMALLINT NOT NULL default '0', " .		
		"time_add INT NOT NULL default '0', " .
		"time_use INT NOT NULL default '0', " .
		"time_creating INT NOT NULL default '0', " .
		"hits INT NOT NULL default '0', " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_fields']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"name VARCHAR(255) NOT NULL default '', " .
		"field_type SMALLINT NOT NULL default '0', " .
		"flags SMALLINT NOT NULL default '0', " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_category']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"field_id INT NOT NULL default '0', " .
		"name VARCHAR(255) NOT NULL default '', " .
		"isprivate SMALLINT default NULL, " .
		"PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_exif']." ( ".
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"datetimeoriginal VARCHAR(255) default NULL, " .
		"make VARCHAR(255) default NULL, " .
		"model VARCHAR(255) default NULL, " .
		"artist VARCHAR(255) default NULL, " .
		"copyright VARCHAR(255) default NULL, " .
		"aperturevalue VARCHAR(255) default NULL, " .
		"shutterspeedvalue VARCHAR(255) default NULL, " .
		"exposuretime VARCHAR(255) default NULL, " .
		"isospeedratings VARCHAR(255) default NULL, " .
		"flash VARCHAR(255) default NULL, " .
		"focallength VARCHAR(255) default NULL, " .
		"fnumber VARCHAR(255) default NULL, " .		
		"jpegcomment VARCHAR(255) default NULL, " .
		"PRIMARY KEY (md5sum) " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_iptc']." ( ".
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"PRIMARY KEY (md5sum) " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_comments']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"meta_time INT NOT NULL default '0', " .
		"meta_author VARCHAR(255) NOT NULL default '', " .
		"meta_comment text NOT NULL, " .
		" PRIMARY KEY (id) " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_data']." ( ".
		"id INT NOT NULL AUTO_INCREMENT, " .
		"field_id INT NOT NULL default '0', " .
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"meta_data VARCHAR(255) NOT NULL default '', " .
		"PRIMARY KEY (id) " .
	")"
); 
?>
