<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * linpha installer
 */

$sql_tables = array(
	"CREATE TABLE ".$linpha_tables['config']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"option_name VARCHAR2(255) NOT NULL, " .
		"option_value VARCHAR2(255), " .
		"user_id NUMBER(10) DEFAULT '0', " .
		"override NUMBER(6) DEFAULT '0'" .
	")",
	"CREATE TABLE ".$linpha_tables['users']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"username VARCHAR2(255) NOT NULL, " .
		"password VARCHAR2(32) NOT NULL, " .
		"user_email VARCHAR2(255) NOT NULL, " .
		"display_name VARCHAR2(255), " .
		"stats_downloads NUMBER(10) DEFAULT '0', " .
		"stats_downloads_size NUMBER(10) DEFAULT '0' " .
	")",
	"CREATE TABLE ".$linpha_tables['groups']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"group_name VARCHAR2(255) NOT NULL " .
	")",
	"CREATE TABLE ".$linpha_tables['user_group']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"group_id NUMBER(10), " .
		"user_id NUMBER(10)" .
	")",
	"CREATE TABLE ".$linpha_tables['permissions']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"photos_id NUMBER DEFAULT '0', " .
		"perm_type VARCHAR2(255), " .
		"permission VARCHAR2(255)" .
	")",
	"CREATE TABLE ".$linpha_tables['photos']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"parent_id NUMBER DEFAULT '0', " .
		"img_type NUMBER(10) DEFAULT '0', " .
		"name VARCHAR2(255) NOT NULL, " .
		"md5sum VARCHAR2(32), " .
		"width NUMBER(10) default '0', " .
		"height NUMBER(10) default '0', " .
		"filesize NUMBER(10) default '0', " .
		"time_add NUMBER(12) DEFAULT '0', " .
		"time_mod NUMBER(12) DEFAULT '0', " .
		"time_exif NUMBER(12) DEFAULT '0', " .
		"rotate NUMBER(12) DEFAULT '0', " .
		"stats_numbers NUMBER(10) DEFAULT '0', " .
		"stats_views NUMBER(10) DEFAULT '0', " .
		"stats_downloads NUMBER(10) DEFAULT '0'" .
	")",
	"CREATE TABLE ".$linpha_tables['photos_cache']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"photo_id NUMBER DEFAULT '0', " .
		"img_width NUMBER(6) DEFAULT '0', " .		
		"img_height NUMBER(6) DEFAULT '0', " .		
		"img_quality NUMBER(6) DEFAULT '0', " .		
		"img_size NUMBER(10) DEFAULT '0', " .
		"is_rotated NUMBER(2) DEFAULT '0', " .		
		"has_watermark NUMBER(2) DEFAULT '0', " .		
		"time_add NUMBER(12) DEFAULT '0', " .
		"time_use NUMBER(12) DEFAULT '0', " .
		"time_creating NUMBER(12) DEFAULT '0', " .
		"hits NUMBER(10) DEFAULT '0'" .
	")",
	"CREATE TABLE ".$linpha_tables['meta_fields']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"name VARCHAR2(255) NOT NULL, " .
		"field_type NUMBER(12) DEFAULT '0', " .
		"flags NUMBER(6) DEFAULT '0' " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_category']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"field_id NUMBER(12) DEFAULT '0', " .
		"name VARCHAR2(255), " .
		"isprivate NUMBER(6) DEFAULT '0' " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_exif']." ( ".
		"md5sum VARCHAR2(32) NOT NULL, " .
		"datetimeoriginal VARCHAR2(255) DEFAULT NULL, " .
		"make VARCHAR2(255) DEFAULT NULL, " .
		"model VARCHAR2(255) DEFAULT NULL, " .
		"artist VARCHAR2(255) DEFAULT NULL, " .
		"copyright VARCHAR2(255) DEFAULT NULL, " .
		"aperturevalue VARCHAR2(255) DEFAULT NULL, " .
		"shutterspeedvalue VARCHAR2(255) DEFAULT NULL, " .
		"exposuretime VARCHAR2(255) DEFAULT NULL, " .
		"isospeedratings VARCHAR2(255) DEFAULT NULL, " .
		"flash VARCHAR2(255) DEFAULT NULL, " .
		"focallength VARCHAR2(255) DEFAULT NULL, " .
		"fnumber VARCHAR2(255) DEFAULT NULL, " .		
		"jpegcomment VARCHAR2(255) DEFAULT NULL " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_iptc']." ( ".
		"md5sum VARCHAR2(32) NOT NULL" .
	")",
	"CREATE TABLE ".$linpha_tables['meta_comments']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"md5sum VARCHAR2(32) NOT NULL, " .
		"meta_time NUMBER(12) DEFAULT '0', " .
		"meta_author VARCHAR2(255), " .
		"meta_comment CLOB " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_data']." ( ".
		"id NUMBER PRIMARY KEY, " .
		"field_id NUMBER DEFAULT '0', " .
		"md5sum VARCHAR2(32) NOT NULL, " .
		"meta_data VARCHAR2(255)" .
	")"
); 

/**
 * autoincrement the oracle way ;-)
 */        
$sql_sequence[] = "CREATE SEQUENCE config_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE users_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE groups_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE user_group_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE permissions_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE photos_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE photos_cache_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE meta_fields_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE meta_category_seq START WITH 1";
//$sql_sequence[] = "CREATE SEQUENCE meta_exif_seq START WITH 1";
//$sql_sequence[] = "CREATE SEQUENCE meta_iptc_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE meta_comments_seq START WITH 1";
$sql_sequence[] = "CREATE SEQUENCE meta_data_seq START WITH 1";

$sql_trigger[] = "CREATE OR REPLACE TRIGGER config_trig " .
		"BEFORE INSERT ON ".$linpha_tables['config']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT config_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";
$sql_trigger[] = "CREATE OR REPLACE TRIGGER users_trig " .
		"BEFORE INSERT ON ".$linpha_tables['users']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT users_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";
$sql_trigger[] = "CREATE OR REPLACE TRIGGER groups_trig " .
		"BEFORE INSERT ON ".$linpha_tables['groups']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT groups_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";
$sql_trigger[] = "CREATE OR REPLACE TRIGGER user_group_trig " .
		"BEFORE INSERT ON ".$linpha_tables['user_group']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT user_group_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";
$sql_trigger[] = "CREATE OR REPLACE TRIGGER permissions_trig " .
		"BEFORE INSERT ON ".$linpha_tables['permissions']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT permissions_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";
$sql_trigger[] = "CREATE OR REPLACE TRIGGER photos_trig " .
		"BEFORE INSERT ON ".$linpha_tables['photos']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT photos_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";		
$sql_trigger[] = "CREATE OR REPLACE TRIGGER photos_cache_trig " .
		"BEFORE INSERT ON ".$linpha_tables['photos_cache']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT photos_cache_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";						
$sql_trigger[] = "CREATE OR REPLACE TRIGGER meta_fields_trig " .
		"BEFORE INSERT ON ".$linpha_tables['meta_fields']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT meta_fields_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";
$sql_trigger[] = "CREATE OR REPLACE TRIGGER meta_category_trig " .
		"BEFORE INSERT ON ".$linpha_tables['meta_category']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT meta_category_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";
/*$sql_trigger[] = "CREATE OR REPLACE TRIGGER meta_exif_trig " .
		"BEFORE INSERT ON ".$linpha_tables['meta_exif']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT meta_exif_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";

$sql_trigger[] = "CREATE OR REPLACE TRIGGER meta_iptc_trig " .
		"BEFORE INSERT ON ".$linpha_tables['meta_iptc']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT meta_iptc_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";						
*/
$sql_trigger[] = "CREATE OR REPLACE TRIGGER meta_comments_trig " .
		"BEFORE INSERT ON ".$linpha_tables['meta_comments']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT meta_comments_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";
$sql_trigger[] = "CREATE OR REPLACE TRIGGER meta_data_trig " .
		"BEFORE INSERT ON ".$linpha_tables['meta_data']." " .
		"REFERENCING NEW AS NEW " .
		"FOR EACH ROW " .
		"BEGIN " .
		"SELECT meta_data_seq.nextval INTO :new.id FROM DUAL; " .
		"END; ";		
?>
      