<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * linpha installer
 */

$sql_tables = array(
	"CREATE TABLE ".$linpha_tables['config']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"option_name VARCHAR(255) NOT NULL default '', " .
		"option_value VARCHAR(255) NOT NULL default '', " .
		"user_id INTEGER default '0', " .
		"override SMALLINT default '0' " .
	")",
	"CREATE TABLE ".$linpha_tables['users']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"username VARCHAR(255) NOT NULL default '' , " .
		"password VARCHAR(32) NOT NULL default '' , " .
		"user_email VARCHAR(255) NOT NULL default '' , " .
		"display_name VARCHAR(255) NOT NULL default '' , " .
		"stats_downloads INTEGER NOT NULL default '0' , " .
		"stats_downloads_size INTEGER NOT NULL default '0' " .
	")",
	"CREATE TABLE ".$linpha_tables['groups']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"group_name VARCHAR(255) NOT NULL default '' " .
	")",
	"CREATE TABLE ".$linpha_tables['user_group']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"group_id INTEGER NOT NULL default '0', " .
		"user_id INTEGER NULL default '0'" .
	")",
	"CREATE TABLE ".$linpha_tables['permissions']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"photos_id INTEGER NOT NULL default '0', " .
		"perm_type VARCHAR(255) NOT NULL default '0', " .
		"permission VARCHAR(255) NOT NULL default '' " .
	")",
	"CREATE TABLE ".$linpha_tables['photos']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"parent_id INTEGER NOT NULL default '0', " .
		"img_type INTEGER NOT NULL default '0', " .
		"name VARCHAR(255) NOT NULL, " .
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"width INTEGER NOT NULL default '0', " .
		"height INTEGER NOT NULL default '0', " .
		"filesize INTEGER NOT NULL default '0', " .
		"time_add INTEGER NOT NULL default '0', " .
		"time_mod INTEGER NOT NULL default '0', " .
		"time_exif INTEGER NOT NULL default '0', " .
		"rotate INTEGER NOT NULL default '0', " .
		"stats_numbers INTEGER NOT NULL default '0', " .
		"stats_views INTEGER NOT NULL default '0', " .
		"stats_downloads INTEGER NOT NULL default '0' " .
	")",
	"CREATE TABLE ".$linpha_tables['photos_cache']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"photo_id INTEGER NOT NULL default '0', " .
		"img_width SMALLINT NOT NULL default '0', " .		
		"img_height SMALLINT NOT NULL default '0', " .		
		"img_quality SMALLINT NOT NULL default '0', " .		
		"img_size INTEGER NOT NULL default '0', " .
		"is_rotated SMALLINT NOT NULL default '0', " .		
		"has_watermark SMALLINT NOT NULL default '0', " .		
		"time_add INTEGER NOT NULL default '0', " .
		"time_use INTEGER NOT NULL default '0', " .
		"time_creating INTEGER NOT NULL default '0', " .
		"hits INTEGER NOT NULL default '0' " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_fields']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"name VARCHAR(255) NOT NULL default '', " .
		"field_type SMALLINT NOT NULL default '0', " .
		"flags SMALLINT NOT NULL default '0' " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_category']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"field_id INTEGER NOT NULL default '0', " .
		"name VARCHAR(255) NOT NULL default '', " .
		"isprivate SMALLINT default NULL " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_exif']." ( ".
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"datetimeoriginal VARCHAR(255) default NULL, " .
		"make VARCHAR(255) default NULL, " .
		"model VARCHAR(255) default NULL, " .
		"artist VARCHAR(255) default NULL, " .
		"copyright VARCHAR(255) default NULL, " .
		"aperturevalue VARCHAR(255) default NULL, " .
		"shutterspeedvalue VARCHAR(255) default NULL, " .
		"exposuretime VARCHAR(255) default NULL, " .
		"isospeedratings VARCHAR(255) default NULL, " .
		"flash VARCHAR(255) default NULL, " .
		"focallength VARCHAR(255) default NULL, " .
		"fnumber VARCHAR(255) default NULL, " .		
		"jpegcomment VARCHAR(255) default NULL " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_iptc']." ( ".
		"md5sum VARCHAR(32) NOT NULL default '' " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_comments']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"meta_time INTEGER NOT NULL default '0', " .
		"meta_author VARCHAR(255) NOT NULL default '', " .
		"meta_comment text NOT NULL " .
	")",
	"CREATE TABLE ".$linpha_tables['meta_data']." ( ".
		"id INTEGER PRIMARY KEY, " .
		"field_id INTEGER NOT NULL default '0', " .
		"md5sum VARCHAR(32) NOT NULL default '', " .
		"meta_data VARCHAR(255) NOT NULL default '' " .
	")"
); 
?>
