<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * linpha installer
 * @package Installation
 */

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','..'); }
include_once(LINPHA_DIR.'/lib/include/common.php');
include_once(LINPHA_DIR.'/install/header.php');
include_once(LINPHA_DIR.'/install/lib.requirements.php');

/**
 * now, it is too late to go back...
 */
if(isset($_SESSION['install_mode']) && $_SESSION['install_mode'] =="manual")
{	
	$back_file = "manual_install.php";
	$show_back_button = true;
}
else
{
	$show_back_button = false;
}


include_once(LINPHA_DIR.'/install/header_html.php');

echo tr("Connecting To Database")."... ";
unset($_SESSION['installmode1']); 

include_once(LINPHA_DIR.'/lib/classes/linpha.class.php');

$linpha = new Linpha();
$linpha->sql->dbConnect();

echo success_msg();

/**
 * add new linpha admin user
 */
echo "<br /><br />";
echo "<h2>".tr("Setup Linpha Admin User").".</h2>";
?>
<div class="boxalign">
<?php echo tr("Admin Username").":"; ?>
<input class="boxalignelement" type="text" id="check01" onKeyup="checkForm()" 
	name="admin_name" value="root">
</div>

<div class="boxalign">
<?php echo tr("Admin Password").":"; ?>
<input class="boxalignelement" type="password" id="check02" 
	onKeyup="checkForm()" name="admin_pass">
</div>

<div class="boxalign">
<?php echo tr("Admin eMail").":"; ?>
<input class="boxalignelement" type="text" id="check03" onKeyup="checkForm()" 
	name="admin_email">
</div>
<br />
<br />

<?php

$query = $linpha->db->Execute("SELECT option_value FROM ".LIN_PREFIX."config " .
		"WHERE option_name='sys_im_use_imagemagick'");
$data = $query->FetchRow(ADODB_FETCH_NUM);

if(false === $data[0])
{
	echo "<h2>".tr("Please Choose Thumbnail Quality")."</h2>";
	?>
	<div align="center">
		<div class="box2">
		<input type='radio' name='quality' value='1'>High Quality<br />
		<img src='./graphics/hqdemo.jpg' width="120" height="90" border="0"">
		</div>
		
		<div class="box2" style="float: none; ">
		<input type='radio' name='quality' value='0' checked>Low Quality<br />
		<img src='./graphics/lqdemo.jpg' width="120" height="90" border="0"">
		</div>
	</div>
	<?php
	echo tr("Warning: High Quality Requires CPU > 1 GHz");
}
?>
<br /><br />
<?php
echo "<h2>".tr("Please Choose Default Thumbnail Size")."</h2>";
?>

<div align="center">
	<div class="box3">
	<input type='radio' name='sys_style_tn_size' value='90'>
	90 pixel<br />
	<img src='./graphics/thumb90px.jpg' />
	</div>
	
	<div class="box3">
	<input type='radio' name='sys_style_tn_size' value='120' checked="checked">
	120 pixel<br />
	<img src='./graphics/thumb120px.jpg' />
	</div>
	
	<div class="box3">
	<input type='radio' name='sys_style_tn_size' value='150'>
	150 pixel<br />
	<img src='./graphics/thumb150px.jpg' />
	</div>
</div>
<br /><br /><br /><br />
<?php

$array_check = array(
	'check01' => 'text',
	'check02' => 'text'
	//'check03' => 'text'
);
$do_javascript_disable_button = true;
include_once(LINPHA_DIR.'/install/footer.php');
?>