<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','..'); }

/**
 * linpha installer
 * @package Installation
 */
include_once(LINPHA_DIR.'/lib/include/common.php');
include_once(LINPHA_DIR.'/install/header.php');

/**
 * save settings from previous page
 */
if(isset($_POST['language']))
{
	$_SESSION['language'] = $_POST['language'];
}

$array = array('sys_im_bracket_support','sys_im_use_convert','sys_im_convert_path');
foreach($array AS $value)
{
	if(isset($_POST[$value]))
	{
		$_SESSION[$value] = $_POST[$value];
	}
	else
	{
		$_SESSION[$value] = 0;
	}
}


include_once(LINPHA_DIR.'/install/header_html.php');


$array_databases = Array(
	'mysql' => 'mysql_connect',
	'postgres' => 'pg_connect',
	'sqlite' => 'sqlite_open',
	'oci8po' => 'oci_connect'
);
$array_databases_names = Array(
	'mysql' => "MySQL",
	'postgres' => "PostgreSQL",
	'sqlite' => "Sqlite",
	'oci8po' => "Oracle"
);

/**
 * check for supported databases
 * define disabled and checked variables
 */
foreach($array_databases AS $key=>$value)
{
	if(!function_exists($value)) {
		$disabled = ' disabled="disabled"';
	} else {
		$disabled =  '';
	}
	
	if(isset($_SESSION['sql_dbtype']) && $_SESSION['sql_dbtype'] == $key) {
		$checked = ' checked="checked"';
	} else {
		/**
		 * use first entry as checked
		 */
		if(!isset($is_first) && empty($disabled))
		{
			$is_first = false;
			$checked = ' checked="checked"';
		}
		else
		{
			$checked = '';
		}
	}

	echo '<input type="radio" id="sql'.$key.'" name="sql_dbtype" value="'.$key.'"'.$disabled.$checked.'>' .
		'<label for="sql'.$key.'">'.$array_databases_names[$key].'</label><br />';

	if(!function_exists($value))
	{
	    echo '<b>'.tr("No Support In PHP Config (php.ini)").'</b><br />';
	}

	echo '<br />'."\n\n";
}

?>
<br /><br />
<h1><?php echo tr("Select Installation Mode"); ?></h1>
<br />
<input type='radio' name='install_mode' value='automatic' checked="checked">
<?php echo tr("Automatic mode"); ?>
<br /><br />
<input type='radio' name='install_mode' value='manual'>
<?php echo tr("Manual Mode (Experts Only)"); ?>

<?php
include_once(LINPHA_DIR.'/install/footer.php');
?>