<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * linpha installer
 * @package Installation
 */

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','..'); }
include_once(LINPHA_DIR.'/lib/include/common.php');
include_once(LINPHA_DIR.'/install/header.php');

$album_dir = (isset($_SESSION['album_dir']) ? $_SESSION['album_dir'] : 'albums');
$sql_dir = (isset($_SESSION['sql_dir']) ? $_SESSION['sql_dir'] : 'var/sql');
$cache_dir = (isset($_SESSION['cache_dir']) ? $_SESSION['cache_dir'] : 'var/cache');
$tmp_dir = (isset($_SESSION['tmp_dir']) ? $_SESSION['tmp_dir'] : 'var/tmp');


/**
 * save settings from previous page
 */
	if(isset($_POST['sql_dbtype']))
	{
		$_SESSION['sql_dbtype'] = $_POST['sql_dbtype'];
	}

	if(isset($_POST['install_mode']))
	{
		$_SESSION['install_mode'] = $_POST['install_mode'];
	}

/**
 * sqlite doesn't know anyhting about username, password, hostname and
 * databasename -> skip the following pages
 */
	if(isset($_SESSION['sql_dbtype']) && $_SESSION['sql_dbtype'] == "sqlite")
	{
		$_SESSION['sql_username'] = '';
		$_SESSION['sql_password'] = '';
		$_SESSION['sql_hostname'] = '';
		$_SESSION['sql_dbname'] = 'database.sqlite';
		$_SESSION['sql_prefix'] = 'linpha_';
	
		$next_file = "step7_selectprefix.php";
	}



include_once(LINPHA_DIR.'/install/header_html.php');
?>

<div class="boxalign">
<?php echo tr("Album Directory").":"; ?>
<input class="boxalignelement" type="text" id="check01" onKeyup="checkForm()" 
	name="album_dir" size="30" value="<?php echo $album_dir; ?>">
</div>
(-> <?php echo installLinRealpath( installGetFullPath($album_dir) ) ?>)
<br /><br />

<br />
<h2 style="color: red;"><?php echo tr("Warning: All directories below will be deleted if they exists !!"); ?></h2>
<br />

<div class="boxalign">
<?php echo tr("Sql Directory").":"; ?>
<input class="boxalignelement" type="text" id="check02" onKeyup="checkForm()" 
	name="sql_dir" size="30" value="<?php echo $sql_dir; ?>">
</div>
(-> <?php echo installLinRealpath( installGetFullPath($sql_dir) );?>)
<br /><br />

<div class="boxalign">
<?php echo tr("Cache Directory").":"; ?>
<input class="boxalignelement" type="text" id="check03" onKeyup="checkForm()" 
	name="cache_dir" size="30" value="<?php echo $cache_dir; ?>">
</div>
(-> <?php echo installLinRealpath( installGetFullPath($cache_dir) ); ?>)
<br /><br />

<div class="boxalign">
<?php echo tr("Temp Directory").":"; ?>
<input class="boxalignelement" type="text" id="check04" onKeyup="checkForm()" 
	name="tmp_dir" size="30" value="<?php echo $tmp_dir; ?>">
</div>
(-> <?php echo installLinRealpath( installGetFullPath($tmp_dir) ); ?>)
<br /><br />
<input type="hidden" name="cmd_step4" value="save">


<?php

$array_check = array(
	'check01' => 'text',
	'check02' => 'text',
	'check03' => 'text',
	'check04' => 'text'
);
$do_javascript_disable_button = true;
include_once(LINPHA_DIR.'/install/footer.php');
?>