<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','..'); }

/**
 * linpha installer
 * @package Installation
 */
include_once(LINPHA_DIR.'/lib/include/common.php');
include_once(LINPHA_DIR.'/install/header.php');

/**
 * validate settings
 */
if(isset($_POST['cmd_step4']))
{
	if(!isset($_POST['album_dir']) OR empty($_POST['album_dir']) OR 
		!isset($_POST['sql_dir']) OR empty($_POST['sql_dir']) OR
		!isset($_POST['cache_dir']) OR empty($_POST['cache_dir']) OR
		!isset($_POST['tmp_dir']) OR empty($_POST['tmp_dir']) )
	{
		include_once(LINPHA_DIR.'/install/header_html.php');
	
		echo tr("Validating Information")."...  ";
		echo failed_msg();
		echo "<br />".tr("Please Fill In All Fields")."";
		
		echo "</form>";
		$show_next_button = false;
	
		include_once(LINPHA_DIR.'/install/footer.php');
		exit();
	}
	else
	{
		/**
	 	* save settings from previous page
	 	*/
		$dirs = initSessionValues();		
	}

	/**
	 * goto manual mode
	 */
	if(isset($_SESSION['install_mode']) && $_SESSION['install_mode'] =="manual")
	{
		header("Location: manual_install.php");
		exit();
	}
	
}	

include_once(LINPHA_DIR.'/install/header_html.php');

if(isset($_POST['cmd_step4']))
{	
	/**
	 * checking album, sql, cache and tmp directory
	 */
		if(initInitialDirectories($dirs) != true)
		{
			$show_next_button = false;
			include_once(LINPHA_DIR.'/install/footer.php');
			exit();
		}
}
?>
<br /><br />
<hr />
<h1><?php echo tr("$title_str[$key]"); ?></h1>
<br />
<?php 
if($_SESSION['sql_dbtype'] == 'mysql') 
{	
	echo tr("NOTE: If you have setup a root Password for your MySQL Database " .
		"please login using your root account.")."<br /><br />";
	$_SESSION['sql_dbport'] = '3306';
}
elseif($_SESSION['sql_dbtype'] == 'postgres')
{
	echo tr("NOTE: There is currently now way to let LinPHA create the required " .
		"Database, so you have to create a new Database using \"createdb\" " .
		"from commandline before you proceed.")."<br /><br />";
	$_SESSION['sql_dbport'] = '5432';
}
elseif($_SESSION['sql_dbtype'] == 'oci8po')
{
	echo tr("NOTE: Oracle support is only testet on XE the \"Free\" Edition. " .
			"If you get things running using a \"real\" Oracle Database please " .
			"drop us a note!")."<br /><br />";
	$_SESSION['sql_dbport'] = '1521';
}
?>

<div class="boxalign">
<?php echo tr("Username").":"; ?> 
<input class="boxalignelement" type="text" id="check01" onKeyup="checkForm()" 
	name="sql_username" value="<?php echo isset($_SESSION['sql_username']) ? $_SESSION['sql_username'] : 'root' ; ?>">
<br />
</div>

<div class="boxalign">
<?php echo tr("Password").":"; ?>
<input class="boxalignelement" type="password" id="check02" 
	onKeyup="checkForm()" name="sql_password">
<br />
</div>

<div class="boxalign">
<?php echo tr("Hostname").":"; ?>
<input class="boxalignelement" type="text" id="check03" onKeyup="checkForm()" 
	name="sql_hostname" value="<?php echo isset($_SESSION['sql_hostname']) ? 
	$_SESSION['sql_hostname'] : 'localhost' ; ?>">
</div>

<div class="boxalign">
<?php echo tr("Port").":"; ?>
<input class="boxalignelement" type="text" id="check04" onKeyup="checkForm()" 
	name="sql_dbport" value="<?php echo isset($_SESSION['sql_dbport']) ? 
	$_SESSION['sql_dbport'] : '3306' ; ?>">
</div>


<?php

$array_check = array(
	'check01' => 'text',
	//'check02' => 'text',
	'check03' => 'text',
	'check04' => 'text'
);

$do_javascript_disable_button = true;
include_once(LINPHA_DIR.'/install/footer.php');
?>