<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','..'); }

/**
 * linpha installer
 * @package Installation
 */
include_once(LINPHA_DIR.'/lib/include/common.php');
include_once(LINPHA_DIR.'/install/header.php');
include_once(LINPHA_DIR.'/install/header_html.php');

/**
 * save settings from previous page
 */
if(isset($_POST['sql_hostname'])) {
	$_SESSION['sql_hostname'] = $_POST['sql_hostname'];
}
if(isset($_POST['sql_username'])) {
	$_SESSION['sql_username'] = $_POST['sql_username'];
}
if(isset($_POST['sql_password'])) {
	$_SESSION['sql_password'] = $_POST['sql_password'];
}
if(isset($_POST['sql_dbport'])) {
	$_SESSION['sql_dbport'] = $_POST['sql_dbport'];
}

/**
 * validate settings
 */
if(empty($_SESSION['sql_hostname']) OR empty($_SESSION['sql_username']) 
	OR empty($_SESSION['sql_dbport']))
{
	echo tr("Validating Information")."...  ";
	echo failed_msg();
	echo "<br />".tr("Please Fill In All Fields")."";
	
	echo "</form>";
	$show_next_button = false;
	include_once(LINPHA_DIR.'/install/footer.php');
	exit();
}


switch($_SESSION['sql_dbtype'])
{
case "mysql":
	echo tr("Testing Server Connection")."<br /><br />";
	echo tr("Connecting MySQL-Server")."... ";

	$link = @mysql_connect($_SESSION['sql_hostname'].":".$_SESSION['sql_dbport'], 
			$_SESSION['sql_username'], $_SESSION['sql_password']);
	if (!$link)
	{
		echo failed_msg();
   		echo "<br />".tr("Error Connecting To Server").": ".mysql_error()."";
   		$error_nr = 2;
	}
	else
	{
		echo success_msg();
		
		$curtime = time();
		$result = mysql_query("CREATE DATABASE linpha_test_".$curtime);
		if($result)
		{
			$_SESSION['allowed_to_create_db'] = true;
			mysql_query("DROP DATABASE linpha_test_".$curtime);

			$db_list = mysql_list_dbs($link);
			
			while ($row = mysql_fetch_object($db_list)) {
				$databases[] = $row->Database;
			}
		}
		else
		{
			$_SESSION['allowed_to_create_db'] = false;
		}
	}

break;
case "postgres":
	$_SESSION['allowed_to_create_db'] = false;
break;
case "oci8po":
	$_SESSION['allowed_to_create_db'] = false;
break;

// case "sqlite": sqlite goes directly to stage8
}

if(isset($error_nr))
{
	echo "</form>";
	$show_next_button = false;
	include_once(LINPHA_DIR.'/install/footer.php');
	exit();
}

/**
 * select database
 */
?>
<br /><br />
<hr>
<br />
<?php
if($_SESSION['allowed_to_create_db'] == true)
{
	/**
	 * search a valid database name (which doesn't already exists)
	 */
	if(isset($databases))
	{
		if(array_search('linpha',$databases) === false)
		{
			$dbname = 'linpha';
		}
		else
		{
			$dbname = '';
		}
	}
	else
	{
		$dbname = 'linpha';
	}
	
	if(isset($_SESSION['createdb']))
	{
		 if($_SESSION['createdb'])
		 {
		 	$checked_create = ' checked="checked"';
		 	$checked_dontcreate = '';
		 }
		 else
		 {
		 	$checked_create = '';
		 	$checked_dontcreate = ' checked="checked"';
		 }
	}
	else
	{
	 	$checked_create = ' checked="checked"';
	 	$checked_dontcreate = '';
	}
	
	echo tr("You Are Allowed To Create A New Database (Recommended)");
	?>
	<br />
	<input type="radio" id="radio_db1" name="create_database" 
		value="create"<?php echo $checked_create; ?>>

	<?php echo tr("New Database Name").": "; ?>
	<input type="text" name="sql_dbname_create" 
		value="<?php echo isset($_SESSION['sql_dbname']) ? 
		$_SESSION['sql_dbname'] : $dbname ; ?>" 
		onKeyup="document.getElementById('radio_db1').checked = true;">

	<br /><br />
	<?php echo tr("Or").","; ?><br />
	<input type="radio" id="radio_db2" name="create_database" 
		value="false"<?php echo $checked_dontcreate; ?>> 
	<?php
}

if(isset($databases))
{
	echo tr("Install Into Existing Database").": ";
	?>
	<br />
	<select name="sql_dbname_installinto"<?php
		if($_SESSION['allowed_to_create_db'] == true)
		{
			echo 'onChange="document.getElementById(\'radio_db2\').checked = true;"';
		}
	?>>
	<?php
	foreach($databases AS $value)
	{
		if(isset($_SESSION['sql_dbname']) && $_SESSION['sql_dbname'] == $value)
		{
			$selected = ' selected="selected"';
		}
		else
		{
			$selected = '';
		}
		echo "<option".$selected.">".$value."</option>\n";
	}
	?>
	</select>
	<?php
}

if($_SESSION['allowed_to_create_db'] == false AND !isset($database))
{	
	if($_SESSION['sql_dbtype'] == 'oci8po')
	{
		echo tr("Name Of Database To Use, this is usually \"XE\" For Oracle Express Edition");
	}
	else
	{
		echo tr("Name Of Database To Use (Must Exist)").":<br />";
	}	
	?>
	<input type="text" name="sql_dbname_installinto" 
		value="<?php echo isset($_SESSION['sql_dbname']) ? 
		$_SESSION['sql_dbname'] : '' ; ?>">
	
	<?php
}

include_once(LINPHA_DIR.'/install/footer.php');
?>
