<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','..'); }

/**
 * linpha installer
 * @package Installation
 */
include_once(LINPHA_DIR.'/lib/include/common.php');
include_once(LINPHA_DIR.'/install/header.php');


/**
 * sqlite go back stuff
 */
if(isset($_SESSION['sql_dbtype']) && $_SESSION['sql_dbtype'] == "sqlite")
{
	$back_file = "step4_selectdirectories.php";
}

include_once(LINPHA_DIR.'/install/header_html.php');

/**
 * save settings from previous page
 */
if( isset( $_POST['create_database'] ) && $_POST['create_database'] == "create")
{
	$_SESSION['createdb'] = true;
	$_SESSION['sql_dbname'] = $_POST['sql_dbname_create'];
}
elseif( isset( $_POST['sql_dbname_installinto'] ) )
{
	$_SESSION['createdb'] = false;
	$_SESSION['sql_dbname'] = $_POST['sql_dbname_installinto'];
}
	
/**
 * validate settings
 */
if( empty($_SESSION['sql_dbname']) )
{
	echo tr("Validating Information")."...  ";
	echo failed_msg();
	echo "<br />".tr("Please Fill In All Fields")."";
	echo "</form>";
	$show_next_button = false;
	include_once(LINPHA_DIR.'/install/footer.php');
	exit();
}

switch($_SESSION['sql_dbtype'])
{
case "mysql":
	echo "<h2>".tr("Checking Database")."</h2><br />";

	$link = @mysql_connect($_SESSION['sql_hostname'].":".$_SESSION['sql_dbport'], 
			$_SESSION['sql_username'], $_SESSION['sql_password']);
	
	if(isset($_POST['create_database']) && $_POST['create_database'] == "create")
	{
		echo tr("Creating Database")."... ";
		$result = @mysql_query("CREATE database ".$_SESSION['sql_dbname']);

		if($result)
		{
			echo success_msg();
		}
		else
		{
			echo failed_msg();
			echo '<br />'.mysql_error();
			$error_nr = 2;
		}
		
	}

	if(!isset($error_nr))
	{
		echo "<br />".tr("Selecting Database").". ".$_SESSION['sql_dbname'].'... ';
		$db_selected = @mysql_select_db($_SESSION['sql_dbname'], $link);
		if (!$db_selected)
		{
			echo failed_msg();
			echo "<br />".tr("Failed Opening Database").". ".$_SESSION['sql_dbname'].": " . mysql_error() . "<br />";
			$error_nr = 3;
		}
		else
		{
			echo success_msg();
		}
	}

break;
case "postgres":
	echo tr("Testing Server Connection")."<br /><br />";
	echo tr("Connecting PostgreSQL-Server")."... ";

	$link = pg_connect("host=".$_SESSION['sql_hostname']." " .
			"port=".$_SESSION['sql_dbport']." " .
			"dbname=".$_SESSION['sql_dbname']." " .
			"user=".$_SESSION['sql_username']." " .
			"password=".$_SESSION['sql_password'].""); 
	
	if (!$link)
	{
		echo failed_msg();
		echo "<br />".tr("Error Connecting To Server").": ".pg_last_error($link);
		$error_nr = 2;
	}
	else
	{
		echo success_msg();
	}
break;
case "sqlite":
	
	/**
	 * checking album, sql, cache and tmp directory
	 */
		$dirs = initSessionValues();
		if(initInitialDirectories($dirs) != true)
		{
			$show_next_button = false;
			include_once(LINPHA_DIR.'/install/footer.php');
			exit();
		}
	
	echo tr("Testing File Connection")."<br /><br />";
	echo tr("Connecting SQLite Database")."... ";
	
	if(file_exists(LINPHA_DIR.'/'.$_SESSION['sql_dir'].'/'.$_SESSION['sql_dbname']))
	{
		echo failed_msg();
  		echo "<br />".tr("Database Already Exists, Delete The File ".$_SESSION['sql_dbname']." first!")."";
  		$error_nr = 3;
	}
	else
	{
		
		/**
		 * store in session to be used when switching to adodb
		 */
		
		if ($db = @sqlite_open(LINPHA_DIR.'/'.$_SESSION['sql_dir'].'/'.$_SESSION['sql_dbname'], 0666, $sqliteerror))
		{
			echo success_msg();
		}
		else
		{
			echo failed_msg();
	  		echo "<br />".tr("Failed To Create Database").": ".$sqliteerror;
	  		$error_nr = 3;
		}
	}
break;
case "oci8po":
	echo tr("Testing Server Connection")."<br /><br />";
	echo tr("Connecting ORACLE-Server")."... ";
	/**
	 * make already use of ADBDO as native oci_connet() sucks
	 */
	include_once('../lib/adodb/adodb.inc.php');
	$link = ADONewConnection('oci8po');
	$link ->Connect($_SESSION['sql_hostname'].":".$_SESSION['sql_dbport'], $_SESSION['sql_username'], $_SESSION['sql_password'], $_SESSION['sql_dbname']);
	if (!$link)
	{
		echo failed_msg();
		echo "<br />".tr("Error Connecting To Server").":";
		$error_nr = 2;
	}
	else
	{
		echo success_msg();
		$link->close();
	}

break;

}

echo "<br /><br />";

if(isset($error_nr))
{
	echo "</form>";
	$show_next_button = false;
	include_once(LINPHA_DIR.'/install/footer.php');
	exit();
}

/**
 * selecting prefix
 */
if($_SESSION['sql_dbtype'] != "sqlite")
{
	?>
	<br /><br />
	<hr>
	<br />
	<?php echo tr("Please Enter Database Prefix For Linpha Tables (Default: linpha_)").": <br />" ?>
	<input type="text" id="check01" onKeyup="checkForm()" name="sql_prefix" 
		value="<?php echo isset($_SESSION['sql_prefix']) ? 
		$_SESSION['sql_prefix'] : 'linpha_' ; ?>">
	
	<?php
	$array_check = array(
		'check01' => 'text'
	);
	$do_javascript_disable_button = true;

}
include_once(LINPHA_DIR.'/install/footer.php');
?>