<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','..'); }

/**
 * linpha installer
 * @package Installation
 */
include_once(LINPHA_DIR.'/lib/include/common.php');
include_once(LINPHA_DIR.'/install/header.php');

/**
 * now, it is too late to go back...
 */
$show_back_button = false;

include_once(LINPHA_DIR.'/install/header_html.php');
include_once(LINPHA_DIR.'/lib/classes/linpha.class.php');

$linpha = new Linpha();
$linpha->sql->dbConnect();

/**
 * create tables
 */
	/**
	 * get table names and add prefix
	 */
		include_once(LINPHA_DIR.'/install/sql/sql.tables.php');
		foreach($linpha_tables AS $key=>$value)
		{
			$linpha_tables[$key] = LIN_PREFIX.$value;
		}
	
	/**
	 * include sql strings
	 */
		include_once(LINPHA_DIR."/install/sql/sql.".LIN_DB_TYPE.".php");

	/**
	 * finally create tables
	 */
		echo tr("Creating Tables")."... ";
			
		$translation_array = array_keys($linpha_tables);	// only used in error case
		while( list($key,$query) = each($sql_tables) )
		{
			$result = $linpha->db->Execute($query);
			if(!$result)
			{
				echo LIN_PREFIX.$translation_array[$key].' ';
				echo failed_msg();
				echo ' '.$linpha->db->ErrorMsg().'<br />';
				$error_nr = 1;
			}
		}
		/**
		 * take care of oracle seqeunces and triggers
		 */
		if($_SESSION['sql_dbtype'] == 'oci8po')
		{
			echo tr("Creating Sequences")."...<br /> ";
			
			/**
			 * create sequences
			 */
			while( list($key, $query) = each($sql_sequence) )
			{
				$result = $linpha->db->Execute($query);
				if(!$result)
				{
					echo tr("Failed To Create Sequence for [$key].");
					echo failed_msg();
					echo ' '.$linpha->db->ErrorMsg().'<br />';
					$error_nr = 1;
				}
			}
	
			/**
			 * create triggers
			 */
			echo tr("Creating Triggers")."...<br /> ";
			while( list($key, $query) = each($sql_trigger) )
			{
				$result = $linpha->db->Execute($query);
				if(!$result)
				{
					echo tr("Failed To Create Trigger for [$key].");
					echo failed_msg();
					echo ' '.$linpha->db->ErrorMsg().'<br />';
					$error_nr = 1;
				}
			}
		}
		 
		if(!isset($error_nr))
		{
			echo success_msg();
		}
		else
		{
			$show_next_button = false;
			include_once(LINPHA_DIR.'/install/footer.php');
			exit(1);
		}

/**
 * insert data
 */
 	echo "<br /><br />".tr("Inserting Table Data")."... ";
	include_once(LINPHA_DIR.'/install/sql/sql.data.php');
	foreach($sql_queries AS $value)
	{
		$result = $linpha->db->Execute($value);
		if(!$result)
		{
			echo failed_msg();
			echo $value;
			echo ' '.$linpha->db->ErrorMsg().'<br />';
			$error_nr = 1;
		}
	}
	if(!isset($error_nr))
	{
		echo success_msg();
	}
	else
	{
		$show_next_button = false;
		include_once(LINPHA_DIR.'/install/footer.php');
		exit(1);
	}

/**
 * create directories
 */	
	/**
	 * create cache directories
	 */
	echo "<br /><br />".tr("Creating Cache Directories")."... ";
	mkdir(installGetFullPath( $_SESSION['cache_dir'] ).'/img', 0700);
	mkdir(installGetFullPath( $_SESSION['cache_dir'] ).'/thumb', 0700);
	
	echo success_msg();

/**
 * create config files
 */
	/**
	 * create config.dir.php file
	 */
		echo "<br /><br />".tr("Writing config.dir.php File")."... ";
		$fp = fopen(LINPHA_DIR."/var/config.dir.php","w+");
		if($fp)
		{
			$comment[1] = '';
			include_once(LINPHA_DIR.'/install/sql/config.dir.php');
		
			fwrite( $fp, $str );
			fclose($fp);
			
			if(!@chmod(LINPHA_DIR."/var/config.dir.php", 0600))
			{
				echo warning_msg().'<br />';
				echo tr("Chmod Failed For config.dir.php")."<br />";
			}
			else
			{
				echo success_msg();
			}
		}
		else
		{
			echo failed_msg();
			$show_next_button = false;
			include_once(LINPHA_DIR.'/install/footer.php');
			exit(1);
		}

	/**
	 * create config.sql.php file
	 */
		echo "<br />".tr("Writing config.sql.php File")."... ";
		$fp = fopen( installGetFullPath( $_SESSION['sql_dir'] )."/config.sql.php","w+" );
		if($fp)
		{
			$comment[1] = ''; 
			$comment[2] = ''; 
			$comment[3] = ''; 
			$comment[4] = ''; 
			$comment[5] = ''; 
			$comment[6] = '';
			$comment[7] = '';
			
			include_once(LINPHA_DIR.'/install/sql/config.sql.php');
		
			fwrite( $fp, $str );
			fclose($fp);
			
			if( !@chmod( installGetFullPath( $_SESSION['sql_dir'] )."/config.sql.php", 0600 ) )
			{
				echo warning_msg().'<br />';
				echo tr("Chmod Failed For config.sql.php")."<br />";
			}
			else
			{
				echo success_msg();
			}
		}
		else
		{
			echo failed_msg();
			$show_next_button = false;
			include_once(LINPHA_DIR.'/install/footer.php');
			exit(1);
		}

include_once(LINPHA_DIR.'/install/footer.php');
?>