<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * This is the base class which needs to be included. It takes care of 
 * including a number of class files and sets up basic things.
 */
if(!defined('LINPHA_DIR')) { exit(1); }

include_once(LINPHA_DIR.'/lib/classes/linpha.sql.class.php');
include_once(LINPHA_DIR.'/lib/classes/linpha.template.class.php');

include_once(LINPHA_DIR.'/lib/classes/linpha.image.class.php');
include_once(LINPHA_DIR.'/lib/classes/linpha.filesys.class.php');
include_once(LINPHA_DIR.'/lib/classes/linpha.import.class.php');
include_once(LINPHA_DIR.'/lib/classes/linpha.identify.class.php');
include_once(LINPHA_DIR.'/lib/classes/linpha.metadata.class.php');
include_once(LINPHA_DIR.'/lib/classes/linpha.functions.php');

/**
 * @todo remove include - just for testing language stuff
 */
include_once(LINPHA_DIR.'/lib/lang/lang.German.php');

class Linpha
{
	public $db, $sql, $template;

function __construct()
{
	$this->sql = new LinSql();

	/**
	 * some defines
	 */
		if(!defined('LINPHA_LINK'))
		{
			if( strpos($_SERVER['PHP_SELF'],'index.php') !== false )
			{
				$new_phpself = substr($_SERVER['PHP_SELF'],0,strlen($_SERVER['PHP_SELF'])-strlen('index.php'));
			}
			else
			{
				$new_phpself = $_SERVER['PHP_SELF'];
			}
	
	
			// append '?' to easier append later variables
			if( strpos($new_phpself,'?') === false )
			{
				define('LINPHA_LINK',$new_phpself.'?');
			}
			else
			{
				define('LINPHA_LINK',$new_phpself);
			}
		}
		
		if(!defined('LINPHA_CLIENT'))
		{
			define('LINPHA_CLIENT', LinFilesys::cleanPath( dirname($_SERVER['PHP_SELF']).'/'.LINPHA_DIR ) );
		}

	/**
	 * installation check
	 */
	 	if(!isset($_SESSION['installmode2']))
	 	{ 		
			if(! file_exists( LINPHA_DIR.'/var/config.dir.php') )
			{
				header('Location: '.LINPHA_CLIENT.'/install/');
				exit();
			}
			
			if( file_exists( LINPHA_DIR.'/install' ) && !file_exists(LINPHA_DIR.'/install/ignore_delete_install_msg.txt') )
			{
				echo "For security reasons, you have to delete the <b>./install</b> folder before you can continue!";
				exit();
			}
	 	}
}

} // end class Linpha

?>