<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn 
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * This class takes care of LinPHAs template layouts
 * @package Template 
 */
class LinTemplate
{
	public $template_name, $layout_name;
	public $layoutimagespath;
	public $output;
	public $URL_base, $URL_full, $idCurrent;
	public $hideMenu = false, $hideTitle = false;

	public $bgcolor, $bodybgcolor, $fontcolor, $albumsbgcolor, $linkscolor, $linkshovercolor;

	
	private $body_name;
	private $head_name;
	private $css_name;
	
	function __construct()
	{
		$this->idCurrent = 0;
		
		/**
		 * @todo secure template_name and layout_name because they are used in include()
		 */
		$this->template_name = $GLOBALS['linpha']->sql->config->value['sys_style_layout_template'];
		$this->layout_name = $GLOBALS['linpha']->sql->config->value['sys_style_layout_theme'];
		$this->linpha_title = $GLOBALS['linpha']->sql->config->value['sys_style_layout_title'];

		$this->bgcolor = $GLOBALS['linpha']->sql->config->value['sys_style_layout_color_elembg'];
		$this->bodybgcolor = $GLOBALS['linpha']->sql->config->value['sys_style_layout_color_bodybg'];
		$this->fontcolor = $GLOBALS['linpha']->sql->config->value['sys_style_layout_color_font'];
		$this->albumsbgcolor = $GLOBALS['linpha']->sql->config->value['sys_style_layout_color_albumsbg'];
		$this->linkscolor = $GLOBALS['linpha']->sql->config->value['sys_style_layout_color_links'];
		$this->linkshovercolor = $GLOBALS['linpha']->sql->config->value['sys_style_layout_color_linkshover'];
	}
	
	/**
	 * include the file requested, take care of css, its not included!
	 */
	function includeFile($what)
	{
		global $linTpl;
		
		switch($what)
		{
		case 'body':
			$filename = LINPHA_DIR.'/templates/'.$this->template_name.'/'.$this->body_name.'.html.php';
			if(file_exists($filename))
			{
				include_once( $filename );
			}

			break;
		case 'head':
/**
 * do some common definitions in head
 */
?>
<!-- css includes -->

<!-- colorsettings.php -->
<link rel='stylesheet' href='<?php echo LINPHA_CLIENT.'/templates/'.$this->template_name.'/themes/default/colorsettings.php'.
	'?bg='.$this->bgcolor.'&amp;bodybg='.$this->bodybgcolor.'&amp;font='.$this->fontcolor.
	'&amp;albumsbg='.$this->albumsbgcolor.'&amp;links='.$this->linkscolor.'&amp;linkshover='.$this->linkshovercolor; ?>' type='text/css'>  
<?php if($this->layout_name != 'default' &&
	file_exists(LINPHA_DIR.'/templates/'.$this->template_name.'/themes/'.$this->layout_name.'/colorsettings.php'))
{ ?>
<link rel='stylesheet' href='<?php echo LINPHA_CLIENT.'/templates/'.$this->template_name.'/themes/'.$this->layout_name."/colorsettings.php?bg=".
		$this->bgcolor."&amp;bodybg=".$this->bodybgcolor."&amp;font=".$this->fontcolor.
		"&amp;albumsbg=".$this->albumsbgcolor."&amp;links=".$this->linkscolor."&amp;linkshover=".$this->linkshovercolor; ?>' type='text/css'>  
<?php } ?>

<!-- global.css -->
<link rel='stylesheet' href='<?php echo LINPHA_CLIENT.'/templates/'.$this->template_name.'/themes/default/css/global.css'; ?>' type='text/css'>
<?php if($this->layout_name != 'default' &&
	file_exists(LINPHA_DIR.'/templates/'.$this->template_name.'/themes/'.$this->layout_name.'/css/global.css'))
{ ?>
<link rel='stylesheet' href='<?php echo LINPHA_CLIENT.'/templates/'.$this->template_name.'/themes/'.$this->layout_name.'/css/global.css'; ?>' type='text/css'>  
<?php } ?>

<!-- body css -->
<link rel='stylesheet' href='<?php echo LINPHA_CLIENT.'/templates/'.$this->template_name.'/themes/default/css/'.$this->css_name.'.css'; ?>' type='text/css'>
<?php if($this->layout_name != 'default' &&
	file_exists(LINPHA_DIR.'/templates/'.$this->template_name.'/themes/'.$this->layout_name.'/css/'.$this->css_name.'.css'))
{ ?>
<link rel='stylesheet' href='<?php echo LINPHA_CLIENT.'/templates/'.$this->template_name.'/themes/'.$this->layout_name.'/css/'.$this->css_name.'.css'; ?>' type='text/css'>
<?php } ?>

	<!--[if IE]>
	<style type="text/css" media="screen">
	#menu ul { width: 1em; }	/* this will be a *min* width */
	#menu ul ul { width: 12em; }
	#menu ul li { float: left; width: 100%; }
<?php /*	</style>
	<![endif]-->
	<!--[if lt IE 7]>
	<style type="text/css" media="screen">*/ ?>
	body { behavior: url(<?php echo LINPHA_CLIENT; ?>/templates/misc/csshover.htc); font-size: 100%; }
	#menu ul li a { height: 1%; } 
	#menu a, #menu span { font: bold 0.7em/1.4em arial, helvetica, sans-serif; }
	</style>
	<![endif]-->

<script type="text/javascript" language="JavaScript"  src="<?php echo LINPHA_CLIENT; ?>/lib/js/prototype.js"></script>
<script type="text/javascript" language="JavaScript"  src="<?php echo LINPHA_CLIENT; ?>/lib/js/LinGlobal.js"></script>
<script type="text/javascript" language="JavaScript">
var LINPHA_LINK = '<?php echo LINPHA_LINK; ?>';
var LINPHA_CLIENT = '<?php echo LINPHA_CLIENT; ?>';
var linUrlBase = '<?php echo linConvertAmp($linTpl->URL_base); ?>';
var startIdCurrent = <?php echo $this->idCurrent; ?>;
var IdCurrent = startIdCurrent;
<?php
if(! isset($_SESSION['use_js']) && ! isset($_SESSION['disable_ajax']))
{
	echo "myLinGlobal.checkAjaxCompatibility();"."\n";
}
?>
</script>

<?php
			$filename = LINPHA_DIR.'/templates/'.$this->template_name.'/'.$this->head_name.'.head.php';
			if(file_exists($filename))
			{
				include_once( $filename );
			}

			break;

		}
	}
	
	function setModuleName($name)
	{
		$this->body_name = $name;
		$this->head_name = $name;
		$this->css_name = $name;
	}
	
	function overrideModule($what,$name)
	{
		switch($what)
		{
		case 'body':
			$this->body_name = $name;
			break;
		case 'head':
			$this->head_name = $name;
			break;
		case 'css':
			$this->css_name = $name;
			break;
		}		
	}

	/**
	 * print the whole menu
	 * @uses  global.html.php, module.ajax.php
	 */
	function printMenus($modules,$comingfrom_ajax=false)
	{
		$array = explode(',',$modules);
		foreach($array AS $value)
		{
			switch($value)
			{
			case 'more':
				if( isset( $this->output['menu_More'] ) ) {
					$this->printMenu("More");
				}
			break;
			case 'settings':
				if($GLOBALS['linpha']->sql->isLoggedIn()) {
					echo '<!-- my settings -->'."\n";
					$this->printMenu("My Settings",LINPHA_LINK."&amp;linCat=settings");
				}
			break;
			case 'admin':
				if($GLOBALS['linpha']->sql->isLoggedIn()) {
					echo '<!-- admin links -->'."\n";
					$this->printMenu("Admin",LINPHA_CLIENT."/admin/");
				}
			break;
			default:	// all other, like home, search, login, guestbook, icons, more
				$fragment = 'menu_'.$value;
				include(LINPHA_DIR.'/templates/'.$this->template_name.'/fragments.php');
			break;
			}
		}

		if($comingfrom_ajax && isset($this->output['sys_log']) && !empty($this->output['sys_log']))
		{
			echo '<script language="JavaScript" type="text/javascript">myLinGlobal.linSyslog("'.$this->output['sys_log'].'");</script>';
		}
	}
	
	/**
	 * print the main menu entries (more, admin, ...)
	 */
	function printMenu($index,$link='')
	{
		if( ! isset( $GLOBALS['linpha']->template->output['menu_'.$index] ) )
		{
			echo "\n".'<ul>'."\n";
			echo "\t".'<li><a href="'.$link.'">'.i18n($index).'</a>'."\n";
			echo "\n".'</ul>'."\n";			
		}
		else
		{
			echo "\n".'<ul>'."\n";
			if(!empty($link))
			{
				echo "\t".'<li><a href="'.$link.'">'.i18n($index).'</a>'."\n";
			}
			else
			{
				echo "\t".'<li><span>'.i18n($index).'&nbsp;&nbsp;</span>'."\n";
			}
			echo "\n".'<ul id="linMenu'.$index.'" onmouseover="myLinGlobal.reloadMenu()">'."\n";
	
			foreach($GLOBALS['linpha']->template->output['menu_'.$index] AS $key=>$value)
			{
				if(!is_array($value['value']))
				{
					if(isset($value['target'])) {
						$target_str = ' target="'.$value['target'].'"';
					} else {
						$target_str = '';
					}
					
					if(isset($value['id'])) {
						$id_str = ' id="'.$value['id'].'"';
					} else {
						$id_str = '';
					}

					echo "\t".'<li'.$id_str.'><a href="'.$value['value'].'"'.$target_str.'>'.$value['name'].'</a></li>'."\n";  
				}
				else
				{
					echo "\t".'<li><span>'.$value['name'].'&nbsp;&nbsp;</span>'."\n";
		
					echo "\t".'<ul>'."\n";
								
					foreach($value['value'] AS $sub_value)
					{
						if(!is_array($sub_value['value']))
						{
							if(isset($sub_value['target'])) {
								$target_str = ' target="'.$sub_value['target'].'"';
							} else {
								$target_str = '';
							}
							
							if(isset($sub_value['id'])) {
								$id_str = ' id="'.$sub_value['id'].'"';
							} else {
								$id_str = '';
							}
							
							echo "\t\t".'<li'.$id_str.'><a href="'.$sub_value['value'].'"'.$target_str.'>'.$sub_value['name'].'</a></li>'."\n";
						}
						else
						{
							echo  "\t\t".'<li><span>'.$sub_value['name'].'&nbsp;&nbsp;</span>'."\n";
				
							echo  "\t\t".'<ul>'."\n";
										
							foreach($sub_value['value'] AS $subsub_value)
							{
								if(isset($subsub_value['target'])) {
									$target_str = ' target="'.$subsub_value['target'].'"';
								} else {
									$target_str = '';
								}

								if(isset($subsub_value['id'])) {
									$id_str = ' id="'.$subsub_value['id'].'"';
								} else {
									$id_str = '';
								}

								echo "\t\t\t".'<li'.$id_str.'><a href="'.$subsub_value['value'].'"'.$target_str.'>'.$subsub_value['name'].'</a></li>'."\n";

							}
							
							echo  "\t\t".'</ul>'."\n";
							echo "\t\t".'</li>'."\n";
						}
					}
					
					echo  "\t".'</ul>'."\n";
					echo  "\t".'</li>'."\n";
				}
			}
	
			echo  "\t".'</ul>'."\n";
			echo  "\t".'</li>'."\n";
			echo  '</ul>'."\n";
		}
	}

	/**
	 * rounded corner stuff
	 */
	function divRoundCorners($top_bottom,$alpha='',$type='')
	{
		$size = 15;
		
		if(empty($type))	// default
		{
			$color = $this->bgcolor;
			$bgcolor = $this->bodybgcolor;
		}
		elseif($type=='albums')
		{
			$color = $this->albumsbgcolor;
			$bgcolor = $this->bgcolor;
		}

		if($top_bottom == 'top')
		{
			$alignleft = 'tl';
			$alignright = 'tr';
		}
		elseif($top_bottom == 'bottom')
		{
			$alignleft = 'bl';
			$alignright = 'br';
		}

		if(empty($alpha))	// default
		{
			$str = '<div style="background: url('.LINPHA_CLIENT.'/templates/misc/roundcorners.php?color='.$color.'&amp;bgcolor='.$bgcolor.'&amp;size='.$size.'&amp;align='.$alignright.') no-repeat top right;">';
			$str .= '<img src="'.LINPHA_CLIENT.'/templates/misc/roundcorners.php?color='.$color.'&amp;bgcolor='.$bgcolor.'&amp;size='.$size.'&amp;align='.$alignleft.'" alt="" width="'.$size.'" height="'.$size.'" />';
			$str .= '</div>';
		}
		else	// currently only used in slideshow, does not work well in internet explorer
		{
			$str = '<div style="position: relative; background: url('.LINPHA_CLIENT.'/templates/misc/roundcorners.php?color='.$color.'&amp;bgcolor='.$bgcolor.'&amp;size='.$size.'&amp;alpha&amp;align='.$alignright.') no-repeat top right;">';
			$str .= '<div class="roundAlphabottomInner">&nbsp;</div>';
			$str .= '<img src="'.LINPHA_CLIENT.'/templates/misc/roundcorners.php?color='.$color.'&amp;bgcolor='.$bgcolor.'&amp;size='.$size.'&amp;align='.$alignleft.'&amp;alpha" alt="" width="'.$size.'" height="'.$size.'" class="AlphaCorner" />';
			$str .= '</div>';
		}
		
		return $str;
	}

	function themeFile( $filename )
	{
		if( file_exists( LINPHA_DIR.'/templates/'.$this->template_name.'/themes/'.$this->layout_name.'/'.$filename )  )
		{
			return LINPHA_CLIENT.'/templates/'.$this->template_name.'/themes/'.$this->layout_name.'/'.$filename;
		}
		else
		{
			return LINPHA_CLIENT.'/templates/'.$this->template_name.'/themes/default/'.$filename;
		}
	}
} // end class linTemplate

?>