<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','../..'); }
if(!defined('LINPHA2_INC')) { die("ERROR: Direct access forbidden."); }

/**
 * This class takes care of all common operations in the linpha template system.
 * @param string Template name
 */
class Template 
{

public $template_name;

	function __construct($template_name)
	{	
		if(strlen($template_name) < "1")
		{
			throw new Exception("ERROR: No template name defined " .
					"while starting new instance of class Template " .
					"<br>LOCATION: linpha.template.class.php. Please " .
					"set template name in main.php");
		}
		else
		{
			$this -> template_name = "$template_name";
		}
	}

	/**
	 * Init valid XHTML header
	 * @todo set language, charset and title
	 */
	function linXhtmlHeader()
	{
	?>
		<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
			"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

		<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en-AU">

		<head>

		<meta http-equiv="content-type" content="application/xhtml+xml; charset=UTF-8"/>
		<meta name="author" content="The LinPHA Developers" />
		<meta name="keywords" content="Linpha album fotoalbum gallery " .
			"galerie archive Archiv image Bilder Fotos PHP Photo ".
			"Bildergalerie Webalbum" />
		<meta name="description" content="The LinPHA2 Photo Archive" />

		<title>LinPHA - The PHP Photo Archive</title>

		<link rel="stylesheet" type="text/css" 
			href="<?php echo LINPHA_DIR;?>/templates/<?php echo $this->template_name;?>/css/style.css" />
		
		</head>		
		<?php echo LINPHA_DIR;?>
	<?php
	}

} // end class
?>