<?php
/*
* Copyright (c) 2004 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
* File to create the print images
*/

if(!defined('LINPHA_DIR')) { exit(1); }


?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>LinPHA - <?php echo i18n("Basket")." - ".i18n("Print"); ?></title>
<style>
.page_break {
	page-break-before: always;
}
</style>
</head>

<body bgcolor='#FFFFFF'>

<?php

/**
 * 2 photos/page (10x15cm)
 */ 
$printsettings[2]['w'] = 425;
$printsettings[2]['h'] = 319;
$printsettings[2]['show_filenames'] = 0;
$printsettings[2]['cols'] = 1;
$printsettings[2]['rows_per_page'] = 2;

/**
 * 4 photos/page (9x13cm)
 */
$printsettings[4]['w'] = 277;
$printsettings[4]['h'] = 369;
$printsettings[4]['show_filenames'] = 0;
$printsettings[4]['cols'] = 2;
$printsettings[4]['rows_per_page'] = 2;

/**
 * 8 photos/page (6,5x9cm)
 */
$printsettings[8]['w'] = 235;
$printsettings[8]['h'] = 180;
$printsettings[8]['show_filenames'] = 0;
$printsettings[8]['cols'] = 2;
$printsettings[8]['rows_per_page'] = 4;

/**
 * 16 photos/page (4,5x6,5cm)
 */ 
$printsettings[16]['w'] = 136;
$printsettings[16]['h'] = 180;
$printsettings[16]['show_filenames'] = 0;
$printsettings[16]['cols'] = 4;
$printsettings[16]['rows_per_page'] = 4;

/**
 * photo index
 */ 
$printsettings[28]['w'] = 120;
$printsettings[28]['h'] = 90;
$printsettings[28]['show_filenames'] = 1;
$printsettings[28]['cols'] = 4;
$printsettings[28]['rows_per_page'] = 7;

$print_h = $printsettings[$_POST['images']]['h'];
$print_w = $printsettings[$_POST['images']]['w'];

/**
 * create table
 */
?>

<table border="1" align="center" cellspacing="0" cellpadding="0">
<tr>

<?php

$row_counter = 0;
$col_counter = 0;

/**
 * read array with images to print
 */
reset($_SESSION['basket_ids']);
while(list($key, $image_id) = each($_SESSION['basket_ids']))
{

	$full_filename = LinSql::getFullImagePath( $image_id );

	/**
	 * orientation stuff
	 */
	list($org_width,$org_height,$org_type) = LinIdentify::linGetImageSize($full_filename);
	
	if(LinIdentify::isSupportedImage($org_type))
	{
		$col_counter++;


		/**
		 * need rotate?
		 */
		$array = LinImage::scaleToFit($org_width,$org_height,$print_w,$print_h);
		$unrotated_surface = $array['w'] * $array['h'];

		$array = LinImage::scaleToFit($org_height,$org_width,$print_h,$print_w,0);
		$rotated_surface = $array['w'] * $array['h'];
		
		if($rotated_surface > $unrotated_surface)	// which surface is bigger?
		{
			$rotate = 1;
			
			/**
			 * flip width and height because of rotation
			 */
			$rotated_width = $org_height;
			$rotated_height = $org_width;
		} else{
			$rotate = 0;
			$rotated_width = $org_width;
			$rotated_height = $org_height;
		}

		$array = LinImage::scaleToFit($rotated_width,$rotated_height,$print_w,$print_h);
		$img_w = $array['w'];
		$img_h = $array['h'];

	
		if($_POST['l_or_h_quality'] == 'h')
		{
			$nh = $org_height;
			$nw = $org_width;
		} else {
			$nh = $img_h;
			$nw = $img_w;
		}
		
		/**
		 * on rotate, we have to flip $nw and $nh
		 */
		if($rotate) {
			$tmp = $nh;
			$nh = $nw;
			$nw = $tmp;
			unset($tmp);
		}

		/**
		 * thumbnail
		 */
		echo "\n\t\t".'<td width="'.$print_w.'" height="'.$print_h.'">';
		echo '<img width="'.$img_w.'" height="'.$img_h.'" '.
				'src="'.LINPHA_CLIENT.'/get_image.php?'.
				'linId='.$image_id.'&amp;'.
				'width='.$nw.'&amp;'.
				'height='.$nh.'&amp;'.
				($_POST['l_or_h_quality'] == 'h' ? "quality=80&amp;" : '').	// if high quality selected, set quality to 80 (anything higher than 80 isn't meaningful), if low quality selected, no quality is given, and so get_thumbs_on_fly.php takes the default quality
				'rotate='.$rotate.'">';

		if($printsettings[$_POST['images']]['show_filenames']) {
			echo "<br/><font size='-1'>";
			echo linCutString(basename($full_filename),15,0);
			echo "</font>";
		}
		
		echo '</td>'."\n";


		/**
		 * row break
		 */
		if($col_counter == $printsettings[$_POST['images']]['cols'])
		{
			?>
</tr>
<tr>

			<?php
			$col_counter = 0;
			$row_counter++;
		}
	
	
		/**
		 * pagebreak after x rows
		 */
		if($row_counter == $printsettings[$_POST['images']]['rows_per_page'])
		{
			?>

</tr>
</table>
<div class="page_break"></div>
<table border="1" align="center" cellspacing="0" cellpadding="0">
<tr>

			<?php
			$row_counter = 0;
			$col_counter = 0;
		}
	}
}
?>

</tr>
</table>

</body>
</html>