<?php
if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * some common used stuff
 * 
 * always include this file which has no "if(!defined('LINPHA_DIR')) { exit(1); }" on top
 * that means:
 * - index.php, get_image.php, get_thumb.php
 * - admin/index.php
 * - lib/include/calendar.php, lib/lang/language.php,
 * - install/index.php, install/step*
 */
	define('LINPHA_VERSION','2.0 alpha 1');

/**
 * Magic Quotes stuff
 */
	/**
	* always include this file with *include_once* to prevent multiple remove of magic quotes!
	*
	* Magic-quotes was added to reduce code written by beginners from being dangerous.
	* If you disable magic quotes, you must be very careful
	* to protect yourself from SQL injection attacks.
	* For details see http://www.php.net/manual/en/function.get-magic-quotes-gpc.php
	* 
	* There is also a nice UnifyMagicQuotes() function in the getid3 library...
	*
	* @author  flo
	*/
	
	/**
	* Disabling magic quotes at runtime
	* for example fread()
	*/
	set_magic_quotes_runtime(0);
	
	/**
	* Remove magic quotes for get, post and cookie data
	* We can't disable it, because we are already too late
	* It could also be done with a directive in a .htaccess file
	* (php_value magic_quotes_gpc 0)
	*/
	if (get_magic_quotes_gpc()) {
		function stripslashes_deep($value)
		{
			$value = is_array($value) ?
				array_map('stripslashes_deep', $value) :
				stripslashes($value);
			
			return $value;
		}
		
		$_POST = array_map('stripslashes_deep', $_POST);
		$_GET = array_map('stripslashes_deep', $_GET);
		$_COOKIE = array_map('stripslashes_deep', $_COOKIE);
		$_REQUEST = array_map('stripslashes_deep', $_REQUEST);
		
		/**
		* http://php3.de/manual/de/features.file-upload.php
		* Note that with magic_quotes_gpc on, the uploaded filename
		* has backslashes added *but the tmp_name does not*.
		* On Windows where the tmp_name path includes backslashes,
		* you *must not* run stripslashes() on the tmp_name,
		* so keep that in mind when de-magic_quotes-izing your input.
		*
		* -> do not stripslashes on whole array, but only on $_FILES[*]['name']
		*/
		foreach($_FILES AS $key=>$value)
		{
			$_FILES[$key]['name'] = stripslashes($_FILES[$key]['name']);
		}
		
		$HTTP_GET_VARS    = $_GET;
		$HTTP_POST_VARS   = $_POST;
		$HTTP_COOKIE_VARS = $_COOKIE;
	}

/**
 * secure PHP_SELF
 * 
 * added from linpha1 patch 1432469
 * 
 * short description:
 * with the url http://example.com/tests/simple.php/%22%3E%3Cscript%3Ealert('xss')%3C/script%3E%3Cfoo
 * PHP_SELF is: /tests/simple.php/"><script>alert('xss')</script><foo
 * and thats dangerous
 * 
 * further details about the PHP_SELF XSS problem:
 * http://blog.phpdoc.info/archives/13-XSS-Woes.html
 */
	/**
	 * Added by Roland Haeder <webmaster@mxchange.org>
	 *
	 * This code came from my free mailexchange script called 'MXChange'
	 * Please refer the pages on http://www.mxchange.org for further details
	 *
	 */
	// Secure the PHP_SELF variable by first making all HTML code unuseable
	$_SERVER['PHP_SELF'] = htmlentities($_SERVER['PHP_SELF']);
	
	// Split it up into path and filename
	$SELF_DIR  = dirname($_SERVER['PHP_SELF']);
	$SELF_FILE = basename($_SERVER['PHP_SELF']);
	
	// Check for a .php inside the $SELF_DIR...
	while (ereg(".php", $SELF_DIR))
	{
		// Correct the dirname
		$SELF_DIR = substr($SELF_DIR, 0, (strpos($SELF_DIR, ".php") + 4));
		// Rewrite filename...
		$SELF_FILE = basename($SELF_DIR);
		// ... and dirname
		$SELF_DIR = dirname($SELF_DIR);
	}
	
	// Put both together again and let's pray it is secured now...
	$_SERVER['PHP_SELF'] = $SELF_DIR."/".$SELF_FILE;
	
	// Remove uneccessary variables
	unset($SELF_DIR);
	unset($SELF_FILE);

/**
 * some defines
 */
if(strtoupper(substr(PHP_OS,0,3)) == 'WIN')
{
	define('LIN_NL',"\r\n");
	define('LIN_OS',"win");
}
else
{
	define('LIN_NL',"\n");
	define('LIN_OS',"unix");
}

?>