<?php
/*
* Copyright (c) 2006 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * This is the base class which needs to be included. It takes care of 
 * including a number of class files and sets up basic things.
 */
if(!defined('LINPHA_DIR')) { exit(1); }

try
{
/**
 * check folders
 */
	/**
	 * album folder
	 */
	$dir = LinSql::getPath('album');
	if( ! file_exists($dir) )
	{
		throw new Exception(i18n("Directoy Not Existing").": ".i18n("Album").": ".$dir);
	}
	
	if( ! is_readable($dir) )
	{
		throw new Exception(i18n("Directoy Not Readable").": ".i18n("Album").": ".$dir);
	}
	
	/**
	 * tmp folder
	 */
	$dir = LinSql::getPath('tmp');
	if( ! file_exists($dir) )
	{
		throw new Exception(i18n("Directoy Not Existing").": ".i18n("Temp").": ".$dir);
	}
	
	if( ! is_writable($dir) )
	{
		throw new Exception(i18n("Directoy Not Writable").": ".i18n("Temp").": ".$dir);
	}

	/**
	 * cache folder
	 */
	$dir = LinSql::getPath('cache');
	if( ! file_exists($dir) )
	{
		throw new Exception(i18n("Directoy Not Existing").": ".i18n("Cache").": ".$dir);
	}
	
	if( ! is_writable($dir) )
	{
		throw new Exception(i18n("Directoy Not Writable").": ".i18n("Cache").": ".$dir);
	}


}
catch(Exception $error)
{
	die("Error: ".$error -> getMessage());
}

?>