
/**
 * class and global definitions
 */
var LinImage = Class.create();
var myLinImage;

LinImage.prototype = {
	
	/**
	 * initialize()
	 * 
	 * Constructor runs on completion of the DOM loading.
	 */
	initialize: function()
	{
		this.imgInfoColorNotActive = $('linDivInfoLink').style.color;
		this.imgInfoColorActive = $('linHrefInfoLink').style.color;
		this.imgInfoShowHide = 'hide';


		this.fullscreenActive = false;
		this.fullscreenOldMaxWidth, this.fullscreenOldMaxHeight, this.previousBodyOverflow;
		this.slideshowActive = false;
		this.ssCurrentTimerID;
		this.ssCurrentDelay = 5000;
		this.ssRandom = false;
		this.ssLoop = false;
		
		this.xmlDoc = new Array();
		this.nextThumbs = new Array();
		this.prevThumbs = new Array();
		this.preloadImageSrc = new Array();	// image array, will contain a lot of preloaded images
		this.finishedPreloadedImages = new Array();	// set to true after preload completed
		this.preloadXmlFinished = new Array();
		
		this.currentFileType;			// 1 = image, 2 = video, 3 = others
		
		this.curLocationHash;
		this.timerResize;
		
		this.testarray = new Array();
		this.testarray[0] = 'test 2';

	},


	// -----------------------------------------------------------------------------------
	// functions to load xml data of images
	// -----------------------------------------------------------------------------------

	loadImage: function(imgId) {
		if(IdCurrent != imgId)
		{
			IdCurrent = imgId;
			//myLinGlobal.menuNeedsUpdating = true;	// IdCurrent changed, update menu on next hover of the menu
			location.hash = 'idCurrent='+IdCurrent;
		}

		this.curLocationHash = location.hash;	// update current Hash, this value is periodically checked to reload the image if neccessary

		if(this.preloadXmlFinished[imgId] && typeof this.xmlDoc[imgId] != "undefined" )	// use typeof to work in IE
		{
			this.changeImage();
		}
		else
		{
			this.loadImageXml(imgId);
		}
	},
	
	loadImageXml: function(imgId) {
		// http://wiki.script.aculo.us/scriptaculous/show/Ajax.Request
		new Ajax.Request(
			xmlUrl + '&linId=' + imgId + '&xml',
			{
				method:'get',
				asynchronous:true,
				onSuccess:this.loadImageContinue,
				onFailure: function(t) { alert('Error ' + t.status + ' -- ' + t.statusText); }
			}
		);
	},

	loadImageContinue: function(t) {
		var loadedimgid = t.responseXML.documentElement.getElementsByTagName('imgid').item(0).firstChild.data;

		// save xml data
		myLinImage.xmlDoc[loadedimgid] = t.responseXML.documentElement;
		myLinImage.preloadXmlFinished[loadedimgid] = true;

		if( loadedimgid == IdCurrent )	// coming from loadImage()
		{
			myLinImage.changeImage();
		}
		else	// coming from preloadImage()
		{
			myLinImage.preloadImage(loadedimgid);
		}
	},


	// -----------------------------------------------------------------------------------
	// Navigation functions
	// -----------------------------------------------------------------------------------

	movePrev: function() {
		if( this.slideshowActive )
		{
			clearTimeout(this.ssCurrentTimerID);
		}

		if(this.prevThumbs[ this.prevThumbs.length - 1 ]) 
		{
			Element.setOpacity('linSsImgPrev',0.7);
			new Effect.Appear('linSsImgPrev', { duration: 0.5, from: 0.7, to: 1.0 });
			myLinImage.loadImage(this.prevThumbs[ this.prevThumbs.length - 1 ]);
			
			if( this.slideshowActive )
			{
				clearTimeout(this.ssCurrentTimerID);
				this.ssCurrentTimerID = setTimeout("myLinImage.slideshowPlay()", this.ssCurrentDelay);
			}
		}
		else	// end reached, do nothing but enable keyboard navigation again
		{
			myLinImage.enableKeyboardNav();
		}

		if( this.slideshowActive )
		{
			this.ssCurrentTimerID = setTimeout("myLinImage.slideshowPlay()", this.ssCurrentDelay);
		}
	},
	moveNext: function() {
		if( this.slideshowActive )
		{
			clearTimeout(this.ssCurrentTimerID);
		}

		if(this.nextThumbs[0])
		{
			Element.setOpacity('linSsImgNext',0.7);
			new Effect.Appear('linSsImgNext', { duration: 0.5, from: 0.7, to: 1.0 });
			myLinImage.loadImage(this.nextThumbs[0]);
		}
		else if( this.ssLoop )
		{
			Element.setOpacity('linSsImgNext',0.7);
			new Effect.Appear('linSsImgNext', { duration: 0.5, from: 0.7, to: 1.0 });
			this.moveFirst();
		}
		else	// end reached, do nothing but enable keyboard navigation again
		{
			myLinImage.enableKeyboardNav();
		}

		if( this.slideshowActive )
		{
			this.ssCurrentTimerID = setTimeout("myLinImage.slideshowPlay()", this.ssCurrentDelay);
		}
	},
	moveFirst: function() {
		if( this.slideshowActive )
		{
			clearTimeout(this.ssCurrentTimerID);
		}

		Element.setOpacity('linSsImgFirst',0.7);
		new Effect.Appear('linSsImgFirst', { duration: 0.5, from: 0.7, to: 1.0 });
		myLinImage.loadImage( firstImgId );

		if( this.slideshowActive )
		{
			this.ssCurrentTimerID = setTimeout("myLinImage.slideshowPlay()", this.ssCurrentDelay);
		}
	},
	moveLast: function() {
		if( this.slideshowActive )
		{
			clearTimeout(this.ssCurrentTimerID);
		}

		Element.setOpacity('linSsImgLast',0.7);
		new Effect.Appear('linSsImgLast', { duration: 0.5, from: 0.7, to: 1.0 });
		myLinImage.loadImage( lastImgId );

		if( this.slideshowActive )
		{
			this.ssCurrentTimerID = setTimeout("myLinImage.slideshowPlay()", this.ssCurrentDelay);
		}
	},

	// -----------------------------------------------------------------------------------
	// Change image functions
	// -----------------------------------------------------------------------------------

	/**
	 * changeImage()
	 */
	changeImage: function() {	
		
		/**
		 * set height of outer div to prevent the whole page getting smaller, and if the image is loaded getting bigger again
		 * but in fullscreen, we want no activities in background
		 */
		if(! this.fullscreenActive) {
			$('linDivMainimage').style.height = $('linImgMainimage').style.height;
			//$('linDivMain').style.height = $('linDivMain').offsetHeight;
			//alert($('linDivMain').offsetHeight);
		}

		/**
		 * hide elements during transition
		 */
		this.hideImgInfoNow();	// hide meta text immediately
		Element.hide('linImgMainimage');	// hide mainimage while changing image to prevent flicker
		Element.hide('linDivInfoLink');
		
		this.currentFileType = this.xmlDoc[IdCurrent].getElementsByTagName('filetype').item(0).firstChild.data;

		switch( this.currentFileType )
		{
		case '1':	// image

			if(! this.finishedPreloadedImages[IdCurrent] )
			{
				Element.show('linDivloading');
			}
			
			$('linImgMainimage').style.marginLeft = 0;
			
			/**
			 * calc image width and height
			 */
				var orgWidth = this.xmlDoc[IdCurrent].getElementsByTagName('imgwidth').item(0).firstChild.data;
				var orgHeight = this.xmlDoc[IdCurrent].getElementsByTagName('imgheight').item(0).firstChild.data;
				var sizeArray = this.scaleToFit(orgWidth,orgHeight,maxImageWidth,maxImageHeight,1);
				var imgWidth = sizeArray[0];
				var imgHeight = sizeArray[1];
	
			/**
			 * preload image
			 */
			var currentImgSrc = imageSrc + IdCurrent + '&width=' + imgWidth + '&height=' + imgHeight;
			imgPreloader = new Image();
			
			/**
			 * once image is preloaded, resize image container
			 * 
			 * pay attention with the other image preloader!
			 * if imgWidth and imgWidth was not set with trailing 'var' it got overlapping with the other variables
			 * and this caused the image not resized correctly in resizeImageContainer() !!!
			 */
			imgPreloader.onload=function(){
				myLinImage.finishedPreloadedImages[IdCurrent] = true;
				$('linImgMainimage').src = currentImgSrc;
				myLinImage.resizeImageContainer(imgWidth, imgHeight);
			}
			imgPreloader.src = currentImgSrc;

			break;
		case '2': // video

			$('linImgMainimage').style.marginLeft = 200;
			
			/**
			 * show video thumbnail
			 */
			$('linImgMainimage').src = thumbSrc + IdCurrent ;
			$('linImgMainimage').style.width = 'auto';
			$('linImgMainimage').style.height = 'auto';

			/**
			 * show image and set div height
			 */
			this.showImage();

			break;
		case '0':	// others
			break;
		}
	},

	/**
	 * resizeImageContainer()
	 */
	resizeImageContainer: function( imgWidth, imgHeight) {

		// get current height and width
		/*this.wCur = $('linImgMainimage').offsetWidth;
		this.hCur = $('linImgMainimage').offsetHeight;

		// scalars based on change from old to new
		this.xScale = ((imgWidth  + (borderSize * 2)) / this.wCur) * 100;
		this.yScale = ((imgHeight  + (borderSize * 2)) / this.hCur) * 100;

		// calculate size difference between new and old image, and resize if necessary
		wDiff = (this.wCur - borderSize * 2) - imgWidth;
		hDiff = (this.hCur - borderSize * 2) - imgHeight;

		if(!( hDiff == 0)){ new Effect.Scale('linImgMainimage', this.yScale, {scaleX: false, duration: resizeDuration, queue: 'front'}); }
		if(!( wDiff == 0)){ new Effect.Scale('linImgMainimage', this.xScale, {scaleY: false, delay: resizeDuration, duration: resizeDuration}); }

		// if new and old image are same size and no scaling transition is necessary, 
		// do a quick pause to prevent image flicker.
		if((hDiff == 0) && (wDiff == 0)){
			if (navigator.appVersion.indexOf("MSIE")!=-1){ pause(250); } else { pause(100);} 
		}*/

		$('linImgMainimage').style.width = imgWidth;
		$('linImgMainimage').style.height = imgHeight;

	
		/*Element.setHeight('prevLink', imgHeight);
		Element.setHeight('nextLink', imgHeight);
		Element.setWidth( 'imageDataContainer', imgWidth + (borderSize * 2));*/
		
		/**
		 * show panorama link
		 * the only reason why do this at this point is, because this is only done on images
		 * and we just know the width and height
		 */
		if( imgWidth/imgHeight >= 2 || imgHeight/imgWidth >= 2 )
		{
			Element.show('linHrefPanoLink');
		}

		this.showImage();
	},
	
	/**
	 * showImage()
	 * 
	 * Display image and begin preloading next images.
	 */
	showImage: function(){
		Element.hide('linDivloading');
		
		if( useEffects )
		{
			new Effect.Appear('linImgMainimage', { duration: 0.2, afterFinish: function(){   myLinImage.setImageData(); } });
		}
		else
		{
			Element.show('linImgMainimage');
			this.setImageData()
		}

		if(! this.fullscreenActive)
		{
			$('linDivMainimage').style.height = $('linImgMainimage').style.height;	// reset to correct height to prevent trouble if image is bigger or smaller
			//$('linDivMain').style.height = 'auto';
		}
	},

	/**
	 * setImageData()
	 */
	setImageData: function()
	{
		this.enableKeyboardNav();

		/**
		 * set title
		 */
		if( typeof $('linDivTitle') != 'undefined' )
		{
			$('linDivTitle').innerHTML = this.xmlDoc[IdCurrent].getElementsByTagName('title').item(0).firstChild.data;
		}

		/**
		 * update the menu
		 * 
		 * replace the image ids in the menu
		 * replace( /linId=[0-9]* /g , "linId=" + IdCurrent );
		 * its just an search/replace of 'linId=x' in the menu
		 * its very fast (about 0 - 15ms) and its executed every time the image changes
		 * 
		 * but only in menuMore and menuAdmin, because we have in menuLogin
		 * linId='+IdCurrent, and ooh this will create very unexpected results..!!
		 */
		if( typeof $('linMenuAdmin') != 'undefined' )
		{
			$('linMenuAdmin').innerHTML = $('linMenuAdmin').innerHTML.replace( /linId=[0-9]*/g , "linId=" + IdCurrent );			
		}

		/**
		 * menuMore
		 */
		if( typeof $('linMenuMore') != 'undefined' )
		{
			$('linMenuMore').innerHTML = $('linMenuMore').innerHTML.replace( /linId=[0-9]*/g , "linId=" + IdCurrent );
			
			/**
			 * replace the width and height dimensions of the view at fullscreen link
			 */
			var orgWidth = this.xmlDoc[IdCurrent].getElementsByTagName('imgwidth').item(0).firstChild.data;
			var orgHeight = this.xmlDoc[IdCurrent].getElementsByTagName('imgheight').item(0).firstChild.data;
			$('linLiViewAtFullscreen').innerHTML = $('linLiViewAtFullscreen').innerHTML.replace( /width=[0-9]*/ , "width=" + orgWidth );
			$('linLiViewAtFullscreen').innerHTML = $('linLiViewAtFullscreen').innerHTML.replace( /height=[0-9]*/ , "height=" + orgHeight );
			$('linLiViewAtFullscreen').innerHTML = $('linLiViewAtFullscreen').innerHTML.replace( /[0-9]*x[0-9]*/ , orgWidth + "x" + orgHeight );
		}

		/**
		 * set current thumb
		 */
		$('linDivThumbnavi_Current').innerHTML = '<a href="javascript:myLinImage.loadImage(' + IdCurrent + ')"><img class="linImgThumbnavi_Current" src="' + thumbSrc + IdCurrent + '" /></a>';
	
		/**
		 * set prev thumbs
		 */
		$('linDivThumbnavi_Prev').innerHTML = '';
		this.prevThumbs = new Array();
		if(this.xmlDoc[IdCurrent].getElementsByTagName('prevthumb').length > 0)
		{
			for(var i = 0; i < this.xmlDoc[IdCurrent].getElementsByTagName('prevthumb').length; i++)
			{
				var thumbId = this.xmlDoc[IdCurrent].getElementsByTagName('prevthumb').item(i).firstChild.data;
				this.prevThumbs[i] = thumbId;
				this.setPrevNextThumb(thumbId, 'linDivThumbnavi_Prev');
			}
		}
	
		/**
		 * set next thumbs
		 */
		$('linDivThumbnavi_Next').innerHTML = '';
		this.nextThumbs = new Array();
		if(this.xmlDoc[IdCurrent].getElementsByTagName('nextthumb').length > 0)
		{
			for(var i = 0; i < this.xmlDoc[IdCurrent].getElementsByTagName('nextthumb').length; i++)
			{
				var thumbId = this.xmlDoc[IdCurrent].getElementsByTagName('nextthumb').item(i).firstChild.data;
				this.nextThumbs[i] = thumbId;
				this.setPrevNextThumb(thumbId, 'linDivThumbnavi_Next');
			}
		}
		
		/**
		 * set meta data
		 */
		$('linDivMeta').innerHTML = '';
		if(this.xmlDoc[IdCurrent].getElementsByTagName('meta').length > 0)
		{
			var table = Builder.node('table', {id: 'linTableMeta'} );
			var tbody = Builder.node('tbody');

			for(var i = 0; i < this.xmlDoc[IdCurrent].getElementsByTagName('meta').length; i++)
			{
				var meta = this.xmlDoc[IdCurrent].getElementsByTagName('meta').item(i);
				var metaname = meta.getElementsByTagName('name').item(0).firstChild.data;
				if(meta.getElementsByTagName('value').item(0).hasChildNodes()) {	// prevent error in IE
					var metavalue = meta.getElementsByTagName('value').item(0).firstChild.data;
				} else {
					var metavalue = '';
				}

				var tr = Builder.node('tr');
				var tdleft = Builder.node('td', {className: 'linTdMetaLeftColumn'}, metaname );
				var tdright = Builder.node('td', metavalue );

				tr.appendChild(tdleft);
				tr.appendChild(tdright);
				tbody.appendChild(tr);
			}

			table.appendChild(tbody);
			
			$('linDivMeta').appendChild(table);

		}

		/**
		 * file type specific meta data stuff
		 */
		switch( this.currentFileType )
		{
		case '1':	// image
			this.setImageInfoLink();	// show the "info" link, must be called after Appear('linImgMainimage')

			Element.hide('linDivVideoLink');
			Element.show('linDivExifLink');
			
			break;
		case '2':	// video

			Element.show('linDivVideoLink');
			Element.hide('linDivExifLink');
			
			$('linDivMetaOuter').style.top = $('linImgMainimage').offsetTop;
			$('linDivMetaOuter').style.height = $('linImgMainimage').offsetHeight;	// 'auto'
			Element.show('linDivMetaOuter');

			break;
		}

		this.initTextareaAddComment();
		this.setComments();

		/**
		 * set image nr
		 * currently only in slideshow used
		 */
		$('linDivSlideshowImgNr').innerHTML = this.xmlDoc[IdCurrent].getElementsByTagName('imgnr').item(0).firstChild.data;
		
		
		/**
		 * and at last, start preloading next and previous images
		 */
		this.preloadXml();
		
	
	},
	
	/**
	 * setPrevNextThumb()
	 * 
	 * code to generate a thumbnail with a <div><a><img> tag
	 */
	setPrevNextThumb: function(thumbId, divId)
	{
		var ElemImg = Builder.node('img', {id: 'thumb'+thumbId, className: 'linImgThumbnavi_PrevNext', src: thumbSrc + thumbId});
		var ElemA = Builder.node('a', {href: 'javascript:myLinImage.loadImage(' + thumbId + ')'});
		var ElemDiv = Builder.node('div', {className: 'linDivThumbnavi_PrevNext'});
		
		ElemA.appendChild( ElemImg );
		ElemDiv.appendChild( ElemA );
		$(divId).appendChild(ElemDiv);
		
		if(! this.finishedPreloadedImages[thumbId]) {
			Element.setOpacity('thumb'+thumbId,0.5);
		}

	},
	

	// -----------------------------------------------------------------------------------
	// Keyboard actions
	// -----------------------------------------------------------------------------------

	/**
	 * enableKeyboardNav()
	 */
	enableKeyboardNav: function() {
		document.onkeydown = this.keyboardAction; 
	},

	/**
	 * disableKeyboardNav()
	 */
	disableKeyboardNav: function() {
		document.onkeydown = '';
	},

	/**
	 * keyboardAction()
	 * 
	 * very nice
	 * http://www.mediaevent.de/javascript/needful_tables.html
	 */
	keyboardAction: function(e) {
		
		if (e == null) { // ie
			keycode = event.keyCode;
			ctrlKey = event.ctrlKey;
		} else { // mozilla
			keycode = e.which;
			ctrlKey = e.ctrlKey;
		}
		
		/*if( ctrlKey )
		{
			alert('ctrl pressed');
			return;
		}*/
		
		//alert(keycode);
		
		key = String.fromCharCode(keycode).toLowerCase();

		//if ((keycode == 39) && (ctrlKey == true))				// ctrl + arrow right
		if (keycode == 34)											// page down
		{
			myLinImage.disableKeyboardNav();
			myLinImage.moveNext();
			return false;
		}
		//else if ((keycode == 37) && (ctrlKey == true))			// ctrl + arrow left
		else if (keycode == 33)										// page up
		{
			myLinImage.disableKeyboardNav();
			myLinImage.movePrev();
			return false;
		}
		else if ((keycode == 32) && (ctrlKey == true))			// ctrl + space
		{
			myLinImage.slideshowStartStop();
		}
		else if ((keycode == 122))									// F11
		{
			if( myLinImage.fullscreenActive ) {
				$('linDivSlideshowExit').show();		// hide exit button to force exit again with F11
				myLinImage.fullscreenStop();
			} else {
				$('linDivSlideshowExit').hide();
				myLinImage.fullscreenStart();
			}
		}
		else if ((keycode == 36) && (ctrlKey == true))			// ctrl + home
		//else if (keycode == 36)										// home
		{
			myLinImage.moveFirst();
			return false;
		}
		else if ((keycode == 35) && (ctrlKey == true))			// ctrl + end
		//else if (keycode == 35)										// end
		{
			myLinImage.moveLast();
			return false;
		}
		else if( myLinImage.fullscreenActive && ((key == 'f') || (key == 'x') || (key == 'o') || (key == 'c') )	) // close fullscreen
		{
			myLinImage.fullscreenStop();
		}
		else if(myLinImage.fullscreenActive &&  key == 's')	// start/stop slideshow
		{
			myLinImage.slideshowStartStop();
		}
		else if(myLinImage.fullscreenActive && key == 'p')		// display previous image
		{
			myLinImage.disableKeyboardNav();
			myLinImage.movePrev();
		}
		else if(myLinImage.fullscreenActive && key == 'n')		// display next image
		{
			myLinImage.disableKeyboardNav();
			myLinImage.moveNext();
		}
	},


	// -----------------------------------------------------------------------------------
	// Preload functions
	// -----------------------------------------------------------------------------------

	/**
	 * preloadXml()
	 * Preload previous and next images.
	 * 
	 * normally, loadImageXml() will call also preloadImage()
	 * but we also need to call preloadImage() if the Xml data is preloaded,
	 * but not yet the image (this may occur if we change to fullscreen,
	 * then, the images need to be re preloaded all
	 */
	preloadXml: function() {

		// preload nextthumb from left to right
		if(this.xmlDoc[IdCurrent].getElementsByTagName('nextthumb').length > 0)
		{
			for(var i = 0; i < this.xmlDoc[IdCurrent].getElementsByTagName('nextthumb').length; i++)
			{
				var imgId = this.xmlDoc[IdCurrent].getElementsByTagName('nextthumb').item(i).firstChild.data;

				if(! this.preloadXmlFinished[imgId])
				{
					this.loadImageXml(imgId);
				}
				else if(! this.finishedPreloadedImages[imgId] )
				{
					this.preloadImage(imgId);
				}
			}
		}

		// preload prevthumb from right to left
		if(this.xmlDoc[IdCurrent].getElementsByTagName('prevthumb').length > 0)
		{
			for(var i = this.xmlDoc[IdCurrent].getElementsByTagName('prevthumb').length-1; i >= 0; i--)
			{
				var imgId = this.xmlDoc[IdCurrent].getElementsByTagName('prevthumb').item(i).firstChild.data;

				if(! this.preloadXmlFinished[imgId])
				{
					this.loadImageXml(imgId);
				}
				else if(! this.finishedPreloadedImages[imgId] )
				{
					this.preloadImage(imgId);
				}
			}
		}
	},
	
	/**
	 * preloadImage()
	 * 
	 * will be called after getting the xml data 
	 */
	preloadImage: function(imgId)
	{
		if(! this.finishedPreloadedImages[imgId] )
		{
			switch(this.xmlDoc[imgId].getElementsByTagName('filetype').item(0).firstChild.data)
			{
			case '1': // image
				/**
				 * set image width and height
				 */
					var orgWidth = this.xmlDoc[imgId].getElementsByTagName('imgwidth').item(0).firstChild.data;
					var orgHeight = this.xmlDoc[imgId].getElementsByTagName('imgheight').item(0).firstChild.data;
					var sizeArray = this.scaleToFit(orgWidth,orgHeight,maxImageWidth,maxImageHeight,1);
					var imgWidth = sizeArray[0];
					var imgHeight = sizeArray[1];
		
				/**
				 * preload image
				 */
				this.preloadImageSrc[imgId] = new Image();
		
				this.preloadImageSrc[imgId].onload=function(){
					myLinImage.preloadImageFinished(imgId);
				}
				this.preloadImageSrc[imgId].src = imageSrc + imgId + '&width=' + imgWidth + '&height=' + imgHeight;
				
				break;
			case '2': // video
				this.preloadImageFinished(imgId);
				break;
			case '0': // other
				break;
			}
		}
	},
	
	preloadImageFinished: function(imgId) {

		this.finishedPreloadedImages[imgId] = true;

		if( $('thumb'+imgId) )	// maybe its not here anymore
		{
			new Effect.Appear('thumb'+imgId, { duration: 0.5, from: 0.5, to: 1.0 });
		}

	},


	// -----------------------------------------------------------------------------------
	// Slideshow functions
	// -----------------------------------------------------------------------------------
	
	fullscreenStart: function()
	{
		this.fullscreenActive = true;

		/**
		 * save old values to restore if slideshow ends
		 */
		this.fullscreenOldMaxWidth = maxImageWidth;
		this.fullscreenOldMaxHeight = maxImageHeight;

		/**
		 * disable scrollbars
		 */
		this.previousBodyOverflow = document.getElementsByTagName("body")[0].style.overflow;
		document.getElementsByTagName("body")[0].style.overflow='hidden';

		/**
		 * start slideshow with some superduper effects
		 */		
		Effect.Appear('linDivSlideshowOverlay', { queue: 'end', duration: 1.0, from: 0.0, to: 0.9 });
		Effect.BlindDown('linDivSlideshowControlsOuter', { queue: 'end'} );
		Element.show('linDivSlideshowImage');
		
		/**
		 * steal the mainimage
		 */
		$('linDivMainimage').innerHTML = '';
		$('linDivSlideshowImage').innerHTML = '<img id="linImgMainimage" style="display: none;" class="linImgSlideshow">';
		
		/**
		 * reload image with new position and size
		 */
		this.resizeWindow();
	},
	fullscreenStop: function()
	{
		this.fullscreenActive = false;

		/**
		 * restore max image size
		 */
		maxImageWidth = this.fullscreenOldMaxWidth;
		maxImageHeight = this.fullscreenOldMaxHeight;

		/**
		 * re-enable scrollbars
		 */
		document.getElementsByTagName("body")[0].style.overflow = this.previousBodyOverflow;

		/**
		 * delete preloaded images after stopping fullscreen
		 */
		this.finishedPreloadedImages = new Array();

		/**
		 * end slideshow with some superduper effects
		 */
		Effect.Fold('linDivSlideshowControlsOuter', { queue: 'end'} );
		Effect.Fade('linDivSlideshowOverlay', { queue: 'end', duration: 0.5, from: 0.9, to: 0.0 } );
		Element.hide('linDivSlideshowImage');

		/**
		 * give back the mainimage
		 */
		$('linDivSlideshowImage').innerHTML = '';
		$('linDivMainimage').innerHTML = '<img id="linImgMainimage" style="display: none;">';

		/**
		 * reload image with old position and size
		 */
		this.loadImage( IdCurrent );
	},
	
	slideshowStartStop: function()
	{
		// start Slideshow
		if(! this.slideshowActive)
		{
			this.slideshowActive = true;
			Element.setOpacity('linSsImgStart',0.7);
			this.ssCurrentTimerID = setTimeout("myLinImage.slideshowPlay()", this.ssCurrentDelay);
		}
		else	// stop Slideshow
		{
			this.slideshowActive = false;
			Element.setOpacity('linSsImgStart',1);
			clearTimeout(this.ssCurrentTimerID);
		}
	},
	slideshowPlay: function()
	{
		if(this.nextThumbs[0] || this.ssLoop)
		{
			this.moveNext();
			//this.ssCurrentTimerID = setTimeout("myLinImage.slideshowPlay()", this.ssCurrentDelay);
		}
		else
		{
			// force stop slideshow
			this.slideshowActive = true;
			this.slideshowStartStop();
		}
	},

	slideshowChangeDelay: function()
	{
		this.ssCurrentDelay = $('linSsDelay').options[ $('linSsDelay').selectedIndex ].value * 1000;
		//document.optionsForm.delay.options[document.optionsForm.delay.selectedIndex].value * 1000;
	},
	slideshowChangeLoop: function()
	{
		if(! this.ssLoop) {
			this.ssLoop = true;
			Element.setOpacity('linSsImgLoop',0.7);
		} else {
			this.ssLoop = false;
			Element.setOpacity('linSsImgLoop',1);			
		}
	},
	slideshowChangeRandom: function()
	{
		if(! this.ssRandom) {
			this.ssRandom = true;
			Element.setOpacity('linSsImgRandom',0.7);
		} else {
			this.ssRandom = false;
			Element.setOpacity('linSsImgRandom',1);			
		}
		alert('This feature is currently not implemented, do we really need that?');
	},


	// -----------------------------------------------------------------------------------
	// Image info functions
	// -----------------------------------------------------------------------------------

	/**
	 * setImageInfoLink()
	 * 
	 * positions the info link on bottom right of the image
	 * could only be done after image is not hidden anymore
	 * 
	 * if this can be done without javascript, please tell me
	 */
	setImageInfoLink: function()
	{
		$('linDivInfoLink').style.top = $('linImgMainimage').offsetTop + $('linImgMainimage').offsetHeight + 3;
		$('linDivInfoLink').style.left = $('linImgMainimage').offsetLeft + $('linImgMainimage').offsetWidth - 200; // 200: width of linDivInfoLink, value set view_img.css width = 200px; can't get width with javascript because element is hidden
		Element.show('linDivInfoLink');
	},
	
	/**
	 * showImgInfo()
	 * 
	 * fade out the image, show the meta infos, sets the color of the "Info" link to another
	 * 
	 * idea:
	 * swap the colors of <a> and <div> tag (id 'linHrefInfoLink' and 'linDivInfoLink'
	 * so it is possible to set the colors in the css template (and not in javascript file)
	 */
	showImgInfo: function()
	{
		/**
		 * make visible/invisible
		 */
		if( this.imgInfoShowHide == 'hide' )
		{
			this.imgInfoShowHide = 'show';
	
			/**
			 * set position
			 */
			$('linDivMetaOuter').style.top = $('linImgMainimage').offsetTop;
			$('linDivMetaOuter').style.height = $('linImgMainimage').offsetHeight;
	
			new Effect.Appear('linDivMetaOuter', { duration: 0.3 });	//, from: 0.0, to: 1.0
			new Effect.Fade('linDivMainimage', { duration: 0.3, from: 1.0, to: 0.2 });
			
			$('linHrefInfoLink').style.color = this.imgInfoColorNotActive;
		}
		else
		{
			this.imgInfoShowHide = 'hide';
			
			new Effect.Fade('linDivMetaOuter', { duration: 0.3 });	// , from: 1.0, to: 0.0
			new Effect.Appear('linDivMainimage', { duration: 0.3, from: 0.2, to: 1.0 });
	
			$('linHrefInfoLink').style.color = this.imgInfoColorActive;
		}
	},
	hideImgInfoNow: function()
	{
		Element.hide('linDivMetaOuter');
		Element.hide('linHrefPanoLink');
		Element.setOpacity('linDivMainimage',1);
		this.imgInfoShowHide = 'hide';
	
		$('linHrefInfoLink').style.color = this.imgInfoColorActive;
	},
	
	/**
	 * returns an array(width, height) with the correct size to fit
	 * in dst_w and dst_h
	 */
	scaleToFit: function(src_w,src_h,dst_w,dst_h,no_increase)
	{
		if(src_h == 0 || src_w == 0)
		{
			return new Array(0, 0);
		}
	
		var img_relation = src_w / src_h;
	
		// Image is smaller than screen, no resize required
		if ((src_w <= dst_w) && (src_h <= dst_h) && no_increase)
		{
			var returnarray = new Array( Math.round(src_w), Math.round(src_h) );
		}
		else
		{
			/*
			The image is way bigger than the screen, resize maintaining aspect ratio
	
			$src_w, $src_h: original image sizes
			$dst_w, $dst_h: screen width and height
			$img_relation = $src_w/$src_h;
		
			Either $dst_w decisive or $dst_h, usually $dst_h 
			*/
	
			var tmp_height = dst_w / img_relation;		// calc the new height with screen width
			if (tmp_height > dst_h)			// we were wrong, it's still widther than screen -> $dst_h is decisive
			{
				var returnarray = new Array( Math.round(img_relation*dst_h), Math.round(dst_h) );
			}
			else
			{
				var returnarray = new Array( Math.round(dst_w), Math.round(tmp_height) );
			}
		}
		
		return returnarray;
	},
	

	// -----------------------------------------------------------------------------------
	// Comments
	// -----------------------------------------------------------------------------------
	
	setComments: function()
	{
		$('linDivComments').innerHTML = '';

		if(this.xmlDoc[IdCurrent].getElementsByTagName('comment').length > 0)
		{
			for(var i = 0; i < this.xmlDoc[IdCurrent].getElementsByTagName('comment').length; i++)
			{
				var tagcomment = this.xmlDoc[IdCurrent].getElementsByTagName('comment').item(i);
				var commenttime = document.createTextNode( tagcomment.getElementsByTagName('time').item(0).firstChild.data + ' by ' );
				var commentauthor = document.createTextNode( tagcomment.getElementsByTagName('author').item(0).firstChild.data );
//				var commenttext = document.createTextNode( tagcomment.getElementsByTagName('text').item(0).firstChild.data );
				
				var commenttextdiv = Builder.node('div', {id: 'linComment'+i});
	
				$('linDivComments').appendChild(commenttime);
				$('linDivComments').appendChild(commentauthor);
				$('linDivComments').appendChild( document.createElement("hr") );
				$('linDivComments').appendChild(commenttextdiv);
				$('linDivComments').appendChild( document.createElement("br") );
				$('linDivComments').appendChild( document.createElement("br") );
				
				$('linComment'+i).innerHTML = tagcomment.getElementsByTagName('text').item(0).firstChild.data;
			}
		}
	},
	
	saveComment: function(t)
	{
		// not use 'this.' doesnt work if call from ajax success function

		myLinImage.xmlDoc[IdCurrent] = t.responseXML.documentElement;
	
		if(myLinImage.xmlDoc[IdCurrent].getElementsByTagName('commentadded').length > 0)
		{
			myLinImage.initTextareaAddComment();
			myLinGlobal.linSyslog( myLinImage.xmlDoc[IdCurrent].getElementsByTagName('commentadded').item(0).firstChild.data );
		}
		
		//myLinImage.loadImage(IdCurrent);
		myLinImage.setComments();
	},
	
	/**
	 * openTextarea()
	 * 
	 * opens the bigger textarea to enter longer image comments
	 * this function is defined in view_img_static.html.php too
	 */
	openTextarea: function()
	{
		Element.show('linDivAddCommentTextarea');
		Element.hide('linDivAddCommentText');
		
		$('linInputAddCommentTextarea').value = $('linInputAddCommentText').value;
	},
	
	initTextareaAddComment: function()
	{
		Element.hide('linDivAddCommentTextarea');
		Element.show('linDivAddCommentText');
		
		$('linInputAddCommentTextarea').value = '';
		$('linInputAddCommentText').value = '';
	},
	

	// -----------------------------------------------------------------------------------
	// Meta functions
	// -----------------------------------------------------------------------------------
	
	updateLinId: function(elemId)
	{
		elemId.href = elemId.href.replace( /linId=[0-9]*/g , "linId=" + IdCurrent );		
	},
	

	// -----------------------------------------------------------------------------------
	// Common used functions
	// -----------------------------------------------------------------------------------

	/**
	 * resizeWindow, use this wrapper function because internet explorer triggers the resize event to fast
	 */
	resizeWindow: function ()
	{
		clearTimeout(this.timerResize);
		this.timerResize = setTimeout(linImageWrapper,250); 
	}
}

/**
 * linImageWrapper()
 * 
 * use this wrapper function if called from setTimeout()
 * because 'this.' would not work otherwise
 */
function linImageWrapper()
{
	if(myLinImage.fullscreenActive)
	{
		/**
		 * delete preloaded images after starting fullscreen and resizing window
		 */
		myLinImage.finishedPreloadedImages = new Array();

		myLinGlobal.setWindowSize();
		maxImageWidth = myLinGlobal.linInnerWidth - 70;
		maxImageHeight = myLinGlobal.linInnerHeight - 120;
		
		myLinImage.loadImage( IdCurrent );
	}
	else
	{
		myLinImage.setImageInfoLink();
		// myLinGlobal.setMainHeight();
	}
}

/**
 * init on finished page load
 */
function initLinImage()
{
	$('linDivMainimage').style.height = startImgHeight; // initial sets correct height at begin and not after the image is loaded
	$('linImgMainimage').style.height = startImgHeight; // initial sets correct height at begin and not after the image is loaded
	myLinImage = new LinImage();
	
	/**
	 * doing something very important!
	 * rebuild the browsers histroy back, forware and reload functions
	 * if we have a #idCurrent=xyz in the url use this as the id
	 */
	if( document.location.hash.indexOf('idCurrent') != -1 )
	{
		IdCurrent = document.location.hash.substr(11);
	}

	/**
	 * and again something important
	 * rebuild the browsers histroy back, forware and reload functions
	 * periodically check if the url has changed
	 * if so, load the new id
	 */
	myLinImage.curLocationHash = location.hash;
	window.setInterval(function()
	{
		if (myLinImage.curLocationHash != location.hash)
		{
			if( document.location.hash.substr(11) != '' )
			{
				IdCurrent = document.location.hash.substr(11);

			}
			else	// location.hash contains no '#idCurrent', we're back on start
			{
				IdCurrent = startIdCurrent;
			}

			myLinImage.loadImage(IdCurrent);
		}
	}, 1000);
	
	
	/**
	 * append the slideshow divs to the body
	 * we need to append to body to be sure to get the real fullscreen
	 * even if we are locked in another div
	 */
	var objBody = document.getElementsByTagName("body").item(0);
	objBody.appendChild( Builder.node('div', {id: "linDivSlideshowOverlay", style: "display: none;"}) );
	objBody.appendChild( Builder.node('div', {id: "linDivSlideshowImage", style: "display: none;"}) );
	objBody.appendChild( Builder.node('div', {id: "linDivSlideshowControlsOuter", style: "display: none;"}) );
	
	$('linDivSlideshowControlsOuter').innerHTML = linSlideshowHtml;


	// automatically start slideshow if requested (coming from thumbview)
	if( document.location.search.indexOf('slideshow') != -1 )
	{
		myLinImage.fullscreenStart();
	}
	else
	{
		myLinImage.loadImage(IdCurrent);
	//	setMainHeight();	// defined in LinGlobal.js
	//	window.onresize = onWindowResize;
	//	Event.observe(window, 'resize', onWindowResize, false);
		Event.observe(window, 'resize', myLinImage.resizeWindow, false);
	}
}

Event.observe(window, 'load', initLinImage, false);

