/**
 * javascript thumbnail viewer
 *
 * check performance:
 var start = new Date().getTime();
 alert( (new Date().getTime() - start) );
 *
 */

/**
 * class and global definitions
 */
var LinThumbnails = Class.create();
var myLinThumbnails;

LinThumbnails.prototype =
{
	/**
	 * initialize()
	 * Constructor runs on completion of the DOM loading.
	 */
	initialize: function()
	{
		this.currentPage = linStartupPage
		this.nrPages = 0;
		this.timerResize;

		/**
		 * page numbers
		 */
		this.pnLeft = 3;
		this.pnRight = 3;
		this.pnMiddleLeft = 2;
		this.pnMiddleRight = 4;
		this.pnConstant = this.pnLeft + this.pnRight + this.pnMiddleLeft + this.pnMiddleRight + 1;
		this.spaceMin = 2; // minimum space before replacing numbers with dots
	},

	displayThumbs: function()
	{
		/**
		 * set correct main height only if linPhotosPerPage == auto
		 * needs to be in linDisplayThumbs!
		 */
		myLinGlobal.setMainHeight();	// defined in LinGlobal.js
	
		/**
		 * calculate nr of photos per page (from select form)
		 */
		switch( linPhotosPerPage )
		{
		case 'auto':
			var nr_cols = Math.floor( (document.getElementById('linDivMain')['offsetWidth']-linMainSpacerWidth) / (linTnSize + linImgSpacerWidth) );
			var nr_rows = Math.floor( (document.getElementById('linDivMain')['offsetHeight']-linMainSpacerHeight) / (linTnSize + linImgSpacerHeight + (linImgDivSpacerHeight*linNrTextLines) ) );
			var max_photos_per_page = nr_rows * nr_cols;
		break;
		case 'all':
			var nr_cols = Math.floor( (document.getElementById('linDivMain')['offsetWidth']-linMainSpacerWidth) / (linTnSize + linImgSpacerWidth) );
			var max_photos_per_page = linTotPhotos;
			var nr_rows = Math.ceil(max_photos_per_page / nr_cols);
		break;
		default:
			/**
			 * ceil max_photos_per_page to complet the row!
			 */
			var nr_cols = Math.floor( (document.getElementById('linDivMain')['offsetWidth']-linMainSpacerWidth-5) / (linTnSize + linImgSpacerWidth) );	/* -5 -> scrollbars */
			var nr_rows = Math.ceil( linPhotosPerPage / nr_cols);	
			var max_photos_per_page = nr_rows * nr_cols;
		break;
		}
		
		/**
		 * at least on image per page 
		 */
		(nr_cols == 0) ? nr_cols = 1 : '';
		(nr_rows == 0) ? nr_rows = 1 : '';
		(max_photos_per_page == 0) ? max_photos_per_page = nr_rows * nr_cols : '';
		
	
		/**
		 * prepare page numbers
		 */
		this.nrPages = Math.ceil( linTotPhotos / max_photos_per_page );
	
	
		/**
		 * check if our current page still exists (maybe we changed the linTnSize and now there arent so much pages anymore)
		 * (but not if this.currentPage == 1 and this.nrPages == 0)
		 */
		if(this.currentPage > this.nrPages && this.currentPage != 1)
		{
			this.currentPage = this.nrPages;
		}
		
		/**
		 * write page numbers
		 */
		this.writePageNumbers();
		
		/**
		 * write divs
		 */
		var img_nr = 1;
		var startup_img_nr = (this.currentPage - 1)*max_photos_per_page;
	
		$('linDivMain').innerHTML='';
		divhtmltext = '';
	
		if(linViewMode == 'thumbdetail') {
			var style1text = '';
			var style2text = ' linDivImgDetail';
			var style3text = 'class="linDivTextDetail"';
		} else {
			var style1text = ' style="width: ' + linTnSize + '"';
			var style2text = '';
			var style3text = 'class="linDivText"';
		}
	
		/**
		 * Prototype modfies the core Array object and you shouldn't use any for
		 * .. in -loops, instead do like this:
		 * [...]
		 * for (var i=0; $t = $aTOC[i]; i++) {
		 *    $temp += 't=' + $t + '<br />';
		 * }
		 * [...]
		 * 
		 * for( var i=0; index = linImgIds[i] ; i++ )
		 * but does not work because the index doesnt starts from 0
		 */
		for (index in linImgIds)
		{
			if(index >= startup_img_nr && img_nr <= max_photos_per_page)
			{
				if( (img_nr-1) % nr_cols == 0) {
					//var styletext = ' style="clear:left;"';
					divhtmltext += '<div style="clear: left;"></div>';
				}
				
				divhtmltext += 
					'<div id="linDivThumb' + index + '" class="linDivThumb"' + style1text + '>' +
					linImgIds[index]['before'] + '<div class="linDivImg' + style2text + '">' +
					'<a href="' + linUrlBase + '&amp;linId=' + linImgIds[index]['id'] + '">' +
					'<img src="' + LINPHA_CLIENT + '/get_thumb.php?linId=' + linImgIds[index]['id'] + '"' + 
						' height="' + linTnSize + '" width="' + linTnSize + '" ' +
						' alt="' + linImgIds[index]['title'] + '" title="' + linImgIds[index]['title'] + '"' +
						' class="linImgThumb" />' +
					'</a></div><div ' + style3text + '>' + linImgIds[index]['after'] + '</div></div>';
	
				/**
				 * flush buffer of divhtmltext on end of line
				 * with this buffer, we're 3-4 as fast as without !!
				 * see also http://www.softwaresecretweapons.com/jspwiki/Wiki.jsp?page=JavascriptStringConcatenation !!
				 * 
				 * update: using the DOM functions with createElement etc. we would be at least 2 times slower!!
				 */
				if( (img_nr-1) % nr_cols == 0)
				{
					$('linDivMain').innerHTML += divhtmltext;
					divhtmltext = '';
				}
				
				img_nr++;
			}
		}
	
		$('linDivMain').innerHTML += divhtmltext;
	},

	writePageNumbers: function()
	{
		/**
		 * create an array with page numbers
		 */
		pn_nrs = new Array();
		var nr_pages_shown = 0;
		var start_gap = 0;
		var end_gap = 0;
		
		/**
		 * get all pages which should be shown
		 */
		for(var i = 1; i <= this.nrPages; i++)
		{
			if(	this.pnConstant >= this.nrPages				// show all pages if we dont have much	
				|| i <= this.pnLeft																// left side
				|| (i > ( this.nrPages - this.pnRight ) )											// right side
				|| (i >= ( this.currentPage - this.pnMiddleLeft ) && i <= this.currentPage)			// middle left
				|| (i <= ( this.currentPage + this.pnMiddleRight ) && i >= this.currentPage)			// middle right
			  )
			{
				pn_nrs[i] = 1;
				nr_pages_shown++;
				
				if(start_gap != 0 && end_gap == 0)	// make sure this is done only with the first gap 
				{
					end_gap = i-1;		// used later to fill up this gap if needed
				}
			}
			else
			{
				pn_nrs[i] = 0;
	
				if(start_gap == 0) // make sure this is done only with the first gap
				{
					start_gap = i; // used later to fill up this gap if needed
				}
			}
		}
		
		/**
		 * add this.currentPage to array, and increment nr_pages_shown if needed
		 */
		if(pn_nrs[this.currentPage] == 0)
		{
			nr_pages_shown++;
		}
		pn_nrs[this.currentPage] = 2;
		
		/**
		 * if with have a lot of pages, fill up the array so that we have all the time the same number of page numbers
		 */
		if( this.pnConstant > nr_pages_shown && this.nrPages > this.pnConstant)
		{
			/**
			 * fill up the gap (there is only _one_ gap if we have to fill up the array)
			 * stop if we filled up enough the needed value,
			 * or stop if we are reaching the this.spaceMin (to prevent: 1 2 3 4 5 6 ... 8 9 10 11)
			 */
			beginn_with_startgap = 1;
			while( this.pnConstant > nr_pages_shown && (end_gap - start_gap) >= this.spaceMin)
			{
				if(beginn_with_startgap == 1)
				{
					pn_nrs[start_gap] = 1;
					nr_pages_shown++;
					start_gap++;
				
					beginn_with_startgap = 0;
				}
				else //beginn_with_startgap = 0 
				{
					pn_nrs[end_gap] = 1;
					nr_pages_shown++;
					end_gap--;
				
					beginn_with_startgap = 1;
				}
			}
		}
		
		/**
		 * search for small gaps (this.spaceMin) and fill up
		 */
		var counter = 0;
		for(var i = 1; i <= this.nrPages; i++)
		{
			if(pn_nrs[i] == 0)
			{
				counter++;
			}
			else 
			{
				if(counter < this.spaceMin)
				{
					/**
					 * fill up gap
					 */
					for(var ii = (i-1); ii >= (i-counter); ii--)
					{
						pn_nrs[ii] = 1;
					} 
				}
				
				/**
				 * reset counter
				 */
				counter = 0;
			}
		}


	
		/**
		 * write starting '<<' and '<'
		 */
			if(this.currentPage == 1)
			{
				$('linDivPagenrLeft').innerHTML = "<< <";
			}
			else
			{
				$('linDivPagenrLeft').innerHTML = "";
	
				$('linDivPagenrLeft').appendChild( Builder.node( 'a', {href: 'javascript:myLinThumbnails.gotoPage(1)'}, "<<" ) );
				$('linDivPagenrLeft').appendChild( document.createTextNode(" ") );
				$('linDivPagenrLeft').appendChild( Builder.node( 'a', {href: 'javascript:myLinThumbnails.gotoPage( (myLinThumbnails.currentPage)-1 ) '}, "<" ) );
			}
	
		/**
		 * write page numbers
		 */
			$('linDivPagenrMiddle').innerHTML='';
	
			for(var i = 1; i <= this.nrPages; i++)
			{
				if(pn_nrs[i] != 0)
				{
					start_gap = 0;
		
					if(pn_nrs[i] == 2)
					{
						var myText = document.createTextNode(i);
					}
					else if(pn_nrs[i] == 1)
					{
						var myText = document.createElement('a');
			
						var myAttribute=document.createAttribute("href");
						myAttribute.nodeValue = 'javascript:myLinThumbnails.gotoPage('+i+')';
						myText.setAttributeNode(myAttribute);
			
						var myText2 = document.createTextNode(i);
						myText.appendChild(myText2);
					}
					$('linDivPagenrMiddle').appendChild(myText);
			
					var myText = document.createTextNode(' ');
					$('linDivPagenrMiddle').appendChild(myText);
				}
				else
				{
					if(start_gap == 0)
					{
						start_gap = 1;
						
						var myText = document.createTextNode(' ... ');
						$('linDivPagenrMiddle').appendChild(myText);
					}
				}
			}
	
		/**
		 * write ending '>' and '>>'
		 */
			if(this.currentPage == this.nrPages || this.nrPages == 0)	// need check this.nrPages != 0 because we don't need links if this.nrPages == 0!
			{
				$('linDivPagenrRight').innerHTML = "> >>";
			}
			else
			{
				$('linDivPagenrRight').innerHTML = "";
	
				$('linDivPagenrRight').appendChild( Builder.node( 'a', {href: 'javascript:myLinThumbnails.gotoPage( (myLinThumbnails.currentPage)+1 )'}, ">" ) );
				$('linDivPagenrRight').appendChild( document.createTextNode(" ") );
				$('linDivPagenrRight').appendChild( Builder.node( 'a', {href: 'javascript:myLinThumbnails.gotoPage( myLinThumbnails.nrPages ) '}, ">>" ) );
			}
	},

	gotoPage: function(nr)
	{
		this.currentPage = nr;
		this.displayThumbs();
	},
	
	setTnSize: function( tn_size_local )
	{
		linTnSize = tn_size_local;
		this.displayThumbs();
	},
	
	setNrImages: function( photos_per_page_local)
	{
		linPhotosPerPage = photos_per_page_local;
		this.displayThumbs();
	},

	/**
	 * loadSlideshow()
	 * 
	 * to start the slideshow, first open imageview with first image, and then start slideshow
	 */
	loadSlideshow: function()
	{
		location.href = linUrlBase + '&linId=' + linImgIds[0]['id'] + '&slideshow';
	},

	/**
	 * resizeWindow, use this wrapper function because internet explorer triggers the resize event to fast
	 */
	resizeWindow: function ()
	{
		clearTimeout(this.timerResize);
		this.timerResize = setTimeout(linThumbnailsWrapper,250); 
	}
}

/**
 * linThumbnailsWrapper()
 * 
 * use this wrapper function if called from setTimeout()
 * because 'this.' would not work otherwise
 */
function linThumbnailsWrapper()
{
	myLinThumbnails.displayThumbs();
}

/**
 * initLinThumbnails()
 * 
 * create the object and initially display the thumbnails
 */
function initLinThumbnails()
{
	myLinThumbnails = new LinThumbnails();
	Event.observe(window, 'resize', myLinThumbnails.resizeWindow, false);
	
	myLinThumbnails.displayThumbs();
}

Event.observe(window, 'load', initLinThumbnails, false);
