<?php
/*
 * Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
 *                    Florian Angehrn 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * Ajax
 * @package Modules
 */
if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * use ajax if requested
 */
if(isset($_GET['use_js']))
{
	$_SESSION['use_js'] = true;
	echo 'use_js saved';		// if need to change, change also in LinGlobal.js !
}

/**
 * force ajax disable
 */
elseif(isset($_GET['disable_ajax']))
{
	$_SESSION['disable_ajax'] = true;
	echo 'disable_ajax saved';
}
/**
 * re-enable
 */
elseif(isset($_GET['enable_ajax']))
{
	if(isset($_SESSION['disable_ajax']))
	{
		unset($_SESSION['disable_ajax']);
		echo 'enable_ajax saved (was disabled before)';
	}
	else
	{
		echo 'enable_ajax saved (but was not disabled before)';
	}
}

/**
 * reload menu
 * 
 * the login itself is done automatically in startSession() because we are using the same form names etc.
 */
elseif(isset($_GET['reloadmenu']))
{
	if( isset($_SESSION['ref_url_base']) )
	{
		include_once(LINPHA_DIR . '/lib/classes/linpha.imgview.class.php');
		$linpha->imgview = new linImgview();
		$linpha->imgview->setCurrentView($_SESSION['ref_modulename']);
		
		$linpha->template->URL_base = $_SESSION['ref_url_base'];
		$linpha->template->URL_full = $linpha->template->URL_base.'&amp;linId='.$linpha->template->idCurrent;
		$_SESSION['ref_url_full'] = $linpha->template->URL_full; 

		$linpha->imgview->setMenu();
	}
	else	// return a default menu
	{
	}
	
	$linpha->template->printMenus('home,search,login,more,icons,settings,admin',$comingfrom_ajax=true);
}

exit();	// important if linpha is included from another webpage

?>