<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn 
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * Albums view related methods and functions
 * @package Modules
 */
if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * @todo  temporary set configs
 */
$order_by = 'name ASC';

/**
 * init
 */
	include_once(LINPHA_DIR . '/lib/classes/linpha.imgview.class.php');
	$linpha->imgview = new linImgview();

/**
 * check permission
 */
	if( !LinSql::photoIsAllowed( $linpha->template->idCurrent ) )
	{
		echo i18n("Error: No Access");
		exit(1);
	}

/**
 * set some infos
 */
	$linpha->template->URL_base = LINPHA_LINK.'&amp;linCat=alb';
	$linpha->template->URL_full = LINPHA_LINK.'&amp;linCat=alb&amp;linId='.$linpha->template->idCurrent;

	$linpha->imgview->setCurrentView('albums');

/**
 * do import
 */
	if( $linpha->sql->config->value['sys_import_autoimport'] && $linpha->imgview->img_type == 0)
	{
		LinImport::updateDir( $linpha->template->idCurrent, $recursive = false, $dryrun = false );
	}

/**
 * set navigation line
 */
	$GLOBALS['linpha']->template->output['title'] = linSetNavigationLine( $linpha->template->idCurrent, LINPHA_LINK.'&amp;linCat=alb&amp;linId=' );
	

/**
 * get photos
 * (in img_view only for prev/next)
 * 
 * take folders first
 */
	$array_folders = $GLOBALS['linpha']->db->GetAssoc("SELECT ".LIN_SELECT_FIELDS." FROM ".LIN_PREFIX."photos " .
		"WHERE img_type = '0' AND parent_id = '".$linpha->imgview->id_parent."' ORDER by ".$linpha->imgview->orderby);

	$array_files = $GLOBALS['linpha']->db->GetAssoc("SELECT ".LIN_SELECT_FIELDS." FROM ".LIN_PREFIX."photos " .
		"WHERE img_type <> '0' AND img_type <> '9999999' AND parent_id = '".$linpha->imgview->id_parent."' ORDER by ".$linpha->imgview->orderby);

	$linpha->imgview->photos = array_merge($array_folders,$array_files);

$linpha->imgview->buildImgView();
?>