<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn 
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * Basket view related methods and functions
 * @package Modules
 */
if(!defined('LINPHA_DIR')) { exit(1); }


/**
 * parse POST data and GET commands
 */
	/**
	* download error handling
	*/
	if(isset($_GET['error_basket_download']))
	{
		switch($_GET['error_basket_download'])
		{
		case 2: linSysLog(i18n("Error").": ".i18n("The download couldn't be started for some reasons!")); break;	// created archive doesn't exists...
		}
	}

	/**
	 * parse GET commands
	 */ 	
 	if( isset( $_REQUEST['cmd'] ) )
 	{
		@ini_set("memory_limit", "100M");		// try to increase memory_limit
		@ini_set('max_execution_time','1000');	// try remove php script time limit of 30 sec
		@set_time_limit(0);						// try remove php script time limit of 30 sec

 		switch($_REQUEST['cmd'])
 		{
		case 'checkout':
			/**
			 * do the final checkout
			 */
			
			try
			{
				/**
				 * check basket permission
				 */
				if(! $GLOBALS['linpha']->sql->checkPermission('basket_'.$_REQUEST['checkout_as']))
				{
					throw new Exception(i18n("No Access"));
				}

				/**
				 * no images selected
				 */
				if( count($_SESSION['basket_ids']) == 0 )
				{
					throw new Exception(i18n("No Images Selected!"));
				}

				/**
				 * check permission of each image id
				 */
				foreach($_SESSION['basket_ids'] AS $value)
				{
					if(! $GLOBALS['linpha']->sql->photoIsAllowed($value))
					{
						throw new Exception(i18n("No Access"));
					}
				}

				/**
				 * do the final checkout
				 * exit script in download (the file download is startet in this file) and print (opens in a new page)
				 */
				switch($_REQUEST['checkout_as'])
				{
				case 'download':
					include_once(LINPHA_DIR.'/lib/include/basket_build_zip.php');
					exit();
				break;
				case 'print':
					include_once(LINPHA_DIR.'/lib/include/basket_build_print.php');
					exit();
				break;
				case 'mail':
					include_once(LINPHA_DIR.'/lib/include/basket_build_mail.php');
				break;
				}
			}
			catch(Exception $error)
			{
				linSysLog(i18n("Error").": ".$error -> getMessage());
			}

		break;

 		case 'add_selected':
			/**
			 * add ids to session
			 * coming from imgview, mode=viewBasket
			 * the permission check with photoIsAllowed() is done while checking out
			 */

		 	if( isset( $_POST['img_id'] ) )
		 	{
		 		foreach($_POST['img_id'] AS $value)
		 		{
	 				$_SESSION['basket_ids'][] = $value;
		 		}
		 	}

	 		Header("Location: ".linConvertAmp($_SESSION['ref_url_full'])."&linMsg=basket_added");
	 		exit();
		
 		case 'remove_all':
	 		/**
	 		 * remove all
	 		 */
 			$_SESSION['basket_ids'] = Array();
 			break;
 		
		case 'remove_selected':
	 		/**
	 		 * remove selected
	 		 */


		 	if( isset( $_POST['img_id'] ) )
		 	{
		 		foreach($_POST['img_id'] AS $value)
		 		{
	 				$key = array_search($value, $_SESSION['basket_ids']);
					unset($_SESSION['basket_ids'][$key]);
		 		}
		 	}

			break;
 		}
 	}
 	
/**
 * build basket view
 */
	/**
	 * get and save parent ids
	 */
	if( count($_SESSION['basket_ids']) > 0 )
	{
		sort($_SESSION['basket_ids']);
		foreach($_SESSION['basket_ids'] AS $value)
		{
			$data = $GLOBALS['linpha']->db->GetRow("SELECT parent_id FROM ".LIN_PREFIX."photos WHERE id = '". LinSql::linAddslashes($value)."'" );
			$array_folders[] = $data[0];
			
			/**
			 * store all imgids in an array with parent_id as the key for easy access
			 */
			$GLOBALS['linpha']->template->output['basket_folder_contents'][$data[0]][] = $value;
		}
		
		$GLOBALS['linpha']->template->output['basket_folders'] = array_unique($array_folders);
	}
	
	/**
	 * create select form
	 */
	$GLOBALS['linpha']->template->output['select_checkout'] = '';
	if( $GLOBALS['linpha']->sql->checkPermission('basket_download') )
	{
		$GLOBALS['linpha']->template->output['select_checkout'] .= '<option value="download"'.
			(isset($_REQUEST['checkout_as']) && $_REQUEST['checkout_as'] == 'download' ? ' selected="selected"' : '').
			'>'.i18n("Download").'</option>'."\n";
	}
	if( $GLOBALS['linpha']->sql->checkPermission('basket_mail') )
	{
		$GLOBALS['linpha']->template->output['select_checkout'] .= '<option value="mail"'.
			(isset($_REQUEST['checkout_as']) && $_REQUEST['checkout_as'] == 'mail' ? ' selected="selected"' : '').
			'>'.i18n("Send As Mail").'</option>'."\n";
	}
	if( $GLOBALS['linpha']->sql->checkPermission('basket_print') )
	{
		$GLOBALS['linpha']->template->output['select_checkout'] .= '<option value="print"'.
			(isset($_REQUEST['checkout_as']) && $_REQUEST['checkout_as'] == 'print' ? ' selected="selected"' : '').
			'>'.i18n("Print").'</option>'."\n";
	}


$linpha->template->setModuleName('basket');
$linpha->template->URL_full = LINPHA_LINK.'&amp;linCat=basket';
$linpha->template->output['title'] = '<a href="'.$linpha->template->URL_full.'">'.i18n("Basket").'</a>';
include_once(LINPHA_DIR.'/templates/'.$GLOBALS['linpha']->template->template_name.'/global.html.php');
?>