<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*                    Florian Angehrn 
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * Navigation view related methods and functions
 * @package Modules
 */
if(!defined('LINPHA_DIR')) { exit(1); }

/**
 * @todo  temporary set configs
 */
$order_by = 'name ASC';

/**
 * init
 */
	include_once(LINPHA_DIR . '/lib/classes/linpha.imgview.class.php');
	$linpha->imgview = new linImgview();

/**
 * set some infos
 */
	$linpha->imgview->setCurrentView('browse');

	$url_base = LINPHA_LINK.'&amp;linCat=browse';
	$url_append = '';
	if(isset($_GET['year']))
	{
		$url_append = '&amp;year='.$_GET['year'];

		if(isset($_GET['month']))
		{
			$url_append .= '&amp;month='.$_GET['month'];

			if(isset($_GET['day']))
			{
				$url_append .= '&amp;day='.$_GET['day'];
			}
		}
	}
	$linpha->template->URL_base = $url_base.$url_append;
	$linpha->template->URL_full = $url_base.$url_append.'&amp;linId='.$linpha->template->idCurrent;

/**
 * set date and navigation line
 */
	$search_string = '';
	$str_navigation = '<a href="'.$url_base.'">all</a> &gt; ';
	$str_datelinks = i18n("Years").': ';

/**
 * year
 */
	$data = $linpha->db->GetRow("SELECT min(datetimeoriginal), max(datetimeoriginal) " .
		"FROM ".LIN_PREFIX."meta_exif");

	$min_year = substr($data[0],0,4);
	$max_year = substr($data[1],0,4);
	
	$sum = 0;
	
	/**
	 * get years between
	 */
	for($i = $min_year; $i <= $max_year; $i++)
	{
		/**
		 * exclude all wrong/empty/... dates
		 */
		if($i > 1900)
		{
			$data = $linpha->db->GetRow("SELECT count(datetimeoriginal) FROM ".LIN_PREFIX."meta_exif WHERE datetimeoriginal LIKE '".$i."%'");
			if($data[0]>0)
			{
				if(isset($_GET['year']) && $i == $_GET['year'])
				{
					$str_datelinks .= $i.' ('.$data[0].'), ';
				}
				else
				{
					$str_datelinks .= '<a href="'.$url_base.'&amp;year='.$i.'">'.$i.'</a> ('.$data[0].'), ';
				}
				
				$sum += $data[0];
			}
		}
	}
	
	/**
	 * calc not indexed images
	 */
		$data = $linpha->db->GetRow("SELECT sum( stats_numbers ) FROM ".LIN_PREFIX."photos WHERE parent_id = '0' GROUP BY parent_id");
		$str_datelinks .= '<a href="'.$url_base.'&amp;year=0">'.i18n("not indexed").'</a> ('.($data[0]-$sum).')';


	if(isset($_GET['year']) && $_GET['year'] != 0)
	{
		$str_navigation .= '<a href="'.$url_base.'&amp;year='.$_GET['year'].'">'.$_GET['year'].'</a> &gt; ';
		$search_string = $_GET['year'];

		/**
		 * show month links
		 */
		$str_datelinks .= '<br />'.i18n("Months").': ';
		for($i=1; $i <= 12; $i++)
		{
			if(strlen($i)==1)
			{
				$i = "0".$i;
			}
			
			$data = $linpha->db->GetRow("SELECT count(datetimeoriginal) FROM ".LIN_PREFIX."meta_exif " .
					"WHERE datetimeoriginal LIKE '".LinSql::linAddslashes($search_string).":".$i."%'");
			if($data[0]>0)
			{
				if(isset($_GET['month']) && $i == $_GET['month'])
				{
					$str_datelinks .= $i.' ('.$data[0].'), ';
				}
				else
				{
					$str_datelinks .= '<a href="'.$url_base.'&amp;year='.$_GET['year'].'&amp;month='.$i.'">'.$i.'</a> ('.$data[0].'), ';
				}
			}
		}
	}

/**
 * month
 */
	if(isset($_GET['month']))
	{
		$str_navigation .= '<a href="'.$url_base.'&amp;year='.$_GET['year'].'&amp;month='.$_GET['month'].'">'.$_GET['month'].'</a> &gt; ';
		$search_string = $_GET['year'].':'.$_GET['month'];

		/**
		 * show day links
		 */
		$str_datelinks .= '<br />'.i18n("Days").': ';
		for($i=1; $i <= 31; $i++)
		{
			if(strlen($i)==1)
			{
				$i = "0".$i;
			}
			
			$data = $linpha->db->GetRow("SELECT count(datetimeoriginal) FROM ".LIN_PREFIX."meta_exif " .
					"WHERE datetimeoriginal LIKE '".LinSql::linAddslashes($search_string).":".$i."%'");
			if($data[0]>0)
			{
				if(isset($_GET['day']) && $i == $_GET['day'])
				{
					$str_datelinks .= $i.' ('.$data[0].'), ';
				}
				else
				{
					$str_datelinks .= '<a href="'.$url_base.'&amp;year='.$_GET['year'].'&amp;month='.$_GET['month'].'&amp;day='.$i.'">'.$i.'</a> ('.$data[0].'), ';
				}
			}
		}
	}

/**
 * day
 */
	if(isset($_GET['day']))
	{
		$str_navigation .= '<a href="'.$url_base.'&amp;year='.$_GET['year'].'&amp;month='.$_GET['month'].'&amp;day='.$_GET['day'].'">'.$_GET['day'].'</a> &gt; ';
		$search_string = $_GET['year'].':'.$_GET['month'].':'.$_GET['day'];
	}

/**
 * not indexed
 * must be before filename
 */
	if(isset($_GET['year']) && $_GET['year']==0)
	{
		$str_navigation .= '<a href="'.$url_base.'&amp;year=0">'.i18n("not indexed").'</a> &gt; ';
	}

/**
 * filename
 */
	if($linpha->template->idCurrent != 0)
	{
		$str_navigation .= '<a href="'.$linpha->template->URL_base.'&amp;linId='.$linpha->template->idCurrent.'">'
				.$linpha->imgview->filename.'</a>';
	}

/**
 * write navigation and date links
 */
	$linpha->template->output['title'] = $str_navigation;
	$linpha->template->output['navigation'] = $str_datelinks;

/**
 * get photos
 */
	/**
	 * not indexed
	 */
	if(isset($_GET['year']) && $_GET['year']==0)
	{
		
		$linpha->imgview->photos = $linpha->db->GetAssoc("SELECT ".LIN_SELECT_FIELDS." ".
			"FROM ".LIN_PREFIX."photos " .
			"LEFT OUTER JOIN ".LIN_PREFIX."meta_exif " .
			"ON ".LIN_PREFIX."photos.md5sum = ".LIN_PREFIX."meta_exif.md5sum " .
			"WHERE ".LIN_PREFIX."meta_exif.datetimeoriginal is NULL " .
			"AND img_type <> '0' " .
			"AND img_type <> '9999999' " .
			"ORDER BY ".$linpha->imgview->orderby);
	}
	else
	{
		$linpha->imgview->photos = $linpha->db->GetAssoc("SELECT ".LIN_SELECT_FIELDS." ".
			"FROM ".LIN_PREFIX."photos, ".LIN_PREFIX."meta_exif " .
			"WHERE ".LIN_PREFIX."photos.md5sum = ".LIN_PREFIX."meta_exif.md5sum " .
			"AND img_type <> '0' " .
			"AND img_type <> '9999999' " .
			"AND ".LIN_PREFIX."meta_exif.datetimeoriginal LIKE '".$search_string."%' " .
			"ORDER BY ".$linpha->imgview->orderby);
	}


$linpha->imgview->buildImgView();
?>