<?php
/*
 * Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
 *                    Florian Angehrn 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * Video
 * @package Modules
 * @todo  use unified error messages
 */
if(!defined('LINPHA_DIR')) { exit(1); }

if( $linpha->template->idCurrent == 0 )
{
	echo i18n("No valid id supplied!");
	exit(1);
} 

$fullfilename = LinSql::getFullImagePath($linpha->template->idCurrent);

/**
 * check for valid filename
 */
if( $fullfilename === FALSE OR !file_exists($fullfilename) )
{
	echo i18n("No valid id supplied!");
	exit(1);
}

/**
 * get file informations
 */
$data = $GLOBALS['linpha']->db->GetRow("SELECT md5sum, img_type, width, height FROM ".LIN_PREFIX."photos " .
		"WHERE id = '".LinSql::linAddslashes($linpha->template->idCurrent)."'");

$md5sum = $data['md5sum'];
$img_type = $data['img_type'];
$filename = basename($fullfilename);

/**
 * check photos permissions
 */
if( !LinSql::photoIsAllowed( $linpha->template->idCurrent, 'read' ) )
{
	echo i18n("No permission!");
	linLog(LOG_TYPE_BASKET, LOG_ERR, 'accessdenied', 'No permission to access the file '.$linpha->template->idCurrent);
	exit(1);
}

if(isset($_GET['lower'])) {
	$width = $_GET['width'];
	$height = $_GET['height'];
	
	$param = '';
} else {
	$width = $data['width'];
	$height = $data['height'];

	$param = '&fullsize=1';
}

$param .= '&width='.$width.'&height='.$height;

$lower_width = round($width/2);
$lower_height = round($height/2);


ob_start();
?>

<div align='center'>
<h2><?php echo i18n("Panorama view of").' '.$filename; ?></h2>
<font color='FF0000'><?php echo i18n("Please use mouse or arrow keys to navigate!"); ?></font><br />
<applet name='ptviewer' archive='<?php echo LINPHA_CLIENT; ?>/lib/js/ptviewer.jar' code='ptviewer.class' width='100%' height='50%' mayscript='true'>
<script language='JavaScript' type='text/javascript'>
<?php /* hint from the author of ptviewer */ ?>
if (navigator.appName != 'Netscape') document.writeln("<PARAM name=maxarray value='40000000'>");
</script>

<param name='file'	value='<?php
	/**
	* use file_download.php because we don't have direct access to the albums dir anymore (.htaccess)
	*/
	echo LINPHA_CLIENT.'/get_image.php?linId='.$linpha->template->idCurrent.$param;
?>'>
<param name='bgcolor'	value='000080'>
<param name='pan'		value='0'>
<param name='tilt'		value='0'>
<param name='fov'		value='90'>
<param name='fovmax'	value='120'>
<param name='fovmin'	value='20'>
<param name='auto'		value='0.5'>
</applet>
<br />
<a href='http://www.fh-furtwangen.de/~dersch/' target='_blank'>Powered by PTViewer</a>
<br /><br />
<?php
echo i18n("If it takes too long to load, try a lower resolution:").' ';
echo '<a href="'.LINPHA_LINK.'linCat=panorama&amp;linId='.$linpha->template->idCurrent.'&lower=1&width='.$lower_width.'&height='.$lower_height.'">';
echo '['.$lower_width.'x'.$lower_height.']';
echo '</a><br />';
echo '('.i18n("Current resolution:").' ['.$width.'x'.$height.'])';
?>
<br /><br />
<a href='javascript:window.close()'><?php echo i18n("Close window"); ?></a>
</div>

<?php
$linpha->template->output['default'] = ob_get_clean();

$linpha->template->setModuleName('default');
//$linpha->template->overrideModule('css','filemanager');
$linpha->template->URL_full = LINPHA_LINK.'&amp;linCat=panorama&amp;linId='.$linpha->template->idCurrent;
$linpha->template->hideMenu = true;
$linpha->template->hideTitle = true;
$linpha->template->output['title'] = i18n("Panorama");
include_once(LINPHA_DIR.'/templates/'.$linpha->template->template_name.'/global.html.php');

?>