<?php
/*
 * Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
 *                    Florian Angehrn 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * Albums view related methods and functions
 * @package Modules
 */
if(!defined('LINPHA_DIR')) { exit(1); }


/**
* call from exif href in img_view
*/
if(isset($_REQUEST['sk'])) {
	$_REQUEST['date_from']=$_REQUEST['sk']; 
	$_REQUEST['date_to']=$_REQUEST['sk']; 
	$_REQUEST['album_select'] = Array('all'=>'all');
	$_REQUEST['cmd'] = 'search';
}

if(isset($_REQUEST['cmd']))
{
	switch($_REQUEST['cmd'])
	{
	case 'search':
		/**
		* search string to short
		*/
		if( !empty($_REQUEST['search_text']) && strlen($_REQUEST['search_text']) < 2 )
		{
			$error = 1;
		}
		/**
		* check for valid input
		* @todo
		*/
		elseif((!empty($_REQUEST['search_text']) && strlen($_REQUEST['search_text'])>=2) OR
			isset($_REQUEST['category']) OR
			(!empty($_REQUEST['date_from']) OR !empty($_REQUEST['date_to'])) OR true)
		{
			/**
			* save search string in session
			*/
			$_SESSION['search'] = $_REQUEST;
		}
		else
		{
			$error = 2;
		}

	break;
	case 'new':
		unset($_SESSION['search']);
        $_REQUEST['button']['meta']['all'] = 1;
	break;
	case 'edit':
		if(isset($_SESSION['search']))
		{
			/**
			 * copy session to request
			 */
			foreach($_SESSION['search'] AS $key=>$value)
			{
				$_REQUEST[$key] = $value;
			}
			unset($_SESSION['search']);
		}
	break;
	}
}
elseif(!isset($_SESSION['search']))
{
	$_REQUEST['button']['meta']['all'] = 1;
}

if(isset($_SESSION['search']))
{
/**
 * init
 */
	include_once(LINPHA_DIR . '/lib/classes/linpha.imgview.class.php');
	$linpha->imgview = new linImgview();
	$linpha->imgview->setCurrentView('search');
	$linpha->template->URL_base = LINPHA_LINK.'&amp;linCat=search';
	$linpha->template->URL_full = LINPHA_LINK.'&amp;linCat=search&amp;linId='.$linpha->template->idCurrent; 
	$linpha->template->output['title'] = i18n("Search");


/**
* create sql search query
*/
	/**
	 * copy session to request
	 */
	foreach($_SESSION['search'] AS $key=>$value)
	{
		$_REQUEST[$key] = $value;
	}

	/**
	* buttons
	*/

	$sql_buttons = '';
	if(!empty($_REQUEST['search_text']))
	{
	/**
	 * Split textfield into particular words
	 */

		/**
		* replace \" with {quotes} to be sure the \" isn't handled as delimiter
		* later it will be replaced back
		* 
		*     * my cat ==> returns all results for my AND/OR cat
      				e.g. my house, my cat, cute cat...
			  * "my cat" ==> returns all results for my cat
      				e.g. this is my cat, but not a cute cat, this is my house..."
    		  * \"my cat\" ==> returns all results for "my cat"
  					e.g. this is "my cat" smilla, but not this is my cat smilla...
		* 
		*/
		$_REQUEST['search_text'] = str_replace('\"','{quotes}',$_REQUEST['search_text']);

		/**
		* extract strings with '"blal asdf"' into 'blal asdf'
		*/
		$array_strings = Array();
		while( ($pos1 = strpos($_REQUEST['search_text'],'"')) !== false)
		{
			/**
			* no ending " found, take the whole string after $pos1
			*/
			if( ($pos2 = strpos(substr($_REQUEST['search_text'],$pos1+1),'"')) === false)
			{
				$substr = substr($_REQUEST['search_text'],$pos1);
			}
			else
			{
				$substr = substr($_REQUEST['search_text'],$pos1,$pos2+2);
			}
			
			/**
			* delete this entry in the search string to be sure the next time we get the next entry
			*/
			$_REQUEST['search_text'] = str_replace($substr,'',$_REQUEST['search_text']);
			
			/**
			* add the string to the array (without starting and ending '"')
			*/
			$array_strings[] = substr($substr,1,strlen($substr)-2);
		}
		
		/**
		* extract normal strings with 'blaab asd' into 'blals' and 'asd'
		*/
		$array_strings = array_merge($array_strings,explode(" ", $_REQUEST['search_text']));
	
		/**
		* remove empty strings and add slashes
		*/
		foreach($array_strings AS $key=>$value)
		{
			if(empty($value)) {
				unset($array_strings[$key]);
			} else {
				$array_strings[$key] = LinSql::linAddslashes($value);
			}
		}


		/**
		 * get text fields
		 */
		$sql_buttons = "(1=2";

		if( !isset($_REQUEST['text_and_or']) OR $_REQUEST['text_and_or'] == "AND") {
			$and_or = "AND";
		} else {
			$and_or = "OR";
		}

		$query = $GLOBALS['linpha']->db->Execute("SELECT id FROM ".LIN_PREFIX."meta_fields WHERE field_type = '1' AND (flags = '5' OR flags = '7')");
		while($data = $query->FetchRow(ADODB_FETCH_NUM))
		{
			if(isset($_REQUEST['button']['meta'][$data[0]]) OR isset($_REQUEST['button']['meta']['all']))
			{
				$sql_buttons .= " OR (";
				
				$num = count($array_strings);
				reset($array_strings);
				for($i = 1; list($key,$value) = each($array_strings); $i++)
				{
					$sql_buttons .= " (".LIN_PREFIX."meta_data.field_id = '".$data[0]."' AND ".LIN_PREFIX."meta_data.meta_data LIKE '%".$value."%') ";
					
					/**
					 * append AND/OR, but not on last item
					 */
					if($i < $num)
					{
						$sql_buttons .= $and_or;
					}
				}
				
				$sql_buttons .= ")";

				$need_metadata_table = true;
			}
		}

		/**
		* build search string
		*/
		$search_string = "{colname} LIKE '%";
		$search_string .= implode("%' ".$and_or." {colname} LIKE '%",$array_strings);
		$search_string .= "%'";
		
		if(isset($_REQUEST['button']['meta']['cmt']) OR isset($_REQUEST['button']['meta']['all']))
		{
			$sql_buttons .= " OR ".str_replace('{colname}',LIN_PREFIX."meta_comments.meta_comment",$search_string);
			$need_meta_comment_table = true;
		}
		if(isset($_REQUEST['button']['meta']['name']) OR isset($_REQUEST['button']['meta']['all']))
		{
			$sql_buttons .= " OR ".str_replace('{colname}',LIN_PREFIX."photos.name",$search_string);
		}

        /**
         * exif/iptc/xmp
         */
			include_once(LINPHA_DIR.'/lib/classes/linpha.metadata.class.php');
			$MetaData = new LinMetaData();

			/**
			 * exif
			 */
			if($GLOBALS['linpha']->sql->config->value['sys_image_exif'])
	        {
				$MetaData->setFields('exif');
				foreach($MetaData->defined_fields['exif'] AS $key=>$value)
	            {
	                if(isset($_REQUEST['button']['exif'][$key]) OR isset($_REQUEST['button']['exif']['all']))
	                {
	                    $sql_buttons .= " OR ".str_replace('{colname}',LIN_PREFIX."meta_exif.".$key,$search_string);
	                    $need_exif_table = true;
	                }
	            }
	        }
	
	        /**
	         * iptc
	         */
			if($GLOBALS['linpha']->sql->config->value['sys_image_iptc'])
	        {
				$MetaData->setFields('iptc');
				foreach($MetaData->defined_fields['iptc'] AS $key=>$value)
	            {
	                if(isset($_REQUEST['button']['iptc'][$key]) OR isset($_REQUEST['button']['iptc']['all']))
	                {
	                    $sql_buttons .= " OR ".str_replace('{colname}',LIN_PREFIX."meta_iptc.".$key,$search_string);
	                    $need_iptc_table = true;
	                }
	            }
	        }

	        /**
	         * xmp
	         */
			if($GLOBALS['linpha']->sql->config->value['sys_image_xmp'])
	        {
				$MetaData->setFields('xmp');
				foreach($MetaData->defined_fields['xmp'] AS $key=>$value)
	            {
	                if(isset($_REQUEST['button']['xmp'][$key]) OR isset($_REQUEST['button']['xmp']['all']))
	                {
	                    $sql_buttons .= " OR ".str_replace('{colname}',LIN_PREFIX."meta_xmp.".$key,$search_string);
	                    $need_xmp_table = true;
	                }
	            }
	        }

		$sql_buttons .= ") AND ";
	}
	//echo $sql_buttons.'<br />';


	/**
	* categories
	*/
	$sql_categories = '';
	if(isset($_REQUEST['select']))
	{
		foreach($_REQUEST['select'] AS $key=>$value)
		{
			$sql_categories .= " (";

			/**
			* add slashes ( and remove empty strings)
			*/
	        $value = LinSql::linAddslashesArray($value);

			if( !isset($_REQUEST['select_and_or'][$key]) OR $_REQUEST['select_and_or'][$key] == "AND") {
				$and_or = "AND";
			} else {
				$and_or = "OR";
			}

			$num = count($value);
			reset($value);
			for($i = 1; list($sub_key,$sub_value) = each($value); $i++)
			{
				$sql_categories .= " (".LIN_PREFIX."meta_data.field_id = '".$key."' AND ".LIN_PREFIX."meta_data.meta_data LIKE '%;".$sub_value.";%') ";
				
				/**
				 * append AND/OR, but not on last item
				 */
				if($i < $num)
				{
					$sql_categories .= $and_or;
				}
			}
			$need_metadata_table = true;

			$sql_categories .= " ) AND ";
		}
	}
	
	//echo $sql_categories.'<br />';


	/**
	 * date (exif)
	 */
	$sql_exif_date = '';
	if( (isset($_REQUEST['date_from_exif']) && !empty($_REQUEST['date_from_exif']) )
		OR (isset($_REQUEST['date_to_exif']) && !empty($_REQUEST['date_to_exif']) ) )
	{
		if( !isset($_REQUEST['date_from_exif']) OR empty($_REQUEST['date_from_exif']) ) {
			$_REQUEST['date_from_exif'] = "0000:00:00 00:00:00";
		}
		if( !isset($_REQUEST['date_to_exif']) OR empty($_REQUEST['date_to_exif']) ) {
			$_REQUEST['date_to_exif'] = "4000:00:00 00:00:00";
		}
	
		$sql_exif_date = "(".LIN_PREFIX."meta_exif.datetimeoriginal BETWEEN ".
			"'".LinSql::linAddslashes($_REQUEST['date_from_exif'])." 00:00:00' AND ".
			"'".LinSql::linAddslashes($_REQUEST['date_to_exif'])." 23:59:59') AND ";
		
		$need_exif_table = true;
	}
	
	//echo $sql_exif_date.'<br />';
	
	$sql_date = '';
	if(isset($_REQUEST['date_from']))
	{
		foreach($_REQUEST['date_from'] AS $key=>$value)
		{

			if( (isset($_REQUEST['date_from'][$key]) && !empty($_REQUEST['date_from'][$key]) )
				OR (isset($_REQUEST['date_to'][$key]) && !empty($_REQUEST['date_to'][$key]) ) )
			{
				if( !isset($_REQUEST['date_from'][$key]) OR empty($_REQUEST['date_from'][$key]) ) {
					$_REQUEST['date_from'][$key] = "0000:00:00 00:00:00";
				}
				if( !isset($_REQUEST['date_to'][$key]) OR empty($_REQUEST['date_to'][$key]) ) {
					$_REQUEST['date_to'][$key] = "4000:00:00 00:00:00";
				}

				$sql_date .= "(".LIN_PREFIX."meta_exif.datetimeoriginal BETWEEN ".
					"'".LinSql::linAddslashes($_REQUEST['date_from'][$key])." 00:00:00' AND ".
					"'".LinSql::linAddslashes($_REQUEST['date_to'][$key])." 23:59:59') AND ";
				
				$need_exif_table = true;
			}
		}
	}
	
	//echo $sql_date.'<br />';
	
	
	/**
	* albums selected
	*/
	$sql_albums = "";
	if( isset($_REQUEST['album_select']) && !in_array('all',$_REQUEST['album_select']) )
	{
		/**
		* create an array which holds the addslashed ids
		*/
		foreach($_REQUEST['album_select'] AS $value)
		{
			$array_paths[] = LinSql::linAddslashes($value);
		}

		$sql_albums .= "(".LIN_PREFIX."photos.parent_id = '";
		$sql_albums .= implode("' OR ".LIN_PREFIX."photos.parent_id = '",$array_paths);
		$sql_albums .= "'";
		$sql_albums .= ") AND ";
	}
	
	//echo $sql_albums.'<br />';

	
	/**
	* set sql query string
    *DISTINCT
	*/
	$sql_begin = "SELECT ".LIN_SELECT_FIELDS." ";


	$sql_where = " FROM ".LIN_PREFIX."photos ".
        (isset($need_metadata_table) ? "LEFT OUTER JOIN ".LIN_PREFIX."meta_data ON ".LIN_PREFIX."photos.md5sum = ".LIN_PREFIX."meta_data.md5sum " : '').
        (isset($need_meta_comment_table) ? "LEFT OUTER JOIN ".LIN_PREFIX."meta_comments ON ".LIN_PREFIX."photos.md5sum = ".LIN_PREFIX."meta_comments.md5sum " : '').
        (isset($need_exif_table) ? "LEFT OUTER JOIN ".LIN_PREFIX."meta_exif ON ".LIN_PREFIX."photos.md5sum = ".LIN_PREFIX."meta_exif.md5sum " : '').
        (isset($need_iptc_table) ? "LEFT OUTER JOIN ".LIN_PREFIX."meta_iptc ON ".LIN_PREFIX."photos.md5sum = ".LIN_PREFIX."meta_iptc.md5sum " : '').
        "WHERE ".$sql_buttons.$sql_categories.$sql_exif_date.$sql_albums.'1=1';
	
    $linpha->imgview->photos = $GLOBALS['linpha']->db->GetAssoc($sql_begin.$sql_where);

	if( count($linpha->imgview->photos) == 0 )
    {
        $GLOBALS['linpha']->template->output['navigation'] = 
        	'<b>'.i18n("Sorry, Your search did not match any content").'</b><br />';
    }
    else
    {
    	$GLOBALS['linpha']->template->output['navigation'] = '';
    }
    $GLOBALS['linpha']->template->output['navigation'] .=
			'<a class="button" href="'.LINPHA_LINK.'&amp;linCat=search&amp;cmd=new">'.
			i18n("New Search").'</a>&nbsp;&nbsp;'.
        	'<a class="button" href="'.LINPHA_LINK.'&amp;linCat=search&amp;cmd=edit">'.
        	i18n("Edit Search").'</a>';

	$linpha->imgview->buildImgView();
}
else
{
	$linpha->template->setModuleName('search');
	$linpha->template->URL_full = LINPHA_LINK.'&amp;linCat=search';
	$linpha->template->output['title'] = i18n("Search");
	include_once(LINPHA_DIR.'/templates/'.$GLOBALS['linpha']->template->template_name.'/global.html.php');
}

?>