<?php
/*
* Copyright (c) 2004 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

if(!defined('TOP_DIR')) { define('TOP_DIR','../../'); }
 
/**
* Class to parse Garmin GPX files and return values for
* latitiude, longitude, elevation, time and more. Makes use of libxml
* to read XML data -> requires php >= 4.2.0!
*
* @author bzrudi
*/
class GpxParser
{
	
var $xmldata; //protected
var $parsedata; //protected
var $filename; //protected

/**
 * Constructor
 */
function GpxParser($filename)
{
	include_once(TOP_DIR.'/plugins/maps/libxml/IsterXmlSimpleXMLImpl.php');
	$xmlreader = new IsterXmlSimpleXMLImpl;
	$this->xmldata = $xmlreader->load_file($filename);
	$this->filename = $filename; 
}

/**
 * This method checks whether file contains waypoints (wpt) or trackpoints 
 * (trkpt) or even routepoints (rtp) and takes good care of 
 * how we handle them.
 * 
 * @param none
 * @return array returns only XmlData and filetype
 * @author bzrudi
 */
function getGpxFileType()
{
	$this->parsedata = file_get_contents($this->filename);

	if(strpos($this->parsedata, 'trkpt'))
	{
		echo "TRACKFILE DETECTED";
		return array($this->xmldata, 'trkpt');
	}
	elseif(strpos($this->parsedata, 'rtept'))
	{
		echo "ROUTEFILE DETECTED";
		return array($this->xmldata, 'rtept');
	}
	elseif(strpos($this->parsedata, 'wpt'))
	{
		echo "WAYFILE DETECTED";
		return array($this->xmldata, 'wpt');
	}	
	else
	{
		echo "CANNOT DETECT INPUT FILE FORMAT";
		return array('dummy', 'failed');
	}
}

} // end class
?>

