<?php
/*
* Copyright (c) 2005 Heiko Rutenbeck <bzrudi@tuxpower.de>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/**
 * Main file to build all page content.
 * This file takes care of all files to include and to setup the pages.  
 */

if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','../../..'); }

try
{
	if(!defined('LINPHA2_INC')) { die("ERROR: Direct access forbidden."); }
	
	if(include_once(LINPHA_DIR.'/lib/classes/linpha.template_old.class.php'))
	{
		/**
		 * Create new instance of class Template
		 * @param string template name
		 */
		$objTemplate = new Template("default_old");
	}
	else
	{
		throw new Exception("ERROR: failed to include " .
			"</lib/classes/linpha.template.class.php> " .
			"<br>LOCATION: main.php");
	}

/**
 * Main Site starts here!
 * First let's setup standard XHTML header taking care of language, charset
 * and title.
 */

$objTemplate -> linXhtmlHeader(); 

require_once(LINPHA_DIR.'/templates/default_old/index.php');

} // end try

/**
 * Error handling, catch exceptions
 * Catch all page exceptions
 */
catch(Exception $error)
{
	echo $error -> getMessage();
}
?>

