<?php
if(!defined('LINPHA_DIR')) { define('LINPHA_DIR','../..'); }

include_once( LINPHA_DIR.'/lib/plugins/watermark/func.watermark.php' );

if(!isset($_GET['color']))
{
	$_GET['color'] = 'orange';
}

if(!isset($_GET['bgcolor']))
{
	$_GET['bgcolor'] = 'white';
}

if(!isset($_GET['align']))
{
	$_GET['align'] = 'tl';
}

if(!isset($_GET['size']))
{
	$size = 15;
}
else
{
	$size = $_GET['size'];
}

switch($_GET['align'])
{
case 'tl': $cx = $size;	$cy = $size;	$workaround = 0; break;
case 'tr': $cx = -1;	$cy = $size;	$workaround = 0; break;
case 'bl': $cx = $size;	$cy = 0;		$workaround = 1; break;
case 'br': $cx = -1;	$cy = -1;		$workaround = 1; break;
}

// create image
$image = imagecreatetruecolor($size, $size);

// create colors
$rgb = LinWatermark::getRgbFromAll($_GET['color']);
$color = imagecolorallocate($image, $rgb['r'], $rgb['g'], $rgb['b']);

if(isset($_GET['alpha']))
{
	imageAlphaBlending($image, false);
	imageSaveAlpha($image, true);
	$bgcolor = imagecolorallocatealpha($image, 0, 0, 0, 127);
}
else
{
	$rgb = LinWatermark::getRgbFromAll($_GET['bgcolor']);
	$bgcolor = imagecolorallocate($image, $rgb['r'], $rgb['g'], $rgb['b']);
}

// fill image with background color
imagefill($image, 0, 0, $bgcolor);


// draw circly
imagefilledellipse($image, $cx, $cy, ($size*2), ($size*2), $color);

// workaround
if($workaround)
{
	imageline($image, 0, 0, $size-1, 0, $color );
}

// flush image
Header('Content-type: image/png');

/**
 * force caching in browser
 * works in firefox and internet explorer
 */
Header("Last-Modified: " . gmdate("D, d M Y H:i:s",mktime (0,0,0,1,1,2000)) . " GMT");  // Date in the past
Header("Expires: Mon, 26 Jul 2100 05:00:00 GMT");    // In other words... never expire the image
Header("Cache-Control: max-age=10000000, s-maxage=1000000, proxy-revalidate, must-revalidate");



imagepng($image);
imagedestroy($image);


?>